unit UAdvancedSend;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, RXSpin, ExtCtrls, RzSplit, ComCtrls, EnhListView,
  RzPanel, RzDlgBtn, UTypes, ExtListView, Mask, RzEdit, RzSpnEdt, ActnList;

type
  TfrmAdvancedSend = class(TForm)
    RzDialogButtons1: TRzDialogButtons;
    RzSizePanel1: TRzSizePanel;
    PageControl1: TPageControl;
    tshGroupToPlanet: TTabSheet;
    tshSelectGroupForPlanet: TTabSheet;
    RzSplitter1: TRzSplitter;
    RzSplitter2: TRzSplitter;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    btnAddGroupsToPlanet: TButton;
    Panel6: TPanel;
    btnAddGroupToPlanets: TButton;
    Panel7: TPanel;
    pmuResults: TPopupMenu;
    lvGroups1: TdfsExtListView;
    lvPlanets1: TdfsExtListView;
    edtSendShipsToPlanets: TRzSpinEdit;
    ActionList1: TActionList;
    ActAddGroupToPlanets: TAction;
    ActResultDeleteGroups: TAction;
    lvResults: TdfsExtListView;
    mniResultsDelete: TMenuItem;
    RzSizePanel2: TRzSizePanel;
    Notebook1: TNotebook;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lblPT_Name: TLabel;
    lblPT_Owner: TLabel;
    lblPT_Population: TLabel;
    lblPT_Industry: TLabel;
    lblPT_Prod: TLabel;
    lblPT_CAP: TLabel;
    lblPT_MAT: TLabel;
    lblPT_COL: TLabel;
    Label18: TLabel;
    lblPT_MaxShip: TLabel;
    lblPT_Size: TLabel;
    Label10: TLabel;
    lblPT_Resources: TLabel;
    lvMyGroupsHover: TdfsExtListView;
    lvOtherGroupsHover: TdfsExtListView;
    RadioGroup1: TRadioGroup;
    Label11: TLabel;
    lblIntercept: TLabel;
    Label12: TLabel;
    lblPT_ProdType: TLabel;
    PopupMenu1: TPopupMenu;
    Add1: TMenuItem;
    N1: TMenuItem;
    PlanetInfo1: TMenuItem;
    MyGroups1: TMenuItem;
    OtherGroups1: TMenuItem;
    cbxRemovePlanetFromListAfterAdd: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure lvGroups1Click(Sender: TObject);
    procedure ActAddGroupToPlanetsUpdate(Sender: TObject);
    procedure ActAddGroupToPlanetsExecute(Sender: TObject);
    procedure ActResultDeleteGroupsUpdate(Sender: TObject);
    procedure ActResultDeleteGroupsExecute(Sender: TObject);
    procedure RzDialogButtons1ClickOk(Sender: TObject);
    procedure lvPlanets1HotTrack(Sender: TObject; var ItemIndex: Integer;
      SubItemIndex: Integer; Location: TPoint; var AllowSelect: Boolean);
    procedure RadioGroup1Click(Sender: TObject);
    procedure lvResultsHotTrack(Sender: TObject; var ItemIndex: Integer;
      SubItemIndex: Integer; Location: TPoint; var AllowSelect: Boolean);
    procedure PlanetInfo1Click(Sender: TObject);
    procedure MyGroups1Click(Sender: TObject);
    procedure OtherGroups1Click(Sender: TObject);
  private
    FSelectedPlanets: TStringList;
    FSelectedGroups: TStringList;
    FCommandString: string;
    FDoIntercept: boolean;
    procedure AddGroup(listviewItems: TListItems; index: integer);
    procedure AddPlanet(listviewItems: TListItems; index: integer);
    procedure SetCommandString(const Value: string);
    procedure BuildGroupsLists;
    procedure BuildPlanetsLists;
    { Private declarations }
  protected
    procedure DoPlanetHover(planet: TPlanet);
    procedure DoMyGroupsHover(planet: TPlanet);
    procedure DoOtherGroupsHover(planet: TPlanet);
  public
    property CommandString: string read FCommandString write SetCommandString;
    property DoIntercept: boolean read FDoIntercept write FDoIntercept;
    property SelectedPlanets: TStringList read FSelectedPlanets write FSelectedPlanets;
    property SelectedGroups: TStringList read FSelectedGroups write FSelectedGroups;
    { Public declarations }
  end;

implementation

{$R *.DFM}

uses
  mkStrUtils, UfrmOrders, UFiles;

{ TfrmAdvancedSend }

procedure TfrmAdvancedSend.SetCommandString(const Value: string);
begin
  FCommandString := Value;
end;

procedure TfrmAdvancedSend.FormShow(Sender: TObject);
begin
  BuildGroupsLists;
  BuildPlanetsLists;
  if lvPlanets1.Items.Count > 0 then
    DoPlanetHover(TPlanet(lvPlanets1.Items[0].Data));
  if FDoIntercept then lblIntercept.Caption := 'Creating Intercept Orders'
  else lblIntercept.Caption := 'Creating Send Orders';
end;

procedure TfrmAdvancedSend.BuildGroupsLists;
var
  i: integer;
begin
  lvGroups1.BeginUpdate;
  try
    lvGroups1.Items.Clear;
    for i := 0 to FSelectedGroups.Count - 1 do begin
      AddGroup(lvGroups1.Items, i);
    end;
  finally
    lvGroups1.EndUpdate;
  end;
end;

procedure TfrmAdvancedSend.BuildPlanetsLists;
var
  i: integer;
begin
  lvPlanets1.BeginUpdate;
  try
    lvPlanets1.Items.Clear;
    for i := 0 to FSelectedPlanets.Count - 1 do begin
      AddPlanet(lvPlanets1.Items, i);
    end;
  finally
    lvPlanets1.EndUpdate;
  end;
end;

procedure TfrmAdvancedSend.AddGroup(listviewItems: TListItems;
  index: integer);
var
  group: TGroup;
  listItem: TListItem;
  intMaxSend: integer;
begin
  if not Assigned(FSelectedGroups.Objects[index]) then exit;
  group := TGroup(FSelectedGroups.Objects[index]);
  intMaxSend := GetMaxToSend(group);
  if intMaxSend > 0 then begin
    listItem := listviewItems.Add;
    listItem.Caption := mkItoA(group.nr);
    listItem.Data := group;
    listItem.SubItems.AddObject(Format('%d', [intMaxSend]), TObject(group.aantal));
    listItem.SubItems.Add(group._Type.Name);
    listItem.SubItems.Add(Format('%5.2f', [group.EffSpeed]));
    listItem.SubItems.Add(Format('%d', [group._Type.Attacks]));
    listItem.SubItems.Add(Format('%5.2f', [group.EffWeapon]));
    listItem.SubItems.Add(Format('%5.2f', [group.EffShield]));
  end;
end;

procedure TfrmAdvancedSend.AddPlanet(listviewItems: TListItems;
  index: integer);
var
  planet: TPlanet;
  listItem: TListItem;
begin
  if not Assigned(FSelectedPlanets.Objects[index]) then exit;
  planet := TPlanet(FSelectedPlanets.Objects[index]);
  listItem := listviewItems.Add;
  listItem.Caption := planet.Name;
  listItem.Data := planet;
  listItem.SubItems.Add(planet.LastOwnerName);
  listItem.SubItems.Add('-');
  listItem.SubItems.Add(Format('%5.2f', [planet.MyShipMass]));
  listItem.SubItems.Add(Format('%5.2f', [planet.FriendShipMass]));
  listItem.SubItems.Add(Format('%5.2f', [planet.EnemyShipMass]));
  listItem.SubItems.Add(Format('%5.2f', [planet.SendedShipMass]));
end;

procedure TfrmAdvancedSend.lvGroups1Click(Sender: TObject);
var
  orgPlanet, planet: TPlanet;
  x0, y0: integer;
  i: integer;
  dist: single;
  group: TGroup;
  dx, dy: Single;
begin
  if Assigned(lvGroups1.Selected) then begin
    lvPlanets1.BeginUpdate;
    try
      group := TGroup(lvGroups1.Selected.Data);
      orgPlanet := group.Planet;
      x0 := orgPlanet.X;
      y0 := orgPlanet.Y;
      for i := 0 to lvPlanets1.Items.Count - 1 do begin
        planet := TPlanet(lvPlanets1.Items[i].Data);
        dx := x0 - planet.X;
        dy := y0 - planet.Y;
        dist := sqrt(dx * dx + dy * dy) / 100;

        lvPlanets1.Items[i].SubItems[1] := mkItoA(trunc(dist / group.effSpeed) + 1);
      end;
      lvPlanets1.Resort;
    finally
      lvPlanets1.EndUpdate;
    end;
  end;
end;

procedure TfrmAdvancedSend.ActAddGroupToPlanetsUpdate(Sender: TObject);
begin
  with TAction(Sender) do begin
    Enabled := (lvGroups1.SelCount = 1) and (lvPlanets1.SelCount > 0);
  end;
end;

procedure TfrmAdvancedSend.ActAddGroupToPlanetsExecute(Sender: TObject);
var
  intMaxShips, intSendShips: integer;
  index: integer;
  listItem: TListItem;
  strGroup, strShipType, strAmount: string;
  grIndex: integer;
  ptIndex: integer;
begin
  lvGroups1.BeginUpdate;
  lvPlanets1.BeginUpdate;
  try
    intMaxShips := mkAtoI(lvGroups1.Selected.SubItems[0]);
    intSendShips := mkAtoI(edtSendShipsToPlanets.Text);
    strGroup := lvGroups1.Selected.Caption;
    strShipType := lvGroups1.Selected.SubItems[1];
    strAmount := edtSendShipsToPlanets.Text;
    if intMaxShips < 1 then Exit;
    index := 0;
    ptIndex := 0;
    while (intMaxShips >= intSendShips) and (index < lvPlanets1.Items.Count) do begin
      if lvPlanets1.Items[index].Selected then begin
        listItem := lvResults.Items.Add;
        listItem.Caption := strGroup;
        listItem.Data := lvPlanets1.Items[index].Data;
        listItem.subItems.Add(strShipType);
        listItem.subItems.Add(lvPlanets1.Items[index].Caption);
        listItem.subItems.Add(strAmount);
        listItem.subItems.Add(lvPlanets1.Items[index].SubItems[1]);
        ptIndex := index;
        if cbxRemovePlanetFromListAfterAdd.Checked then
          lvPlanets1.Items.Delete(index)
        else
          inc(index);
        dec(intMaxShips, intSendShips);
      end else inc(index);
    end;
    if intMaxShips > 0 then
      lvGroups1.Selected.SubItems[0] := mkItoA(intMaxShips)
    else begin
      grIndex := lvGroups1.Selected.Index;
      lvGroups1.Items.Delete(grIndex);
      if lvGroups1.Items.Count > grIndex then begin
        lvGroups1.Selected := lvGroups1.Items[grIndex];
        lvGroups1Click(Sender);
      end;
    end;
    if lvPLanets1.Items.Count > ptIndex then
      lvPlanets1.Selected := lvPlanets1.Items[ptIndex]
    else
      if lvPLanets1.Items.Count > 0 then
        lvPlanets1.Selected := lvPlanets1.Items[0];
    if Assigned(lvPlanets1.Selected) then begin
      DoPlanetHover(TPlanet(lvPlanets1.Selected.Data));
      DoMyGroupsHover(TPlanet(lvPlanets1.Selected.Data));
      DoOtherGroupsHover(TPlanet(lvPlanets1.Selected.Data));
    end;
  finally
    lvGroups1.EndUpdate;
    lvPlanets1.EndUpdate;
  end;
end;

procedure TfrmAdvancedSend.ActResultDeleteGroupsUpdate(Sender: TObject);
begin
  with TAction(Sender) do begin
    Enabled := lvResults.SelCount > 0;
  end;
end;

procedure TfrmAdvancedSend.ActResultDeleteGroupsExecute(Sender: TObject);
var
  i: integer;
  strPlanet, strGroup: string;
  index: integer;
  listItem: TListItem;
begin
  lvResults.BeginUpdate;
  lvGroups1.BeginUpdate;
  lvPlanets1.BeginUpdate;
  try
    i := 0;
    while i < lvResults.Items.Count do begin
      if lvResults.Items[i].Selected then begin
        strGroup := lvResults.Items[i].Caption;
        strPlanet := lvResults.Items[i].SubItems[1];
        index := FSelectedPlanets.IndexOf(strPlanet);
        listItem := lvPlanets1.FindCaption(0, strPlanet, false, true, false);
        if not Assigned(listItem) and (index <> -1) then
          AddPlanet(lvPlanets1.Items, index);
        listItem := lvGroups1.FindCaption(0, strGroup, false, true, false);
        if not Assigned(listItem) then begin
          index := FSelectedGroups.IndexOf(strGroup);
          if index <> -1 then
            AddGroup(lvGroups1.Items, index);
          listItem := lvGroups1.FindCaption(0, strGroup, false, true, false);
        end;
        if Assigned(listItem) then
          listItem.SubItems[0] := mkIToA(mkAtoI(listItem.SubItems[0]) + mkAtoI(lvResults.Items[i].SubItems[2]));
        lvResults.Items.Delete(i);
      end else
        inc(i);
    end;
  finally
    lvResults.EndUpdate;
    lvGroups1.EndUpdate;
    lvPlanets1.EndUpdate;
  end
end;

procedure TfrmAdvancedSend.RzDialogButtons1ClickOk(Sender: TObject);
var
  i: integer;
  intMaxShips, intSendShips: integer;
  intStartIndex: integer;
  listItem: TListItem;
begin
  lvResults.BeginUpdate;
  try
    FCommandString := '';
    for i := 0 to FSelectedGroups.Count - 1 do begin
      intMaxShips := GetMaxToSend(TGroup(FSelectedGroups.Objects[i]));
      intStartIndex := -1;
      repeat
        listItem := lvResults.FindCaption(intStartIndex, FSelectedGroups[i], false, false, false);
        if Assigned(listItem) then begin
          intStartIndex := listItem.index;
          intSendShips := mkAtoI(listItem.SubItems[2]);
          dec(intMaxShips, intSendShips);
          if FCommandString <> '' then
            FCommandString := FCommandString + #13#10;
          if intMaxShips < 1 then begin
            if FDoIntercept then
              FCommandString := FCommandString + 'I ' + listItem.Caption + ' ' + listItem.SubItems[1]
            else
              FCommandString := FCommandString + 'S ' + listItem.Caption + ' ' + listItem.SubItems[1];
            break;
          end else begin
            if FDoIntercept then
              FCommandString := FCommandString + 'I ' + listItem.Caption + ' ' + listItem.SubItems[1] + ' ' + listItem.SubItems[2]
            else
              FCommandString := FCommandString + 'S ' + listItem.Caption + ' ' + listItem.SubItems[1] + ' ' + listItem.SubItems[2];
          end;
        end;
      until not Assigned(listItem);
    end;
  finally
    lvResults.EndUpdate;
  end
end;

procedure TfrmAdvancedSend.lvPlanets1HotTrack(Sender: TObject;
  var ItemIndex: Integer; SubItemIndex: Integer; Location: TPoint;
  var AllowSelect: Boolean);
const
  LastIndex: integer = -1;
var
  planet: TPlanet;
begin
  if (ItemIndex <> -1) and (LastIndex <> ItemIndex) then begin
    planet := TPlanet(lvPlanets1.Items[ItemIndex].Data);
    DoPlanetHover(planet);
    DoMyGroupsHover(planet);
    DoOtherGroupsHover(planet);
    LastIndex := ItemIndex;
  end;
end;

procedure TfrmAdvancedSend.DoPlanetHover(planet: TPlanet);
begin
  lblPT_Name.Caption := planet.Name;
  lblPT_Owner.Caption := planet.LastOwnerName;
  lblPT_Size.Caption := Format('%04.2f', [planet.size]);
  lblPT_Resources.Caption := Format('%04.2f', [planet.Resources]);
  lblPT_Population.Caption := Format('%04.2f', [planet.PopulationCur]);
  lblPT_Industry.Caption := Format('%04.2f', [planet.IndustryCur]);
  lblPT_Prod.Caption := Format('%04.2f', [planet.EffIndustryCur]);
  lblPT_CAP.Caption := Format('%04.2f', [planet.CapitalCur]);
  lblPT_MAT.Caption := Format('%04.2f', [planet.MaterialCur]);
  lblPT_COL.Caption := Format('%04.2f', [planet.ColonistCur]);
  lblPT_MaxShip.Caption := Format('%04.2f', [planet.EffMassProduceCur]);
  lblPT_ProdType.Caption := planet.ProduceType;
end;

procedure TfrmAdvancedSend.DoMyGroupsHover(planet: TPlanet);
var
  i: integer;
  group: TGroup;
  SendedGroup: TSendedGroup;
  listItem: TListItem;
begin
  lvMyGroupsHover.BeginUpdate;
  try
    lvMyGroupsHover.Items.Clear;
    for i := 0 to qReportplayer.Groups.Count - 1 do begin
      group := TGroup(qReportplayer.Groups[i]);
      if (group.Planet = planet) and (group.Turn = LastTurn) and (group.Range = 0) then begin
        listItem := lvMyGroupsHover.Items.Add;
        listItem.Caption := Format('%d', [group.Aantal]);
        listItem.SubItems.Add(group._Type.Name);
        listItem.SubItems.Add(Format('%04.1f', [group.EffSpeed]));
        listItem.SubItems.Add('-');
        listItem.SubItems.Add(Format('%d', [group._Type.Attacks]));
        listItem.SubItems.Add(Format('%04.1f', [group.EffWeapon]));
        listItem.SubItems.Add(Format('%04.1f', [group.EffShield]));
        listItem.SubItems.Add(Format('%04.1f', [group._Type.Mass]));
      end;
    end;
    for i := 0 to SendedGroups.Count - 1 do begin
      SendedGroup := TSendedGroup(SendedGroups.Objects[i]);
      if SendedGroup.sendTo = planet then begin
        listItem := lvMyGroupsHover.Items.Add;
        listItem.Caption := Format('%d', [SendedGroup.sendAantal]);
        listItem.SubItems.Add(SendedGroup.orgGroup._Type.Name);
        listItem.SubItems.Add(Format('%04.1f', [SendedGroup.GetSpeed]));
        listItem.SubItems.Add(mkITOA(trunc(SendedGroup.sendToGo / SendedGroup.GetSpeed) + 1));
        listItem.SubItems.Add(Format('%d', [SendedGroup.orgGroup._Type.Attacks]));
        listItem.SubItems.Add(Format('%04.1f', [SendedGroup.orgGroup.EffWeapon]));
        listItem.SubItems.Add(Format('%04.1f', [SendedGroup.orgGroup.EffShield]));
        listItem.SubItems.Add(Format('%04.1f', [SendedGroup.orgGroup._Type.Mass]));
      end;
    end;
  finally
    lvMyGroupsHover.EndUpdate;
  end;
end;

procedure TfrmAdvancedSend.DoOtherGroupsHover(planet: TPlanet);
var
  i, j: integer;
  group: TGroup;
  player: TPlayer;
  listItem: TListItem;
begin
  lvOtherGroupsHover.BeginUpdate;
  try
    lvOtherGroupsHover.Items.Clear;
    for j := 0 to players.Count - 1 do begin
      player := TPlayer(players.Objects[j]);
      if player <> qReportplayer then begin
        for i := 0 to player.Groups.Count - 1 do begin
          group := TGroup(player.Groups[i]);
          if (group.Planet = planet) and (group.Turn = LastTurn) and (group.Range = 0) then begin
            listItem := lvOtherGroupsHover.Items.Add;
            listItem.Caption := player.Name;
            listItem.SubItems.Add(Format('%d', [group.Aantal]));
            listItem.SubItems.Add(group._Type.Name);
            listItem.SubItems.Add(Format('%04.1f', [group.EffSpeed]));
            listItem.SubItems.Add(Format('%d', [group._Type.Attacks]));
            listItem.SubItems.Add(Format('%04.1f', [group.EffWeapon]));
            listItem.SubItems.Add(Format('%04.1f', [group.EffShield]));
            listItem.SubItems.Add(Format('%04.1f', [group._Type.Mass]));
          end;
        end;
      end;
    end;
  finally
    lvOtherGroupsHover.EndUpdate;
  end;
end;

procedure TfrmAdvancedSend.RadioGroup1Click(Sender: TObject);
begin
  Notebook1.PageIndex := RadioGroup1.ItemIndex;
end;

procedure TfrmAdvancedSend.lvResultsHotTrack(Sender: TObject;
  var ItemIndex: Integer; SubItemIndex: Integer; Location: TPoint;
  var AllowSelect: Boolean);
const
  LastIndex: integer = -1;
var
  planet: TPlanet;
begin
  if (ItemIndex <> -1) and (LastIndex <> ItemIndex) then begin
    planet := TPlanet(lvResults.Items[ItemIndex].Data);
    DoPlanetHover(planet);
    DoMyGroupsHover(planet);
    DoOtherGroupsHover(planet);
    LastIndex := ItemIndex;
  end;
end;

procedure TfrmAdvancedSend.PlanetInfo1Click(Sender: TObject);
begin
  Radiogroup1.ItemIndex := 0;
end;

procedure TfrmAdvancedSend.MyGroups1Click(Sender: TObject);
begin
  Radiogroup1.ItemIndex := 1;
end;

procedure TfrmAdvancedSend.OtherGroups1Click(Sender: TObject);
begin
  Radiogroup1.ItemIndex := 2;
end;

end.
