unit UExportToMDB;

interface

uses
  Windows, DAO_TLB, Forms;

function GetDBEngine: boolean;
function CheckIfDBExists: boolean;
function DoExport: boolean;

procedure DaoEmptyTables(DB: DataBase);

implementation

uses
  ComObj, UFiles, FileCTRL, SysUtils, xProcs, UTypes, ActiveX;

var
  DBEngine: _DBEngine;
  DBFileName: string;

procedure DaoEmptyTables(DB: DataBase);
begin
  DB.Execute('DELETE FROM Battles', 0);
  DB.Execute('DELETE FROM BattleGroups', 0);
  DB.Execute('DELETE FROM Groups', 0);
  DB.Execute('DELETE FROM Shiptypes', 0);
  DB.Execute('DELETE FROM PlayerAtTurn', 0);
  DB.Execute('DELETE FROM PlanetAtTurn', 0);
  DB.Execute('DELETE FROM IncomingGroups', 0);
  DB.Execute('DELETE FROM Players', 0);
  DB.Execute('DELETE FROM Planets', 0);
end;

procedure DoExportPlayers(DB: DataBase);
var
  tablePlayers: Recordset;
  tablePlayerAtTurn: Recordset;
  i, j: integer;
  LastModified: PSafeArray;
  PL_Name: OleVariant;
  PL_ID: OleVariant;
  tmpValue: OleVariant;
  player: TPlayer;
begin
  tablePlayers := DB.OpenRecordset('Players', dbOpenTable, 0, dbOptimistic);
  tablePlayerAtTurn := DB.OpenRecordset('PlayerAtTurn', dbOpenTable, 0, dbOptimistic);
  try
    for i := 0 to players.Count - 1 do begin
      player := TPlayer(Players.Objects[i]);
      PL_Name := player.Name;
      tablePlayers.AddNew;
      tablePlayers.Get_Fields.Get_Item('PL_Name').Set_Value(PL_Name);
      tablePlayers.Update(dbUpdateRegular, False);
      LastModified := tablePlayers.Get_LastModified;
      tablePlayers.Set_Bookmark(LastModified);
      PL_ID := tablePlayers.Get_Fields.Get_Item('PL_ID').Get_Value;
      for j := 0 to LastTurn do begin
        tablePlayerAtTurn.AddNew;
        tablePlayerAtTurn.Get_Fields.Get_Item('PL_TN_Player').Set_Value(PL_ID);
        tmpValue := j;
        tablePlayerAtTurn.Get_Fields.Get_Item('PL_TN_Turn').Set_Value(tmpValue);
        tmpValue := player.Drive[j];
        tablePlayerAtTurn.Get_Fields.Get_Item('PL_TN_DriveTech').Set_Value(tmpValue);
        tmpValue := player.Weapons[j];
        tablePlayerAtTurn.Get_Fields.Get_Item('PL_TN_WeaponTech').Set_Value(tmpValue);
        tmpValue := player.Shield[j];
        tablePlayerAtTurn.Get_Fields.Get_Item('PL_TN_ShieldTech').Set_Value(tmpValue);
        tmpValue := player.Cargo[j];
        tablePlayerAtTurn.Get_Fields.Get_Item('PL_TN_CargoTech').Set_Value(tmpValue);
        tmpValue := player.Population[j];
        tablePlayerAtTurn.Get_Fields.Get_Item('PL_TN_Population').Set_Value(tmpValue);
        tmpValue := player.Industry[j];
        tablePlayerAtTurn.Get_Fields.Get_Item('PL_TN_Industry').Set_Value(tmpValue);
        tablePlayerAtTurn.Update(dbUpdateRegular, False);

      end;
    end;
  finally
    tablePlayers := nil;
    tablePlayerAtTurn := nil;
  end;
end;

function GetDBEngine: boolean;
begin
  if not Assigned(DBEngine) then
  try
    DBEngine := CoDBEngine.Create;
  except
  end;
  Result := Assigned(DBEngine);
end;

function CheckIfDBExists: boolean;
var
  OldDBFilename: string;
begin
  Result := False;
  try
    if DBFileName = '' then begin
      DBFileName := ExtractFilePath(strSpelD);
      DBFileName := strAddSlash(DBFileName) + 'MKGal.MDB';
    end;
    OldDBFilename := ExtractFilePath(Application.ExeName) + 'MKGal.MDB';
    if not FileExists(DBFileName) then
      copyFile(PChar(OldDBFilename), PChar(DBFileName), True);
    if CompareText(OldDBFilename, DBFileName) = 0 then Exit;
    Result := FileExists(DBFileName);
  except
    Result := False;
  end;
end;

function DoExport: boolean;
var
  DBMKGal: Database;
begin
  Result := false;
  if CheckIfDBExists then begin
    DBMKGal := DBEngine.OpenDatabase(DBFileName, False, False, '');
    if Assigned(DBMKGal) then begin
      DaoEmptyTables(DBMKGal);
      DoExportPlayers(DBMKGal);

      DBMKGal.Close;
      Result := true;
    end;
    DBMKGal := nil;
  end;
end;

initialization

finalization
  if Assigned(DBEngine) then
    DBEngine := nil;
end.
