unit USortingAlgorithems;

interface

uses
  Windows, Classes, UTypes, UfrmOrders, UfrmAutoCargoSettings;

procedure CalcDistForCAP(group: TGroup; curCap: single; AutoCAPFill: integer);
procedure CalcDistForCOL(group: TGroup; curCol: single; AutoCOLFill: integer);
procedure CalcDistForStock(group: TGroup);

function CompareDevPlanetsListOnCAP(Item1, Item2: Pointer): Integer;
function CompareDevPlanetsListOnCOL(Item1, Item2: Pointer): Integer;

function CompareHomeWorlds(Item1, Item2: Pointer): Integer;
function CompareHomeWorldsOnNrAndName(Item1, Item2: Pointer): Integer;

function CompareToDoListOnCAP(Item1, Item2: Pointer): Integer;
function CompareToDoListOnCOL(Item1, Item2: Pointer): Integer;
function CompareToDoListOnEffCargo(Item1, Item2: Pointer): Integer;

function CompareTListOnPlanetDistance(Item1, Item2: Pointer): Integer;
function CompareTListOnSortOnArray(Item1, Item2: Pointer): Integer;

var
  CompareSortOnArray: TSortOnArray;

implementation

uses
  UDevelop, UFilesCountMethod, HyperStr, SysUtils;

procedure CalcDistForCOL(group: TGroup; curCol: Single; AutoCOLFill: integer);
var
  devPlanet: TdevPlanet;
  i: integer;
  curPlanet,
    planet: TPlanet;
  size: Single;
begin
  curPlanet := group.Planet;
  for i := 0 to planets.Count - 1 do
  begin
    planet := TPlanet(planets.objects[i]);
    size := planet.Size * AutoCOLFill / 100;
    devPlanet := FindDevPlanet(planet);
    if Assigned(devPlanet) and
      devPlanet.developThisPlanet and
      ((size = 0) or ((planet.PopulationCur < Size) and ((devPlanet.devPopulation[1] + curCol * 8) < Size))) then
      planet.SetDistanceFrom(curPlanet.x, curPLanet.y)
    else
      planet.SetDistanceFrom(Planet.x, Planet.y); // no distance
  end;
end;

procedure CalcDistForStock(group: TGroup);
var
  devPlanet: TdevPlanet;
  i: integer;
  curPlanet,
    planet: TPlanet;
begin
  curPlanet := group.Planet;
  for i := 0 to planets.Count - 1 do
  begin
    planet := TPlanet(planets.objects[i]);
    devPlanet := FindDevPlanet(planet);
    if (planet.PlayerCur = qReportPlayer) and
      (((devPlanet.devCOL[1] > 0) or (devPlanet.devCAP[1] > 0))) then
      planet.SetDistanceFrom(curPlanet.x, curPLanet.y)
    else
      planet.SetDistanceFrom(Planet.x, PLanet.y);
  end;
end;

procedure CalcDistForCAP(group: TGroup; curCap: single; AutoCAPFill: integer);
var
  devPlanet: TdevPlanet;
  i: integer;
  curPlanet,
    planet: TPlanet;
  size: single;
begin
  curPlanet := group.Planet;
  for i := 0 to planets.Count - 1 do
  begin
    planet := TPlanet(planets.objects[i]);
    // misschien toch hier wat anders gaan gebruiken dan planet size, maar dan
    // moet wel rekening gehouden gaan worden met
    size := planet.Size * AutoCAPFill / 100;

    devPlanet := FindDevPlanet(planet);
    if assigned(devPlanet) and
      devPlanet.developThisPlanet and
      (planet.IndustryCur < size) and
      ((devPlanet.devIndustry[1] + curCap) < size) then
      planet.SetDistanceFrom(curPlanet.x, curPLanet.y)
    else
      planet.SetDistanceFrom(Planet.x, PLanet.y); // no distance
  end;
end;

function CompareHomeWorlds(Item1, Item2: Pointer): Integer;
begin
  if HomeWorlds[integer(item1)].planet.Distance < HomeWorlds[integer(item2)].planet.Distance then Result := -1
  else
    if HomeWorlds[integer(item1)].planet.Distance > HomeWorlds[integer(item2)].planet.Distance then Result := 1
    else
      Result := 0;
end;

function CompareHomeWorldsOnNrAndName(Item1, Item2: Pointer): Integer;
begin
  if HomeWorlds[integer(item1)].PlayerNr < HomeWorlds[integer(item2)].PlayerNr then Result := -1
  else
    if HomeWorlds[integer(item1)].PlayerNr > HomeWorlds[integer(item2)].PlayerNr then Result := 1
    else
      Result := CmpUSI(HomeWorlds[integer(item1)].planet.Nr, HomeWorlds[integer(item2)].planet.Nr);
end;

function CompareToDoListOnCAP(Item1, Item2: Pointer): Integer;
var
  curCAP1,
    curCAP2: single;
begin
  if Assigned(TdevGroup(Item1).devPlanet) then
    curCAP1 := TdevGroup(Item1).devPlanet.devCAP[0]
  else
    curCAP1 := 0;
  if Assigned(TdevGroup(Item2).devPlanet) then
    curCAP2 := TdevGroup(Item2).devPlanet.devCAP[0]
  else
    curCap2 := 0;
  if curCAP1 < curCAP2 then Result := 1
  else
    if curCAP1 > curCAP2 then Result := -1
    else
      Result := 0;
end;

function CompareToDoListOnCOL(Item1, Item2: Pointer): Integer;
var
  curCol1,
    curCol2: single;
begin
  if Assigned(TdevGroup(Item1).devPlanet) then
    curCol1 := TdevGroup(Item1).devPlanet.devCOL[0]
  else
    curCol1 := 0;
  if Assigned(TdevGroup(Item2).devPlanet) then
    curCol2 := TdevGroup(Item2).devPlanet.devCOL[0]
  else
    curCol2 := 0;
  if curCol1 < curCol2 then Result := 1
  else
    if curCol1 > curCol2 then Result := -1
    else
      Result := 0;
end;

function CompareToDoListOnEffCargo(Item1, Item2: Pointer): Integer;
var
  curCargo1,
    curCargo2,
    curSpeed1,
    curSpeed2: single;
begin
  curCargo1 := TdevGroup(Item1).orgGroup.EffCargo;
  curCargo2 := TdevGroup(Item2).orgGroup.EffCargo;
  if curCargo1 < curCargo2 then Result := 1
  else
    if curCargo1 > curCargo2 then Result := -1
    else begin
      curSpeed1 := TdevGroup(Item1).orgGroup.EffSpeed;
      curSpeed2 := TdevGroup(Item2).orgGroup.EffSpeed;
      if curSpeed1 > curSpeed2 then Result := 1
      else
        if curSpeed1 < curSpeed2 then Result := -1
        else
          Result := 0;
    end;
end;

function CompareTListOnPlanetDistance(Item1, Item2: Pointer): Integer;
var
  planet1, planet2: TPlanet;
begin
  planet1 := TPLanet(Item1);
  planet2 := TPLanet(Item2);
  if planet1.Distance < planet2.Distance then Result := -1
  else
    if planet1.Distance > planet2.Distance then Result := 1
    else
      Result := 0;
end;

//SortOnArray: TSortOnArray  CompareSortOnArray

function CompareTListOnSortOnArray(Item1, Item2: Pointer): Integer;
var
  planet1, planet2: TPlanet;
  i: Integer;
  sinPerFull1, sinPerFull2: Single;
  vBuildability1: Single;
  vBuildability2: Single;
begin
  if Item1 = Item2 then begin
    Result := 0;
    Exit;
  end;
  planet1 := TPLanet(Item1);
  planet2 := TPLanet(Item2);
  for i := 0 to high(CompareSortOnArray) do begin
    case CompareSortOnArray[i] of
      SORTON_SIZE:
        if planet1.Size < planet2.Size then begin
          Result := 1;
          exit;
        end else
          if planet1.Size > planet2.Size then begin
            Result := -1;
            exit;
          end;
      SORTON_RESOURCES:
        if planet1.Resources < planet2.Resources then begin
          Result := 1;
          exit;
        end else
          if planet1.Resources > planet2.Resources then begin
            Result := -1;
            exit;
          end;
      SORTON_DISTANCE:
        if planet1.Distance < planet2.Distance then begin
          Result := -1;
          exit;
        end else
          if planet1.Distance > planet2.Distance then begin
            Result := 1;
            exit;
          end;
      SORTON_PERCENTFULLHIGH:
        begin
          if planet1.Size > 0 then
            sinPerFull1 := planet1.EffIndustryCur / planet1.Size
          else
            sinPerFull1 := 0;
          if planet2.Size > 0 then
            sinPerFull2 := planet2.EffIndustryCur / planet2.Size
          else
            sinPerFull2 := 0;
          if sinPerFull1 < sinPerFull2 then begin
            Result := 1;
            exit;
          end else
            if sinPerFull1 > sinPerFull2 then begin
              Result := -1;
              exit;
            end;
        end;
      SORTON_PERCENTFULLLOW:
        begin
          if planet1.Size > 0 then
            sinPerFull1 := planet1.EffIndustryCur / planet1.Size
          else
            sinPerFull1 := 0;
          if planet2.Size > 0 then
            sinPerFull2 := planet2.EffIndustryCur / planet2.Size
          else
            sinPerFull2 := 0;
          if sinPerFull1 < sinPerFull2 then begin
            Result := -1;
            exit;
          end else
            if sinPerFull1 > sinPerFull2 then begin
              Result := 1;
              exit;
            end;
        end;
      SORTON_BUILDABILITY:
        begin
          if planet1.Buildability < planet2.Buildability then begin
          Result := 1;
          exit;
        end else
          if planet1.Buildability > planet2.Buildability then begin
            Result := -1;
            exit;
          end;
        end;
    end;
  end;


  if planet1.Distance < planet2.Distance then Result := -1
  else
    if planet1.Distance > planet2.Distance then Result := 1
    else
      Result := 0;
end;

function CompareDevPlanetsListOnCAP(Item1, Item2: Pointer): Integer;
var
  curCap1,
    curCap2: single;
begin
  curCap1 := TDevplanet(Item1).devCap[1];
  curCap2 := TDevplanet(Item2).devCap[1];
  if curCap1 < curCap2 then Result := 1
  else
    if curCap1 > curCap2 then Result := -1
    else
      Result := 0;
end;

function CompareDevPlanetsListOnCOL(Item1, Item2: Pointer): Integer;
var
  curCol1,
    curCol2: single;
begin
  curCol1 := TDevplanet(Item1).devCol[1];
  curCol2 := TDevplanet(Item2).devCol[1];
  if curCol1 < curCol2 then Result := 1
  else
    if curCol1 > curCol2 then Result := -1
    else
      Result := 0;
end;

end.
