unit UfrmAutoCargoSettings;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, RzDlgBtn, OvcBase, OvcState, OvcSlide, ComCtrls,
  RzTrkBar, Mask, RzEdit, RzSpnEdt, ActnList;

const
  SORTON_SIZE = 0;
  SORTON_RESOURCES = 1;
  SORTON_DISTANCE = 2;
  SORTON_PERCENTFULLHIGH = 3;
  SORTON_PERCENTFULLLOW = 4;
  SORTON_BUILDABILITY = 5; // buildability
type
  TSortOnArray = array[0..5] of integer;
  TfrmAutoCargoSettings = class(TForm)
    RzDialogButtons1: TRzDialogButtons;
    rgMaxDistance: TRadioGroup;
    OvcComponentState1: TOvcComponentState;
    lbxSortOn: TListBox;
    Label1: TLabel;
    btnUp: TButton;
    btnDown: TButton;
    Label2: TLabel;
    Label3: TLabel;
    edtCOLFill: TRzSpinEdit;
    edtCAPFill: TRzSpinEdit;
    ActionList1: TActionList;
    actUp: TAction;
    actDown: TAction;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    edtBuildCAPStock: TRzSpinEdit;
    edtBuildResources: TRzSpinEdit;
    edtBuildDistance: TRzSpinEdit;
    Label10: TLabel;
    cbxBuildPlanet: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure actUpUpdate(Sender: TObject);
    procedure actDownUpdate(Sender: TObject);
    procedure actUpExecute(Sender: TObject);
    procedure actDownExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FInit: boolean;
    function GetMaxDistance: integer;
    procedure SetMaxDistance(const Value: integer);
    function GetCAPFill: integer;
    procedure SetCAPFill(const Value: integer);
    function GetCOLFill: integer;
    procedure SetCOLFill(const Value: integer);
    function GetSortOnArray: TSortOnArray;
    procedure DoInit;
    { Private declarations }
  public
    property CAPFill: integer read GetCAPFill write SetCAPFill;
    property COLFill: integer read GetCOLFill write SetCOLFill;
    property MaxDistance: integer read GetMaxDistance write SetMaxDistance;
    property SortOn: TSortOnArray read GetSortOnArray;
    { Public declarations }
  end;

procedure InitBuildability;

var
  frmAutoCargoSettings: TfrmAutoCargoSettings;

implementation

{$R *.DFM}

uses
  UfrmMain, UFiles, UTypes;

procedure InitBuildability;
var
  vPlanet: TPlanet;
  vX: Single;
  vY: Single;
  vX1: Single;
  vY1: Single;
  vDistance: Single;
  i: integer;
  BuildCAPValue: integer;
  BuildResValue: integer;
  BuildDistance: integer;
  BuildCenterPlanet: TPlanet;
begin
  BuildCAPValue := frmAutoCargoSettings.edtBuildCAPStock.IntValue;
  BuildResValue := frmAutoCargoSettings.edtBuildResources.IntValue;
  BuildDistance := frmAutoCargoSettings.edtBuildDistance.IntValue;

  BuildCenterPlanet := FindPlanetWithName(frmAutoCargoSettings.cbxBuildPlanet.Text);
  for i := 0 to planets.Count - 1 do begin
    vPlanet := TPlanet(planets.objects[i]);
    vPlanet.Buildability := 0;
    if (vPlanet.PlayerCur = qReportplayer)
       and (vPlanet.Size > vPlanet.EffIndustryCur) then begin
      if not Assigned(BuildCenterPlanet) then begin
        BuildCenterPlanet := vPlanet;
        frmAutoCargoSettings.cbxBuildPlanet.Text := vPlanet.Name;
      end;
      vX := vPlanet.X;
      vY := vPlanet.Y;
      vX1 := BuildCenterPlanet.X;
      vY1 := BuildCenterPlanet.Y;
      vDistance := sqrt((vX - vX1) * (vX - vX1) + (vY - vY1) * (vY - vY1)) / 1000;

      vPlanet.Buildability := vPlanet.Size + (vPlanet.CapitalCur * BuildCAPValue)
        + (vPlanet.Resources * BuildResValue)
        - (vDistance * BuildDistance);
      if vPlanet.Buildability < 0 then begin
        if vPlanet.Buildability < -1 then
          vPlanet.Buildability := - (1 / vPlanet.Buildability)
        else
          vPlanet.Buildability := 1;
      end else
        vPlanet.Buildability := vPlanet.Buildability * (vPlanet.Size - vPlanet.EffIndustryCur) / vPlanet.Size;
    end;
  end;
end;


{ TfrmAutoCargoSettings }

function TfrmAutoCargoSettings.GetCAPFill: integer;
begin
  DoInit;
  Result := edtCAPFill.IntValue;
end;

function TfrmAutoCargoSettings.GetCOLFill: integer;
begin
  DoInit;
  Result := edtCOLFill.IntValue;
end;

function TfrmAutoCargoSettings.GetMaxDistance: integer;
begin
  DoInit;
  Result := rgMaxDistance.ItemIndex + 1;
end;

function TfrmAutoCargoSettings.GetSortOnArray: TSortOnArray;
var
  i: integer;
begin
  DoInit;
  for i := 0 to high(Result) do begin
    if CompareText(lbxSortOn.Items[i], 'Size') = 0 then Result[i] := SORTON_SIZE
    else
      if CompareText(lbxSortOn.Items[i], 'Resources') = 0 then Result[i] := SORTON_RESOURCES
    else
      if CompareText(lbxSortOn.Items[i], 'Percent Full High') = 0 then Result[i] := SORTON_PERCENTFULLHIGH
    else
      if CompareText(lbxSortOn.Items[i], 'Percent Full Low') = 0 then Result[i] := SORTON_PERCENTFULLLOW
    else
      if CompareText(lbxSortOn.Items[i], 'Buildability') = 0 then Result[i] := SORTON_BUILDABILITY
    else
      Result[i] := SORTON_DISTANCE;
  end;
end;

procedure TfrmAutoCargoSettings.SetCAPFill(const Value: integer);
begin
  edtCAPFill.IntValue := Value;
end;

procedure TfrmAutoCargoSettings.SetCOLFill(const Value: integer);
begin
  edtCOLFill.IntValue := Value;
end;

procedure TfrmAutoCargoSettings.SetMaxDistance(const Value: integer);
begin
  rgMaxDistance.ItemIndex := Value - 1
end;

procedure TfrmAutoCargoSettings.FormShow(Sender: TObject);
begin
  DoInit;
end;

procedure TfrmAutoCargoSettings.FormHide(Sender: TObject);
begin
  OvcComponentState1.SaveState;
  InitBuildability;
end;

procedure TfrmAutoCargoSettings.actUpUpdate(Sender: TObject);
begin
  actUp.Enabled := (lbxSortOn.ItemIndex > 0);
end;

procedure TfrmAutoCargoSettings.actDownUpdate(Sender: TObject);
begin
  actDown.Enabled := (lbxSortOn.ItemIndex <> -1) and (lbxSortOn.ItemIndex < (lbxSortOn.Items.Count - 1));
end;

procedure TfrmAutoCargoSettings.actUpExecute(Sender: TObject);
var
  strTempItem: string;
begin
  strTempItem := lbxSortOn.Items.Strings[lbxSortOn.ItemIndex];
  lbxSortOn.Items.Strings[lbxSortOn.ItemIndex] := lbxSortOn.Items.Strings[lbxSortOn.ItemIndex - 1];
  lbxSortOn.Items.Strings[lbxSortOn.ItemIndex - 1] := strTempItem;
  lbxSortOn.ItemIndex := lbxSortOn.ItemIndex - 1;
end;

procedure TfrmAutoCargoSettings.actDownExecute(Sender: TObject);
var
  strTempItem: string;
begin
  strTempItem := lbxSortOn.Items.Strings[lbxSortOn.ItemIndex];
  lbxSortOn.Items.Strings[lbxSortOn.ItemIndex] := lbxSortOn.Items.Strings[lbxSortOn.ItemIndex + 1];
  lbxSortOn.Items.Strings[lbxSortOn.ItemIndex + 1] := strTempItem;
  lbxSortOn.ItemIndex := lbxSortOn.ItemIndex + 1;
end;

procedure TfrmAutoCargoSettings.FormCreate(Sender: TObject);
begin
  FInit := false;
end;

procedure TfrmAutoCargoSettings.DoInit;
var
  i: integer;
begin
  if FInit then exit;
  OvcComponentState1.Section := 'AutoCargoSettings_' + strGameName;
  OvcComponentState1.RestoreState;
  if lbxSortOn.Items.indexof('Buildability') = -1 then
    lbxSortOn.Items.Add('Buildability');
  cbxBuildPlanet.Items.Clear;
  for i := 0 to planets.Count - 1 do begin
    if TPlanet(planets.objects[i]).PlayerCur = qReportplayer then
      cbxBuildPlanet.Items.Add(TPlanet(planets.objects[i]).Name);
  end;
  InitBuildability;
  FInit := true;
end;

end.

