unit UfrmBattles;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, Utypes, Menus, DualList,
  EnhListView, ExtListView, OvcBase, OvcState, RXCtrls;

type
  TfrmBattles = class(TForm)
    PopupMenu1: TPopupMenu;
    mniAddToBattleSim: TMenuItem;
    DualListDialog1: TDualListDialog;
    OvcFormState1: TOvcFormState;
    mniFindPlanetInOrders: TMenuItem;
    TimerMayChange: TTimer;
    Panel1: TPanel;
    Panel2: TPanel;
    lbxBattleInfo: TTextListBox;
    Splitter1: TSplitter;
    lvBattles: TdfsExtListView;
    Label1: TLabel;
    ComboBox1: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lvBattlesChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure mniAddToBattleSimClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure lvBattlesDblClick(Sender: TObject);
    procedure TimerMayChangeTimer(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    FInitialized: boolean;
    procedure DoClick(index: integer);
    procedure FillBattleInfo(battle: TBattle; BattleInfo: TStrings);
    procedure FillList;
    { Private declarations }
  public
    { Public declarations }
    procedure GoToBattle(battle: TBattle);
  end;

var
  frmBattles: TfrmBattles;

implementation

uses mkStrUtils, UfrmBattleSimulator, UfrmPlanets, UfrmMain,
  UfrmNewMap, UfrmOrders, UFiles;

{$R *.DFM}

procedure TfrmBattles.GoToBattle(battle: TBattle);
var
  i: integer;
begin
  i := 0;
  while i < lvBattles.Items.Count do
  begin
    if lvBattles.Items[i].data = battle then
      break
    else
      inc(i);
  end;
  if i < lvBattles.Items.Count then
    DoClick(i);
end;

procedure TfrmBattles.DoClick(index: integer);
const
  LastIndex: integer = -1;
var
  listItem: TListItem;
begin
  if LastIndex = index then Exit;
  LastIndex := index;
  listItem := lvBattles.Items.Item[index];
  listItem.MakeVisible(False);
  listItem.Selected := True;
  FillBattleInfo(listItem.data, lbxBattleInfo.Items);
end;

procedure TfrmBattles.FillBattleInfo(battle: TBattle; BattleInfo: TStrings);
var
  i, j: integer;
  group: TGroup;
  blnFirstGroup: boolean;
  Smass, Emass: single;
begin
  for j := 0 to players.Count - 1 do
  begin
    blnFirstGroup := True;
    Smass := 0;
    Emass := 0;
    for i := 0 to battle.Groups.Count - 1 do
      if players.Objects[j] = TGroup(battle.Groups.items[i]).player then
      begin
        group := battle.Groups.items[i];
        if blnFirstGroup then
        begin
          BattleInfo.Add(group.Player.name + ' Groups');
          blnFirstGroup := False;
        end;
        Smass := Smass + group._Type.Mass * group.Aantal;
        Emass := EMass + group._Type.Mass * group.AantalBattle;
        BattleInfo.Add(Format('  %.3d %.3d %s', [group.Aantal, group.AantalBattle, group._Type.name]));
      end;
    if not blnFirstGroup then
    begin
      BattleInfo.Add(Format('M: s: %4.1f e: %4.1f l: %4.1f', [SMass, Emass, SMass - EMass]));
      BattleInfo.Add('');
    end;
  end;
end;

procedure TfrmBattles.FormCreate(Sender: TObject);
begin
  FInitialized := False;
end;

procedure TfrmBattles.FormShow(Sender: TObject);
begin
  ComboBox1.ItemIndex := 0;
  FillList;
end;

procedure TfrmBattles.FillList;
var
  i, j: integer;
  bt: TBattle;
  lvItem: TListitem;
  myMass, otherMass: Single;
begin
  lvBattles.BeginUpdate;
  try
    if not FInitialized then
    begin
      lvBattles.Items.Clear;
      for i := 0 to battles.Count - 1 do
      begin
        bt := TBattle(battles.Objects[i]);
        if ComboBox1.ItemIndex = 0 then
          if bt.Turn <> LastTurn then
            Continue;
        lvItem := lvBattles.Items.Add;
        lvItem.Caption := IntToStr(bt.turn);
        lvItem.SubItems.Add(bt.planet.name);
        lvItem.Data := bt;
        myMass := 0;
        otherMass := 0;
        for j := 0 to bt.Groups.Count - 1 do begin
          if TGroup(bt.Groups[j]).Player = qreportplayer then
            myMass := myMass + TGroup(bt.Groups[j]).Aantal * TGroup(bt.Groups[j])._Type.Mass - TGroup(bt.Groups[j]).AantalBattle * TGroup(bt.Groups[j])._Type.Mass
          else
            otherMass := otherMass + TGroup(bt.Groups[j]).Aantal * TGroup(bt.Groups[j])._Type.Mass - TGroup(bt.Groups[j]).AantalBattle * TGroup(bt.Groups[j])._Type.Mass;
        end;
        lvItem.SubItems.Add(FloatToStr(myMass));
        lvItem.SubItems.Add(FloatToStr(otherMass));
      end;
      FInitialized := True;
    end;
  finally
    lvBattles.EndUpdate;
  end;
  lvBattles.CurrentSortAscending := True;
  lbxBattleInfo.Clear;
  if lvBattles.Items.Count > 0 then
    FillBattleInfo(lvBattles.Items[0].data, lbxBattleInfo.Items);
end;

procedure TfrmBattles.lvBattlesChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
const
  LastIndex: integer = -1;
begin
  if Application.Terminated and not TimerMayChange.Enabled then
    Exit;
  if not FInitialized then exit;
  if Change = ctState then
    if Item.Index <> LastIndex then
    begin
      LastIndex := Item.Index;
      lbxBattleInfo.Items.Clear;
      DoClick(Item.Index);
      frmNewMap.Pointplanet(TGroup(Item.data).planet, true);
      frmPlanets.ShowPlanet(TGroup(Item.data).planet, true);
      TimerMayChange.Enabled := True;
    end;
end;

procedure TfrmBattles.mniAddToBattleSimClick(Sender: TObject);
var
  battle: TBattle;
  group: TGroup;
  i: integer;
begin
  if Assigned(lvBattles.Selected) then
  begin
    DualListDialog1.List1.Clear;
    DualListDialog1.List2.Clear;

    battle := Tbattle(lvBattles.Selected.Data);
    for i := 0 to battle.Groups.Count - 1 do
    begin
      group := TGroup(battle.Groups.Items[i]);
      if DualListDialog1.List1.IndexOf(group.Player.Name) = -1 then
        DualListDialog1.List1.Add(group.Player.Name);
    end;
    if DualListDialog1.Execute then
    begin
      frmBattleSimulator.NewBattle;
      for i := 0 to battle.Groups.Count - 1 do
      begin
        group := NewGroup(TGroup(battle.Groups.Items[i]));
        if DualListDialog1.List1.IndexOf(group.Player.Name) = -1 then
          frmBattleSimulator.AddGroupToDefenders(group)
        else
          frmBattleSimulator.AddGroupToAttackers(group);
      end;
      frmBattleSimulator.UpdateBattleSim;
    end;
  end;
end;                    

procedure TfrmBattles.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  WindowState := wsMinimized;
  CanClose := false;
end;

procedure TfrmBattles.lvBattlesDblClick(Sender: TObject);
begin
  if assigned(lvBattles.Selected) then
    frmOrders.FindFirstPlanetInOrders(TGroup(lvBattles.Selected.data).planet.Name);
end;

procedure TfrmBattles.TimerMayChangeTimer(Sender: TObject);
begin
  TimerMayChange.Enabled := False;
end;

procedure TfrmBattles.ComboBox1Change(Sender: TObject);
begin
  FInitialized := false;
  FillList;
end;

end.
