unit UfrmBombings;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, EnhListView, ExtListView, OvcBase, OvcState, Menus, EC_LView,
  EC_ExtLView, EC_Main, ExtCtrls;

type
  TfrmBombings = class(TForm)
    lvBombings: TdfsExtListView;
    OvcFormState1: TOvcFormState;
    PopupMenu1: TPopupMenu;
    mniExportSelected: TMenuItem;
    ExportExtListView1: TExportExtListView;
    mniAddplanetsToClipboardForDevelopment: TMenuItem;
    mniAddSelectedPlanetsForProduce: TMenuItem;
    mniFindPlanetInOrders: TMenuItem;
    TimerMayChange: TTimer;
    procedure lvBombingsChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure FormShow(Sender: TObject);
    procedure mniExportSelectedClick(Sender: TObject);
    procedure lvBombingsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mniAddplanetsToClipboardForDevelopmentClick(Sender: TObject);
    procedure mniAddSelectedPlanetsForProduceClick(Sender: TObject);
    procedure mniFindPlanetInOrdersClick(Sender: TObject);
    procedure TimerMayChangeTimer(Sender: TObject);
  private
    FInitialized: boolean;
    procedure DoClick(index: integer);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmBombings: TfrmBombings;

implementation

uses UTypes, UfrmPlanets, UfrmMain, UfrmOrders, clipbrd,
  UfrmNewMap;

{$R *.DFM}

procedure TfrmBombings.lvBombingsChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
const
  LastIndex: integer = -1;
begin
  if Application.Terminated then
    Exit;
  if not (FInitialized and Assigned(frmNewMap) and Assigned(frmPlanets)) then exit;
  if (Change = ctState) and not TimerMayChange.Enabled then
    if Item.Index <> LastIndex then
    begin
      LastIndex := Item.Index;
      DoClick(Item.Index);
      frmPlanets.ShowPlanet(TBombing(Item.data).planet, true);
      TimerMayChange.Enabled := True;
    end;
end;

procedure TfrmBombings.FormShow(Sender: TObject);
var
  bombing: TBombing;
  lvItem: TListitem;
  i: integer;
  strProducing: string;
begin
  lvBombings.BeginUpdate;
  FInitialized := False;
  try
    for i := 0 to bombings.Count - 1 do
    begin
      bombing := TBombing(bombings.Objects[i]);
      lvItem := lvBombings.Items.Add;
      lvItem.Caption := IntToStr(bombing.Turn);
      lvItem.SubItems.Add(Bombing.Attacker.Name);
      lvItem.SubItems.Add(Bombing.Defender.Name);
      lvItem.SubItems.Add(Bombing.Planet.Name);
      lvItem.SubItems.Add(Format('%5.2f', [Bombing.Population]));
      lvItem.SubItems.Add(Format('%5.2f', [Bombing.Industry]));
      strProducing := '';
      case Bombing.Producing of
        P_CAP: strProducing := 'CAP';
        P_MAT: strProducing := 'MAT';
        P_COL: strProducing := 'COL';
      end;
      lvItem.SubItems.Add(strProducing);
      lvItem.SubItems.Add(Format('%5.2f', [Bombing.Col]));
      lvItem.SubItems.Add(Format('%5.2f', [Bombing.Cap]));
      lvItem.SubItems.Add(Format('%5.2f', [Bombing.Mat]));
      lvItem.Data := bombings.Objects[i];
    end;
  finally
    lvBombings.EndUpdate;
    FInitialized := True;
  end;

end;

procedure TfrmBombings.DoClick(index: integer);
begin

end;

procedure TfrmBombings.mniExportSelectedClick(Sender: TObject);
begin
  ExportExtListview1.Footer := frmMKGal.Caption;
  ExportExtListview1.Choose;
end;

procedure TfrmBombings.lvBombingsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i: integer;
begin
  if ssCTRL in Shift then
    case Key of
      ord('A'),
        ord('a'): with TdfsExtListview(Sender) do begin
          BeginUpdate;
          for i := 0 to Items.Count - 1 do
            Items[i].Selected := True;
          EndUpdate;
        end;
    end;
end;

procedure TfrmBombings.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  WindowState := wsMinimized;
  CanClose := false;
end;

procedure TfrmBombings.mniAddplanetsToClipboardForDevelopmentClick(
  Sender: TObject);
begin
  AddItemsToClipBoardAsDevPlanets(lvBombings.Items, 2);
end;

procedure TfrmBombings.mniAddSelectedPlanetsForProduceClick(
  Sender: TObject);
begin
  AddItemsToClipBoardToproduce(lvBombings.Items, 2);
end;

procedure TfrmBombings.mniFindPlanetInOrdersClick(Sender: TObject);
begin
  if Assigned(lvBombings.Selected) then
    frmorders.FindFirstPlanetInOrders(TBombing(lvBombings.Selected.Data).Planet.Name);
end;

procedure TfrmBombings.TimerMayChangeTimer(Sender: TObject);
begin
  TimerMayChange.Enabled := False;
end;

end.
