unit UfrmCalculations;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmCalculations = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    btnClose: TButton;
    btnCalculate: TButton;
    btnSelectWhere: TButton;
    btnSelectWhat: TButton;
    RzComboBox1: TComboBox;
    RzComboBox2: TComboBox;
    procedure btnCloseClick(Sender: TObject);
    procedure btnCalculateClick(Sender: TObject);
    procedure btnSelectWhereClick(Sender: TObject);
    procedure btnSelectWhatClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmCalculations: TfrmCalculations;

implementation

uses
  uTypes, Eval32, UfrmPLanetsList, UfrmExpressionFilters,
  HyperStr, UfrmSelectExpression;

{$R *.DFM}

function DoCalcPlanet(Expression: string; PT: TPlanet): single;
var
  szTxt: array[0..511] of char;
  rcRes: TEvalValue;
  i: longint;
begin
  Result := 0;
  StrPCopy(szTxt, Expression);
  i := Evaluate(szTxt, @EvalPlanetCallback, rcRes, pt);
  if i = res_Error then Exit;
  case rcRes.dwType of
    res_Numeric,
      res_Boolean:
      Result := rcRes.xValue;
  else
    Result := 0;
  end;
end;

procedure TfrmCalculations.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmCalculations.btnCalculateClick(Sender: TObject);
var
  i: integer;
  sinResult: Single;
  strExprWhere, strExprWhat: string;
  planet: TPlanet;
begin
  sinResult := 0;
  strExprWhere := RzComboBox1.Text;
  strExprWhat := RzComboBox2.Text;
  if CompareText('<ALL SELECTED>', strExprWhere) = 0 then begin
    for i := 0 to frmPLanetsList.SelectedPlanets.Count - 1 do begin
      sinResult := sinResult + DoCalcPlanet(strExprWhat, TPlanet(frmPLanetsList.SelectedPlanets[i]));
    end;
  end else
    for i := 0 to planets.Count - 1 do begin
      planet := TPlanet(planets.objects[i]);
      if DoExprPlanet(strExprWhere, planet) = 1 then
        sinResult := sinResult + DoCalcPlanet(strExprWhat, planet);
    end;
  Memo1.Text := FloatToStr(sinResult);
end;

{
Where:
([PLAYERNAME] = [PT_LASTOWNERNAME])
[PT_PRODTYPE] = 'DRIVE'
[PT_PRODTYPE] = 'WEAPONS'
[PT_PRODTYPE] = 'SHIELDS'
[PT_PRODTYPE] = 'CARGO'
([PLAYERNAME] = [PT_LASTOWNERNAME]) and ([PT_PRODTYPE] = 'DRONE_KILLER')
(([PT_PRODTYPE] = 'DRIVE') or ([PT_PRODTYPE] =  'WEAPONS') or ([PT_PRODTYPE] = 'SHIELDS') or  ([PT_PRODTYPE] = 'CARGO')) and ([PLAYERNAME] =  [PT_LASTOWNERNAME])

What:
[PT_PRODAMOUNT]
Int([PT_PRODAMOUNT])
[PT_EFFMASS]
Int([PT_EFFMASS])


}
procedure TfrmCalculations.btnSelectWhereClick(Sender: TObject);
var
  strExpr: string;
begin
  if SelectPlanetExpression(strExpr) then
    RzComboBox1.Text := strExpr;
end;

procedure TfrmCalculations.btnSelectWhatClick(Sender: TObject);
var
  strExpr: string;
begin
  if SelectPlanetExpression(strExpr) then
    RzComboBox2.Text := strExpr;
end;

end.
