unit UfrmChangeColors;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, RzDlgBtn, StdCtrls, Buttons, OvcBase, OvcState, UTypes;

type
  TColorSchema = class;

  TfrmChangeColors = class(TForm)
    ColorDialog1: TColorDialog;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    cbxUseColorsFirstTurn: TCheckBox;
    cbxUseOneColorOtherPlayers: TCheckBox;
    RzDialogButtons1: TRzDialogButtons;
    btnBackGround: TPanel;
    btnUnInSizeUnk: TPanel;
    btnUnInSizeKnown: TPanel;
    btnPlayerPlanets: TPanel;
    btnFirstTurnPlanets: TPanel;
    btnOtherPlayersPlanets: TPanel;
    Label5: TLabel;
    btnHabSizeUnk: TPanel;
    Label6: TLabel;
    btnIncomingGroups: TPanel;
    Label7: TLabel;
    btnNameOfPlanets: TPanel;
    Label8: TLabel;
    btnBarPopulation: TPanel;
    Label9: TLabel;
    btnBarSize: TPanel;
    Label10: TLabel;
    btnBarIndustry: TPanel;
    Label11: TLabel;
    btnCursor: TPanel;
    Label12: TLabel;
    btnIncomingGroupsTrav: TPanel;
    Label13: TLabel;
    btnOtherTracks: TPanel;
    btnMyTrack: TPanel;
    Label14: TLabel;
    Label15: TLabel;
    btnGroupsLoaded: TPanel;
    btnGroupsUnloaded: TPanel;
    Label16: TLabel;
    Label17: TLabel;
    btnPlanetCircles: TPanel;
    OvcPersistentState1: TOvcPersistentState;
    Button1: TButton;
    procedure ChangeColorClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RzDialogButtons1ClickHelp(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure cbxUseColorsFirstTurnClick(Sender: TObject);
  private
    { Private declarations }
    FDoInit: boolean;
  public
    procedure SetDefaultValue;
    procedure ColorSchemaToForm(ColorSchema: TColorSchema);
    procedure FormToColorSchema(ColorSchema: TColorSchema);
    { Public declarations }
  end;

  TColorSchema = class(TComponent)
  private
    FUseColorsFirstTurn: boolean;
    FUseOneColorOtherPlayers: boolean;
    FFirstTurnPlanets: TColor;
    FUnInSizeUnk: TColor;
    FBackGround: TColor;
    FUnInSizeKnown: TColor;
    FOtherPlayersPlanets: TColor;
    FPlayerPlanets: TColor;
    FHabSizeUnk: TColor;
    FNameOfPlanets: TColor;
    FIncomingGroups: TColor;
    FBarPopulation: TColor;
    FBarIndustry: TColor;
    FBarSize: TColor;
    FCursor: TColor;
    FIncomingGroupsTrav: TColor;
    FMyTracks: TColor;
    FOtherTracks: TColor;
    FGroupsUnLoaded: TColor;
    FGroupsLoaded: TColor;
    FPlanetCircles: TColor;
  public
    procedure Assign(Source: TPersistent); override;
    procedure SetDefault;
  published
    property BackGround: TColor read FBackGround write FBackGround;
    property UnInSizeUnk: TColor read FUnInSizeUnk write FUnInSizeUnk;
    property UnInSizeKnown: TColor read FUnInSizeKnown write FUnInSizeKnown;
    property HabSizeUnk: TColor read FHabSizeUnk write FHabSizeUnk;
    property PlayerPlanets: TColor read FPlayerPlanets write FPlayerPlanets;
    property FirstTurnPlanets: TColor read FFirstTurnPlanets write FFirstTurnPlanets;
    property OtherPlayersPlanets: TColor read FOtherPlayersPlanets write FOtherPlayersPlanets;
    property IncomingGroups: TColor read FIncomingGroups write FIncomingGroups;
    property IncomingGroupsTrav: TColor read FIncomingGroupsTrav write FIncomingGroupsTrav;
    property NameOfPlanets: TColor read FNameOfPlanets write FNameOfPlanets;
    property BarPopulation: TColor read FBarPopulation write FBarPopulation;
    property BarIndustry: TColor read FBarIndustry write FBarIndustry;
    property BarSize: TColor read FBarSize write FBarSize;
    property Cursor: TColor read FCursor write FCursor;
    property MyTracks: TColor read FMyTracks write FMyTracks;
    property OtherTracks: TColor read FOtherTracks write FOtherTracks;
    property GroupsUnLoaded: TColor read FGroupsUnLoaded write FGroupsUnLoaded;
    property GroupsLoaded: TColor read FGroupsLoaded write FGroupsLoaded;
    property PlanetCircles: TColor read FPlanetCircles write FPlanetCircles;
    property UseColorsFirstTurn: boolean read FUseColorsFirstTurn write FUseColorsFirstTurn;
    property UseOneColorOtherPlayers: boolean read FUseOneColorOtherPlayers write FUseOneColorOtherPlayers;
  end;

  PPlayerColorItem = ^TPlayerColorItem;
  TPlayerColorItem = record
    player: TPlayer;
    Color: TColor;
  end;

  TPlayerColors = class(TComponent)
  private
    FPlayersList: TStringList;
    FDefaultColor: TColor;
    procedure SetPlayersList(const Value: TStringList);
    procedure SetAllInfo(const Value: string);
    function GetAllInfo: string;
  public
    procedure Assign(Source: TPersistent); override;
    procedure Clear;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure UpdatePlayers;
    procedure ColorsToPlayers(const useDefault: boolean);
    function GetColor(const player: TPlayer): TColor;
    procedure SetColor(const player: Tplayer; const Color: TColor);
    property DefaultColor: TColor read FDefaultColor write FDefaultColor;
    property PlayersList: TStringList read FPlayersList write SetPlayersList;
  published
    property AllInfo: string read GetAllInfo write SetAllInfo;
  end;

var
  frmChangeColors: TfrmChangeColors;
  CurrentColorSchema: TColorSchema;
  CurrentPlayerColors: TPlayerColors;

implementation

uses UfrmNewMap, UfrmMain, UfrmChangePlayerColors, UFiles;

{$R *.DFM}

procedure TfrmChangeColors.ChangeColorClick(Sender: TObject);
var
  curColor: TColor;
  button: TPanel;
begin
  if Sender is TPanel then begin
    button := TPanel(Sender);
    curColor := button.Color;
    Colordialog1.Color := curColor;
    if Colordialog1.Execute then begin
      button.Color := Colordialog1.Color;
      FormToColorSchema(CurrentColorSchema);
      frmNewMap.Repaint;
    end;
  end;
end;

procedure TfrmChangeColors.FormCreate(Sender: TObject);
begin
  FDoInit := true;
  SetDefaultValue;
  OvcPersistentState1.RestoreState(CurrentColorSchema, 'ColorSettings');
  ColorSchemaToForm(CurrentColorSchema);
  OvcPersistentState1.RestoreState(CurrentPlayerColors, 'ColorSettings_' + GetGameStr);
  CurrentPlayerColors.DefaultColor := CurrentColorSchema.OtherPlayersPlanets;
  CurrentPlayerColors.UpdatePlayers;
  FDoInit := false;
end;


procedure TfrmChangeColors.SetDefaultValue;
begin
  CurrentColorSchema.SetDefault;
  ColorSchemaToForm(CurrentColorSchema);
end;

procedure TfrmChangeColors.RzDialogButtons1ClickHelp(Sender: TObject);
begin
  SetDefaultValue;
  frmNewMap.Repaint;
end;

{ TColorSchema }

procedure TColorSchema.Assign(Source: TPersistent);
begin
  if Source is TColorSchema then begin
    FUseColorsFirstTurn := TColorSchema(Source).UseColorsFirstTurn;
    FUseOneColorOtherPlayers := TColorSchema(Source).UseOneColorOtherPlayers;
    FFirstTurnPlanets := TColorSchema(Source).FirstTurnPlanets;
    FUnInSizeUnk := TColorSchema(Source).UnInSizeUnk;
    FHabSizeUnk := TColorSchema(Source).HabSizeUnk;
    FBackGround := TColorSchema(Source).BackGround;
    FUnInSizeKnown := TColorSchema(Source).UnInSizeKnown;
    FOtherPlayersPlanets := TColorSchema(Source).OtherPlayersPlanets;
    FPlayerPlanets := TColorSchema(Source).PlayerPlanets;
    FNameOfPlanets := TColorSchema(Source).NameOfPlanets;
    FIncomingGroups := TColorSchema(Source).IncomingGroups;
    FIncomingGroupsTrav := TColorSchema(Source).IncomingGroupsTrav;
    FBarSize := TColorSchema(Source).BarSize;
    FBarPopulation := TColorSchema(Source).BarPopulation;
    FBarIndustry := TColorSchema(Source).BarIndustry;
    FCursor := TColorSchema(Source).Cursor;
    FMyTracks := TColorSchema(Source).MyTracks;
    FOtherTracks := TColorSchema(Source).OtherTracks;
    FGroupsUnLoaded := TColorSchema(Source).GroupsUnLoaded;
    FGroupsLoaded := TColorSchema(Source).GroupsLoaded;
    FPlanetCircles := TColorSchema(Source).PlanetCircles;
  end else
    inherited Assign(Source);
end;

procedure TColorSchema.SetDefault;
begin
  BackGround := clBlack;
  UnInSizeUnk := clPurple;
  UnInSizeKnown := clGreen;
  HabSizeUnk := clRed;
  PlayerPlanets := clYellow;
  FirstTurnPlanets := clSilver;
  OtherPlayersPlanets := clBlue;
  UseColorsFirstTurn := true;
  UseOneColorOtherPlayers := true;
  NameOfPlanets := clDkGray;
  IncomingGroups := clWhite;
  IncomingGroupsTrav := clGray;
  BarSize := clRed;
  BarPopulation := clWhite;
  BarIndustry := clBlue;
  Cursor := clWhite;
  MyTracks := clYellow;
  OtherTracks := clWhite;
  GroupsUnLoaded := clRed;
  GroupsLoaded := clBlue;
  PlanetCircles := clRed;
end;

procedure TfrmChangeColors.ColorSchemaToForm(ColorSchema: TColorSchema);
begin
  btnBackGround.Color := ColorSchema.BackGround;
  btnUnInSizeUnk.Color := ColorSchema.UnInSizeUnk;
  btnUnInSizeKnown.Color := ColorSchema.UnInSizeKnown;
  btnHabSizeUnk.Color := ColorSchema.HabSizeUnk;
  btnPlayerPlanets.Color := ColorSchema.PlayerPlanets;
  btnFirstTurnPlanets.Color := ColorSchema.FirstTurnPlanets;
  btnOtherPlayersPlanets.Color := ColorSchema.OtherPlayersPlanets;
  btnCursor.Color := ColorSchema.Cursor;
  cbxUseColorsFirstTurn.Checked := ColorSchema.UseColorsFirstTurn;
  cbxUseOneColorOtherPlayers.Checked := ColorSchema.UseOneColorOtherPlayers;

  btnNameOfPlanets.Color := ColorSchema.NameOfPlanets;
  btnIncomingGroups.Color := ColorSchema.IncomingGroups;
  btnIncomingGroupsTrav.Color := ColorSchema.IncomingGroupsTrav;
  btnBarSize.Color := ColorSchema.BarSize;
  btnBarPopulation.Color := ColorSchema.BarPopulation;
  btnBarIndustry.Color := ColorSchema.BarIndustry;
  btnMyTrack.Color := ColorSchema.MyTracks;
  btnOtherTracks.Color := ColorSchema.OtherTracks;
  btnGroupsLoaded.Color := ColorSchema.GroupsLoaded;
  btnGroupsUnloaded.Color := ColorSchema.GroupsUnLoaded;
  btnPlanetCircles.Color := ColorSchema.PlanetCircles;
end;

procedure TfrmChangeColors.FormToColorSchema(ColorSchema: TColorSchema);
begin
  ColorSchema.BackGround := btnBackGround.Color;
  ColorSchema.UnInSizeUnk := btnUnInSizeUnk.Color;
  ColorSchema.UnInSizeKnown := btnUnInSizeKnown.Color;
  ColorSchema.HabSizeUnk := btnHabSizeUnk.Color;
  ColorSchema.PlayerPlanets := btnPlayerPlanets.Color;
  ColorSchema.FirstTurnPlanets := btnFirstTurnPlanets.Color;
  ColorSchema.OtherPlayersPlanets := btnOtherPlayersPlanets.Color;
  ColorSchema.Cursor := btnCursor.Color;
  ColorSchema.UseColorsFirstTurn := cbxUseColorsFirstTurn.Checked;
  ColorSchema.UseOneColorOtherPlayers := cbxUseOneColorOtherPlayers.Checked;
  ColorSchema.NameOfPlanets := btnNameOfPlanets.Color;
  ColorSchema.IncomingGroups := btnIncomingGroups.Color;
  ColorSchema.IncomingGroupsTrav := btnIncomingGroupsTrav.Color;
  ColorSchema.BarSize := btnBarSize.Color;
  ColorSchema.BarPopulation := btnBarPopulation.Color;
  ColorSchema.BarIndustry := btnBarIndustry.Color;
  ColorSchema.MyTracks := btnMyTrack.Color;
  ColorSchema.OtherTracks := btnOtherTracks.Color;
  ColorSchema.GroupsUnLoaded := btnGroupsUnloaded.Color;
  ColorSchema.GroupsLoaded := btnGroupsLoaded.Color;
  ColorSchema.PlanetCircles := btnPlanetCircles.Color;
  CurrentPlayerColors.ColorsToPlayers(ColorSchema.UseOneColorOtherPlayers);
end;

procedure TfrmChangeColors.FormHide(Sender: TObject);
begin
  if ModalResult = mrOK then begin
    OvcPersistentState1.SaveState(CurrentColorSchema, 'ColorSettings');
    OvcPersistentState1.SaveState(CurrentPlayerColors, 'ColorSettings_' + GetGameStr);
  end;
end;

{ TPlayerColors }

procedure TPlayerColors.Assign(Source: TPersistent);
begin
  if Source is TPlayerColors then begin
    SetPlayersList(TPlayerColors(Source).PlayersList);
  end else
    inherited Assign(Source);
end;

procedure TPlayerColors.Clear;
var
  i: integer;
  PlayerColorItem: PPlayerColorItem;
begin
  for i := 0 to FPlayersList.Count -1 do begin
    PlayerColorItem := PPlayerColorItem(FPlayersList.objects[i]);
    dispose(PlayerColorItem);
  end;
  FPlayersList.Clear;
end;

procedure TPlayerColors.ColorsToPlayers(const useDefault: boolean);
var
  i: integer;
  PlayerColorItem: PPlayerColorItem;
begin
  for i := 0 to FPlayersList.Count -1 do begin
    PlayerColorItem := PPlayerColorItem(FPlayersList.objects[i]);
    if useDefault then
      PlayerColorItem^.player.Color := DefaultColor
    else
      PlayerColorItem^.player.Color := PlayerColorItem^.Color;
  end;
end;

constructor TPlayerColors.Create(AOwner: TComponent);
begin
  inherited Create(Aowner);
  FPlayersList := nil;
  FPlayersList := TStringList.Create;
end;

destructor TPlayerColors.Destroy;
begin
  Clear;
  FPlayersList.Free;
  inherited Destroy;
end;

function TPlayerColors.GetAllInfo: string;
var
  i: integer;
  PlayerColorItem: PPlayerColorItem;
begin
  Result := '';
  for i := 0 to FPlayersList.Count -1 do begin
    PlayerColorItem := PPlayerColorItem(FPlayersList.objects[i]);
    Result := Result + PlayerColorItem^.player.Name + ':' + IntToStr(PlayerColorItem^.Color) + ';';
  end;
end;

function TPlayerColors.GetColor(const player: TPlayer): TColor;
var
  i: integer;
begin
  Result := FDefaultColor;
  for i := 0 to FPlayersList.Count -1 do
    if PPlayerColorItem(FPlayersList.objects[i])^.player = player then
      Result := PPlayerColorItem(FPlayersList.objects[i])^.Color;
end;

procedure TPlayerColors.SetAllInfo(const Value: string);
var
  sPlayer: string;
  sColor: string;
  sLine: string;
  player: TPlayer;
  Color: TColor;
  PlayerColorItem: PPlayerColorItem;
  index: integer;
  i: integer;

  procedure GetNextPlayer(var sLine, sPlayer, sColor: string);
  var
    i: integer;
  begin
    sPlayer := '';
    sColor := '';
    i := 1;
    if sLine = '' then exit;
    while (i <= Length(sLine)) and (sLine[i] <> ':') do inc(i);
    if i <= Length(sLine) then begin
      sPlayer := copy(sLine, 1, i-1);
      delete(sLine, 1, i);
      i := 1;
      while (i <= Length(sLine)) and (sLine[i] <> ';') do inc(i);
      if i <= Length(sLine) then begin
        sColor := copy(sLine, 1, i-1);
        delete(sLine, 1, i);
      end;
    end;
  end;

begin
  sLine := Value;
  if sLine = '' then exit;
  GetNextPlayer(sLine, sPlayer, sColor);
  while (sPlayer <> '') and (sColor <> '') do begin
    player := nil;
    index := players.indexof(lowercase(sPlayer));
    if index = -1 then begin
      for i := 0 to players.Count -1 do begin
        if (pos(sPlayer, TPlayer(players.objects[i]).OldNames) > 0) then
          player := TPlayer(players.objects[i]);
      end;
    end else
      player := TPlayer(players.objects[index]);

    if Assigned(player) then begin
      new(PlayerColorItem);
      try
        Color := TColor(StrToInt(sColor));
        PlayerColorItem^.player := player;
        PlayerColorItem^.Color := Color;
        player.Color := Color;
        FPlayersList.AddObject(lowercase(player.Name), TObject(PlayerColorItem));
      except
        dispose(PlayerColorItem);
      end;
    end;
    GetNextPlayer(sLine, sPlayer, sColor);
  end;
end;

procedure TPlayerColors.SetColor(const player: Tplayer;
  const Color: TColor);
var
  i: integer;
begin
  for i := 0 to FPlayersList.Count -1 do
    if PPlayerColorItem(FPlayersList.objects[i])^.player = player then
      PPlayerColorItem(FPlayersList.objects[i])^.Color := Color;
end;

procedure TPlayerColors.SetPlayersList(const Value: TStringList);
var
  i: integer;
  PlayerColorItem: PPlayerColorItem;
begin
  Clear;
  for i := 0 to Value.Count -1 do begin
    new(PlayerColorItem);
    PlayerColorItem^.player := PPlayerColorItem(Value.objects[i]).player;
    PlayerColorItem^.Color := PPlayerColorItem(Value.objects[i]).Color;
    FPlayersList.AddObject(Value[i], TObject(PlayerColorItem));
  end;
end;

procedure TfrmChangeColors.Button1Click(Sender: TObject);
var
  tmpPlayerColors: TPlayerColors;
begin
  tmpPlayerColors := TPlayerColors.Create(nil);
  try
    tmpPlayerColors.Assign(CurrentPlayerColors);
    if frmChangePlayerColors.ShowModal <> mrOK then
      CurrentPlayerColors.Assign(tmpPlayerColors);
  finally
    tmpPlayerColors.Free;
  end;
end;

procedure TPlayerColors.UpdatePlayers;
var
  i: integer;
  PlayerColorItem: PPlayerColorItem;
begin
  i := 0;
  while i < FPlayersList.Count do
    if players.IndexOf(lowercase(FPlayersList[i])) <> -1 then
      inc(i)
    else begin
      PlayerColorItem := PPlayerColorItem(FPlayersList.objects[i]);
      dispose(PlayerColorItem);
      FPlayersList.Delete(i);
    end;
  for i := 0 to players.Count -1 do
    if FPlayersList.IndexOf(players[i]) = -1 then begin
      new(PlayerColorItem);
      PlayerColorItem^.player := Tplayer(players.objects[i]);
      PlayerColorItem^.Color := FDefaultColor;
      PlayerColorItem^.player.Color := FDefaultColor;
      FPlayersList.AddObject(players[i], TObject(PlayerColorItem));
    end;
end;

procedure TfrmChangeColors.cbxUseColorsFirstTurnClick(Sender: TObject);
begin
  if FDoInit then Exit;
  FormToColorSchema(CurrentColorSchema);
  frmNewMap.Repaint;
end;

initialization
  CurrentColorSchema := nil;
  CurrentPlayerColors := nil;
  CurrentColorSchema := TColorSchema.Create(nil);
  CurrentPlayerColors := TPlayerColors.Create(nil);
  CurrentColorSchema.SetDefault;
finalization
  CurrentColorSchema.Free;
  CurrentPlayerColors.Free;
end.
