unit UfrmChangePlayerColors;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, RzDlgBtn, StdCtrls;

type
  TfrmChangePlayerColors = class(TForm)
    RzDialogButtons1: TRzDialogButtons;
    ScrollBox1: TScrollBox;
    ColorDialog1: TColorDialog;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    procedure ChangeColorClick(Sender: TObject);

    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmChangePlayerColors: TfrmChangePlayerColors;

implementation

{$R *.DFM}

uses
  UfrmChangeColors, UTypes, UfrmNewMap;

procedure TfrmChangePlayerColors.FormShow(Sender: TObject);
var
  i, pos: integer;
  PlayerColorItem: PPlayerColorItem;
  player: TPlayer;
  Color: TColor;
  tmpLabel: TLabel;
  tmpPanel: TPanel;
begin
  pos := 0;
  for i := 0 to CurrentPlayerColors.PlayersList.Count -1 do begin
    PlayerColorItem := PPlayerColorItem(CurrentPlayerColors.PlayersList.objects[i]);
    player := PlayerColorItem^.player;
    if player <> qReportPlayer then begin
      Color := PlayerColorItem^.Color;
      tmpPanel := TPanel.Create(ScrollBox1);
      tmpPanel.Left := 12;
      tmpPanel.Top := pos * 20;
      tmpPanel.Width := 40;
      tmpPanel.Height := 15;
      tmpPanel.Color := Color;
      tmpPanel.parent := ScrollBox1;
      tmpPanel.Tag := integer(PlayerColorItem);
      tmpPanel.OnClick := ChangeColorClick;

      tmpLabel := TLabel.Create(ScrollBox1);
      tmpLabel.Left := 62;
      tmpLabel.Top := pos * 20;
      tmpLabel.Caption := player.Name + '  ('+ player.OldNames + ')';
      tmpLabel.parent := ScrollBox1;
      inc(pos);
    end;
  end;
end;

procedure TfrmChangePlayerColors.ChangeColorClick(Sender: TObject);
var
  button: TPanel;
  PlayerColorItem: PPlayerColorItem;
begin
  if Sender is TPanel then begin
    button := TPanel(Sender);
    Colordialog1.Color := button.Color;
    if Colordialog1.Execute then begin
      button.Color := Colordialog1.Color;
      PlayerColorItem := PPlayerColorItem(button.Tag);
      PlayerColorItem^.Color := button.Color;
      PlayerColorItem^.player.Color := button.Color;
      frmNewMap.Repaint;
    end;
  end;
end;

procedure TfrmChangePlayerColors.FormHide(Sender: TObject);
begin
  while Scrollbox1.ComponentCount > 0 do
    Scrollbox1.Components[0].Free;
end;

end.
