unit UfrmConfigIni;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, RXSpin, inifiles, OvcBase, OvcState, ToolEdit, RzCommon,
  RzLookup, UFiles, RzEdit, RzSpnEdt;

type
  TGameOptions = record
    Gametype: TGametype;
    GameName: string;
    GameDir: string;
    GameExt: string;
    GameFile: string;
    UsedChar: char;
    FileMask: string;
    PlayerName: string;
  end;

  TfrmConfigIni = class(TForm)
    lbxGames: TListBox;
    Label1: TLabel;
    lblDefaultGame: TLabel;
    btnMakeDefault: TButton;
    Label3: TLabel;
    Label5: TLabel;
    edtDirectory: TDirectoryEdit;
    Label6: TLabel;
    edtFileMask: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    edtFileExtension: TEdit;
    edtUsedChars: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    edtTurn0HabitedPlanetsSize: TRxSpinEdit;
    btnClose: TButton;
    btnSave: TButton;
    btnNew: TButton;
    edtName: TEdit;
    Label2: TLabel;
    OvcFormState1: TOvcFormState;
    Label4: TLabel;
    edtUseCountMethod: TRxSpinEdit;
    Label11: TLabel;
    edtTurn0HabitedPlanetsSize2nd: TRxSpinEdit;
    OpenDialog1: TOpenDialog;
    btnCreateShortcutOnDesktop: TButton;
    btnAddAllyTurnReports: TButton;
    RzLookupDialog1: TRzLookupDialog;
    cbxGameType: TComboBox;
    Label12: TLabel;
    edtSkipBattlesUntil: TRzSpinEdit;
    Label13: TLabel;
    edtSkipPlanetsUntil: TRzSpinEdit;
    Label14: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure lbxGamesClick(Sender: TObject);
    procedure btnMakeDefaultClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnNewClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cbxBlindClick(Sender: TObject);
    procedure btnCreateShortcutOnDesktopClick(Sender: TObject);
    procedure btnAddAllyTurnReportsClick(Sender: TObject);
  private
    iniFile: TInifile;
    procedure DoClick(index: integer);
    procedure LeesGame(strGame: string);
    procedure SchrijfGame(strGame: string);
    procedure SetEnables;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmConfigIni: TfrmConfigIni;

function AnalyseFileName(var GameOptions: TGameOptions): boolean;
function GetNewgame(var GameOptions: TGameOptions): boolean;
function SearchGameType(Turn: TStrings; out GameStr: string): TGametype;

procedure CreateShortCutForGame(strGameindex, strGameName: string);

implementation

uses
  HyperStr, xProcs, UfrmMain, mkRegEx, StabUtil;

{$R *.DFM}

procedure TfrmConfigIni.DoClick(index: integer);
begin
  if index = -1 then
    index := 0;
  if index < lbxGames.Items.count then
    LeesGame(lbxGames.Items[index])
  else begin
    edtName.Text := '';
    edtDirectory.InitialDir := '';
    edtDirectory.Text := '';
    edtFilemask.Text := '';
    edtFileExtension.Text := '';
    edtUsedChars.Text := '';
    edtSkipPlanetsUntil.IntValue := 0;
    edtSkipBattlesUntil.IntValue := 0;
    edtTurn0HabitedPlanetsSize.AsInteger := 0;
    edtturn0HabitedPlanetsSize2nd.AsInteger := 0;
    edtUseCountMethod.AsInteger := 3;
    cbxGameType.ItemIndex := 0;
    SetEnables;
  end;
end;

procedure TfrmConfigIni.LeesGame(strGame: string);
var
  strGameType: string;
  i: integer;
begin
  edtName.Text := iniFile.ReadString(strGame, 'Name', '');
  edtDirectory.InitialDir := ExtractFilepath(iniFile.ReadString(strGame, 'spelD', ExtractFilePath(ParamStr(0))));
  edtDirectory.Text := ExtractFilepath(iniFile.ReadString(strGame, 'spelD', ExtractFilePath(ParamStr(0))));
  edtFilemask.Text := ExtractName(iniFile.ReadString(strGame, 'spelD', '%1s%0.03d.txt'));
  edtFileExtension.Text := ExtractFileExt(iniFile.ReadString(strGame, 'spelD', '.txt'));
  edtUsedChars.Text := iniFile.ReadString(strGame, 'spelC', 'k');
  edtSkipPlanetsUntil.IntValue := iniFile.ReadInteger(strGame, 'SkipPlanetsUntilTurn', 0);
  edtSkipBattlesUntil.IntValue := iniFile.ReadInteger(strGame, 'SkipBattlesUntilTurn', 0);
  edtTurn0HabitedPlanetsSize.AsInteger := iniFile.ReadInteger(strGame, 'Turn0HabitedPlanetsSize', 1000);
  edtturn0HabitedPlanetsSize2nd.AsInteger := iniFile.ReadInteger(strGame, 'Turn0HabitedPlanetsSize2nd', 0);
  edtUseCountMethod.AsInteger := iniFile.ReadInteger(strGame, 'UseCountMethod', 3);
  strGameType := iniFile.ReadString(strGame, 'GameType', '');
  cbxGameType.ItemIndex := 0;
  for i := 0 to cbxGameType.Items.Count - 1 do begin
    if CompareText(cbxGameType.Items[i], strGameType) = 0 then
      cbxGameType.ItemIndex := i;
  end;
  SetEnables;
end;

procedure TfrmConfigIni.SchrijfGame(strGame: string);
var
  strSpelD: string;
begin
  inifile.WriteString(strGame, 'Name', edtName.Text);
  strSpelD := strAddSlash(edtDirectory.Text) + edtFilemask.Text + edtFileExtension.Text;
  inifile.WriteString(strGame, 'spelD', strSpelD);
  inifile.WriteString(strGame, 'spelC', edtUsedChars.Text);
  iniFile.WriteInteger(strGame, 'SkipPlanetsUntilTurn', edtSkipPlanetsUntil.IntValue);
  iniFile.WriteInteger(strGame, 'SkipBattlesUntilTurn', edtSkipBattlesUntil.IntValue);
  iniFile.WriteInteger(strGame, 'Turn0HabitedPlanetsSize', edtTurn0HabitedPlanetsSize.AsInteger);
  iniFile.WriteInteger(strGame, 'Turn0HabitedPlanetsSize2nd', edtTurn0HabitedPlanetsSize2nd.AsInteger);
  iniFile.WriteInteger(strGame, 'UseCountMethod', edtUseCountMethod.AsInteger);
  iniFile.WriteString(strGame, 'GameType', cbxGameType.Text);
end;

procedure TfrmConfigIni.FormCreate(Sender: TObject);
var
  gmtp: TGameType;
begin
  inifile := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'MKGal.ini');
  cbxGameType.Items.Clear;
  for gmtp := low(TGameType) to high(TGameType) do
    cbxGameType.Items.Add(SGameStr[gmtp]);
end;

procedure TfrmConfigIni.FormDestroy(Sender: TObject);
begin
  inifile.Free;
end;

procedure TfrmConfigIni.FormShow(Sender: TObject);
var
  list: TStrings;
  i, index: integer;
begin
  lblDefaultGame.Caption := iniFile.ReadString('RUN', 'game', '0');
  list := TStringList.Create;
  try
    inifile.ReadSections(list);
    for i := 0 to list.Count - 1 do
    begin
      if IsNum(list.Strings[i]) then
        lbxGames.Items.Add(list.Strings[i]);
    end;
  finally
    list.Free;
  end;
  index := lbxGames.Items.IndexOf(GetGameStr);
  lbxGames.ItemIndex := index;
  DoClick(index);
end;

procedure TfrmConfigIni.btnCloseClick(Sender: TObject);
begin
  ShowMessage('Restart MKGal, after that the changes will take effect.');
  Close;
end;

procedure TfrmConfigIni.lbxGamesClick(Sender: TObject);
begin
  DoClick(lbxGames.ItemIndex);
end;

procedure TfrmConfigIni.btnMakeDefaultClick(Sender: TObject);
var
  index: integer;
begin
  index := lbxGames.ItemIndex;
  if index <> -1 then
  begin
    inifile.WriteString('RUN', 'game', lbxGames.Items[index]);
    lblDefaultGame.Caption := lbxGames.Items[index];
  end;
end;

procedure TfrmConfigIni.btnSaveClick(Sender: TObject);
var
  index: integer;
begin
  index := lbxGames.ItemIndex;
  if index <> -1 then
    schrijfGame(lbxGames.Items[index]);
end;

procedure TfrmConfigIni.btnNewClick(Sender: TObject);
var
  i, j: integer;
  blnExists: boolean;
  GameOptions: TGameOptions;
begin
  i := 0;
  blnExists := true;
  while blnExists do
  begin
    blnExists := false;
    for j := 0 to lbxGames.Items.Count - 1 do
      if StrtoInt(lbxgames.items[j]) = i then
        blnExists := True;
    if blnExists then inc(i);
  end;
  if GetNewgame(GameOptions) then begin
    if Question(Format('A %s game found:'#13#13 +
      'Name:'#9#9'%s'#13 +
      'Player:'#9#9'%s'#13 +
      'Directory:'#9#9'%s'#13 +
      'File Mask:'#9'%s'#13 +
      'File Ext:'#9#9'%s'#13 +
      'Used Char:'#9'%s', [SGameStr[GameOptions.Gametype],
      GameOptions.GameName,
        GameOptions.PlayerName,
        GameOptions.GameDir,
        GameOptions.FileMask,
        GameOptions.GameExt,
        GameOptions.UsedChar]) + #13#13 +
        'Do you want to add a entry for it?') then
    begin
      i := lbxGames.Items.Add(IntToStr(i));
      lbxGames.ItemIndex := i;
      edtName.Text := GameOptions.GameName;
      edtDirectory.InitialDir := GameOptions.GameDir;
      edtDirectory.Text := GameOptions.GameDir;
      edtFileMask.Text := GameOptions.FileMask;
      edtFileExtension.Text := GameOptions.GameExt;
      edtUsedChars.Text := GameOptions.UsedChar;
      cbxGameType.ItemIndex := ord(GameOptions.Gametype);
      edtSkipPlanetsUntil.IntValue := 0;
      edtSkipBattlesUntil.IntValue := 0;

      if GameOptions.Gametype = gtGalaxyNG then begin
        edtUseCountmethod.AsInteger := 3;
        edtTurn0HabitedPlanetsSize2nd.AsInteger := 400;
      end else begin
        edtUseCountmethod.AsInteger := 0;
        edtTurn0HabitedPlanetsSize2nd.AsInteger := 0;
      end;
      edtTurn0HabitedPlanetsSize.AsInteger := 1000;
      edtTurn0HabitedPlanetsSize2nd.AsInteger := 400;
      SetEnables;
      schrijfGame(IntToStr(i));

      if Question('Do you want to create a Shortcut on the desktop for this game?') then
        CreateShortCutForGame(IntToStr(i), edtName.Text + ' ' + GameOptions.PlayerName);
    end;
  end;
end;

procedure TfrmConfigIni.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if OvcFormState1.Active then begin
    WindowState := wsMinimized;
    CanClose := false;
  end;
end;

procedure TfrmConfigIni.SetEnables;
begin
  edtTurn0HabitedPlanetsSize.Enabled := cbxGameType.Text <> SGameStr[gtGalaxyBlind]; // not cbxBlind.Checked;
  edtTurn0HabitedPlanetsSize2nd.Enabled := cbxGameType.Text <> SGameStr[gtGalaxyBlind]; //not cbxBlind.Checked;
  edtUseCountMethod.Enabled := cbxGameType.Text <> SGameStr[gtGalaxyBlind]; //not cbxBlind.Checked;
  edtTurn0HabitedplanetsSize2nd.Enabled := edtUseCountMethod.AsInteger > 0;
end;

procedure TfrmConfigIni.cbxBlindClick(Sender: TObject);
begin
  SetEnables;
end;

function SearchGameType(Turn: TStrings; out GameStr: string): TGametype;
const
  SearchNormal = '(^\W*Galaxy Game \w+ \w+ \w+ \w+)';
  SearchBlind = '(^\W*Blind Galaxy game)';
  SearchPLUS = '(^\W*\w+ Report for Galaxy PLUS)';
  SearchNG = '^\W*GalaxyNG release';
  SearchNGBlind = '(^\W*GalaxyNG-Blind Game)';
  SearchLines = SearchNormal + '|' + SearchBlind + '|' + SearchPLUS + '|' +
                SearchNGBlind;
var
  i: integer;
  mkreExpr: TmkreExpr;
begin
{
 Galaxy Game Cluster Turn 0 Report for Nation_10
-----
 Galaxy Game Earth Turn 0 Report for Nation_10
-----
 Galaxy Game FrogStar Turn 0 Report for Nation_5
-----


^\W*Galaxy Game \w \w \w
}

{
 Blind Galaxy game Andromeda Report for Kryst, Turn 0
-----
        Blind Galaxy game Hercules Report for Ducks, Turn 0


^\W*Blind Galaxy game
}
{
         Keepers Report for Galaxy PLUS game42 Turn 0 Thu Apr 11 01:45:03 1996

^\W*\w+ Report for Galaxy PLUS
}
  Result := gtUnknown;
  mkreExpr := TmkreExpr.Create(nil);
  try
    GameStr := '';
    mkreExpr.Pattern := SearchLines;
    for i := 0 to turn.Count - 1 do begin
      mkreExpr.Str := turn[i];
      if mkreExpr.DoSearch(1) > 0 then begin
        GameStr := trim(turn[i]);
        break;
      end;
    end;
    if GameStr <> '' then begin
      mkreExpr.Str := GameStr;
      mkreExpr.Pattern := SearchNormal;
      if mkreExpr.DoSearch(1) > 0 then begin
        Result := gtGalaxyNormal;
        mkreExpr.Pattern := SearchNG;
        for i := 0 to turn.Count - 1 do begin
          mkreExpr.Str := turn[i];
          if mkreExpr.DoSearch(1) > 0 then begin
            Result := gtGalaxyNG;
            break;
          end;
        end;
      end else begin
        mkreExpr.Pattern := SearchBlind;
        if mkreExpr.DoSearch(1) > 0 then begin
          Result := gtGalaxyBlind;
        end else begin
          mkreExpr.Pattern := SearchPLUS;
          if mkreExpr.DoSearch(1) > 0 then begin
            Result := gtGalaxyPLUS;
          end else begin
            mkreExpr.Pattern := SearchNGBlind;
            if mkreExpr.DoSearch(1) > 0 then begin
              Result := gtGalaxyNGBlind;
            end;
          end;
        end;
      end;
    end;
  finally
    mkreExpr.Free;
  end;
end;

function GetNewgame(var GameOptions: TGameOptions): boolean;
var
  FileName: string;
  FileStr: string;
  GameStr: string;
  report: TStringList;
  GameNamePos: integer;
  playernamePos: integer;
  table: string;
begin
  Result := False;
  if not frmConfigIni.OpenDialog1.Execute then Exit;
  FileName := frmConfigIni.OpenDialog1.FileName;
  if not FileExists(FileName) then Exit;
  table := BuildTable(#32 + ',');

  report := TStringList.Create;
  try
    report.LoadFromFile(FileName);
    FileStr := report.GetText;
    ReplaceC(FileStr, #$A0, #$20);
    report.SetText(PChar(FileStr));

    GameOptions.Gametype := SearchGameType(report, GameStr);
    GameOptions.GameDir := ExtractFilePath(FileName);
    GameOptions.GameExt := ExtractFileExt(FileName);
    GameOptions.GameFile := ExtractName(FileName);
    if not AnalyseFileName(GameOptions) then begin
      GameOptions.FileMask := '%1s%0.03d';
      GameOptions.UsedChar := #0;
    end;

    case GameOptions.Gametype of
      gtGalaxyNormal: begin GameNamePos := 3; playernamePos := 8; end;
      gtGalaxyNG: begin GameNamePos := 3; playernamePos := 8; end;
      gtGalaxyBlind: begin GameNamePos := 4; playernamePos := 7; end;
      gtGalaxyPLUS: begin GameNamePos := 6; playernamePos := 1; end;
      gtGalaxyNGBlind: begin GameNamePos := 3; playernamePos := 8; end;
    else
      ShowMessage(SGameStr[GameOptions.Gametype] + ' if you are sure this is a galaxy turn report, please contact the author');
      Exit;
    end;

    GameOptions.GameName := Fetch(GameStr, table, GameNamePos, False);
    GameOptions.PlayerName := Fetch(GameStr, table, playernamePos, False);
    if CompareText(GameOptions.PlayerName, 'Player') = 0 then begin
      GameOptions.PlayerName := GameOptions.PlayerName + '_' + Fetch(GameStr, table, playernamePos + 1, False);
    end else
      if CompareText(GameOptions.PlayerName, 'Player') = 0 then begin
        GameOptions.PlayerName := GameOptions.PlayerName + '_' + Fetch(GameStr, table, playernamePos + 1, False);
      end;
    Result := True;
  finally
    report.Free;
  end;
end;

function AnalyseFileName(var GameOptions: TGameOptions): boolean;
var
  mkreExpr: TmkreExpr;
begin
  Result := false;
  mkreExpr := TmkreExpr.Create(nil);
  try
    mkreExpr.Str := GameOptions.GameFile;
    mkreExpr.Pattern := '^[a-zA-Z][0-9][0-9][0-9]$';
    if mkreExpr.DoSearch(1) > 0 then begin
      GameOptions.FileMask := '%1s%0.03d';
      GameOptions.UsedChar := GameOptions.GameFile[1];
      Result := True;
      Exit;
    end;
    mkreExpr.Pattern := '^([a-zA-Z])+[0-9]$';
    if mkreExpr.DoSearch(1) > 0 then begin
      if length(GameOptions.GameFile) > 2 then
        GameOptions.FileMask := '%1s' + copy(GameOptions.GameFile, 2, length(GameOptions.GameFile) - 2) + '%d'
      else
        GameOptions.FileMask := '%1s%d';
      GameOptions.UsedChar := GameOptions.GameFile[1];
      Result := True;
      Exit;
    end;
    mkreExpr.Pattern := '^([a-zA-Z])+[0-9][0-9]$';
    if mkreExpr.DoSearch(1) > 0 then begin
      if length(GameOptions.GameFile) > 3 then
        GameOptions.FileMask := '%1s' + copy(GameOptions.GameFile, 2, length(GameOptions.GameFile) - 3) + '%0.02d'
      else
        GameOptions.FileMask := '%1s%0.02d';
      GameOptions.UsedChar := GameOptions.GameFile[1];
      Result := True;
      Exit;
    end;
  finally
    mkreExpr.Free;
  end;
end;

procedure TfrmConfigIni.btnCreateShortcutOnDesktopClick(Sender: TObject);
var
  index: integer;
begin
  index := lbxGames.ItemIndex;
  if index <> -1 then
    CreateShortCutForGame(lbxGames.Items[index], edtName.Text);
end;

procedure CreateShortCutForGame(strGameindex, strGameName: string);
begin
  CreateLink(strGameindex, 'MKGal ' + strGameName, '', 0, 0, strAddSlash(GetDeskTopPath(True)) + 'MKGal ' + strGameName + '.lnk', ParamStr(0), wsNormal, ExtractFilePath(ParamStr(0)));
end;

procedure TfrmConfigIni.btnAddAllyTurnReportsClick(Sender: TObject);
var
  i, index: integer;
  strReportNames: string;
  ch: char;
begin
  index := lbxGames.ItemIndex;
  if index = -1 then exit;

  if Question('To add turn reports of your ally, you must choose a character to identify them.'#13#13 +
    'Do you want to proceed?') then begin
    RzLookupDialog1.List.Clear;
    for i := ord('a') to ord('z') do begin
      if pos(char(i), edtUsedChars.Text) < 1 then
        RzLookupDialog1.List.Add(char(i));
    end;
    RzLookupDialog1.SearchString := RzLookupDialog1.List[0];
    if RzLookupDialog1.Execute then begin
      try
        ch := RzLookupDialog1.SelectedItem[1];
        for i := 0 to 10 do begin
          if strReportNames <> '' then strReportNames := strReportNames + #13;
          strReportNames := strReportNames + Format(edtFileMask.Text + edtFileExtension.text, [ch, i]);
        end;
        ShowMessage('Reporst must be saved in the same directory as your own reports.' + #13 +
          'Use the following style to name the reports:'#13#13 +
          strReportNames);
        edtUsedChars.Text := edtUsedChars.Text + ch;
        schrijfGame(lbxGames.Items[index]);
      except
        ;
      end;
    end;
  end;
end;

end.
