unit UfrmExpressionFilters;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OvcState, StdCtrls, OvcBase, ExtCtrls, RzDlgBtn, UTypes;

type
  TfrmExpressionFilters = class(TForm)
    RzDialogButtons1: TRzDialogButtons;
    OvcComponentState1: TOvcComponentState;
    RadioGroup1: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RzDialogButtons1ClickOk(Sender: TObject);
  private
    FFilteredplanets: Tlist;
    FExpression: string;
    { Private declarations }
  public
    property Filteredplanets: Tlist read FFilteredplanets;
    property Expression: string read FExpression write FExpression;
    procedure ClearFilteredPlanets;
    procedure DoFiltering;
    function DoExprGRforGroup(group: TObject): boolean;
    function DoExprPTForPlanet(planet: Tplanet): boolean;
    { Public declarations }
  end;

const
  SGROUPEXPR = '[PLAYERNAME]'#9#9#9'Name of player'#13#10 +
    '[GR_COUNT]'#9#9#9'Number of ships in group'#13#10 +
    '[GR_AVAILABLE]'#9#9'Number of ships in group available to send'#13#10 +
    '[GR_NAME]'#9#9#9'Owner Name of Group'#13#10 +
    '[GR_OWNERWAR]'#9#9'Is Owner of Group set to war with you'#13#10 +
    '[GR_TURN]'#9#9#9'Turn number of group (seen in turn)'#13#10 +
    '[GR_RANGE]'#9#9#9'Distance of group from destination'#13#10 +
    '[GR_DRIVETECH]'#9#9'Drive tech used for group'#13#10 +
    '[GR_WEAPONSTECH]'#9#9'Weapon tech used for group'#13#10 +
    '[GR_SHIELDSTECH]'#9#9'Shields tech used for group'#13#10 +
    '[GR_CARGOTECH]'#9#9'Cargo tech used for group'#13#10 +
    '[GR_LOAD]'#9#9#9'Amount of cargo loaded to group'#13#10 +
    '[GR_EFFCARGO]'#9#9'Effective cargo space of ships in group'#13#10 +
    '[GR_EFFWEAPON]'#9#9'Effective weapon strenght'#13#10 +
    '[GR_EFFSHIELD]'#9#9'Effective shield strenght'#13#10 +
    '[GR_EFFSHIELDLOADED]'#9'Effective shield strenght when loaded'#13#10 +
    '[GR_EFFSPEED]'#9#9'Effective speed'#13#10 +
    '[GR_EFFSPEEDLOADED]'#9'Effective speed when loaded'#13#10 +
    '[GR_EFFSPEEDNOW]'#9#9'Current speed of group'#13#10 +
    '[GR_FLEETNAME]'#9#9'Name of Fleet'#13#10 +
    '[GR_UPGRADECOST]'#9#9'Costs of upgrade to current techlevels per ship'#13#10 +
    '[GR_ETA]'#9#9#9#9'Number of turns needed to reach destination'#13#10 +
    '[GR_SOURCE]'#9#9#9'Name of planet that group came from'#13#10 +
    '[GR_DESTINATION]'#9#9'Name of planet that group will fly to'#13#10 +
    '[GR_ETA]'#9#9#9#9'Number of turns needed to reach destination'#13#10 +
    '[PT_NAME]'#9#9#9'Name of planet where group is'#13#10 +
    '[PT_OWNERNAME]'#9#9'Name of owner of planet where group is'#13#10 +
    '[PT_X]'#9#9#9#9'X position of planet'#13#10 +
    '[PT_Y]'#9#9#9#9'Y position of planet'#13#10 +
    '[PT_SIZE]'#9#9#9'Size of planet'#13#10 +
    '[PT_RES]'#9#9#9'Resources of planet'#13#10 +
    '[PT_POPULATION]'#9#9'Current population of planet'#13#10 +
    '[PT_INDUSTRY]'#9#9'Current industry of planet'#13#10 +
    '[PT_EFFINDUSTRY]'#9#9'Effective industry of planet'#13#10 +
    '[PT_EFFMASS]'#9#9#9'Ability to produce this amount of ship mass on planet'#13#10 +
    '[PT_CAP]'#9#9#9'Current capital stockpiles on planet'#13#10 +
    '[PT_MAT]'#9#9#9'Current material stockpiles on planet'#13#10 +
    '[PT_COL]'#9#9#9'Current colonist stockpiles on planet'#13#10 +
    '[PT_MYMASS]'#9#9#9'My total groups mass on planet'#13#10 +
    '[PT_FRIENDLYMASS]'#9#9'Friendly total groups mass on planet'#13#10 +
    '[PT_ENEMYMASS]'#9#9'Enemy total groups mass on planet'#13#10 +
    '[PT_SENTMASS]'#9#9'My total groups mass of groups that will arive next turn on planet'#13#10 +
    '[PT_SENTMASSETA2]'#9#9'My total groups mass of groups that will arive in two turns on planet'#13#10 +
    '[PT_SENTMASSETA3PLUS]'#9#9'My total groups mass of groups that will arive in three or more turns on planet'#13#10 +
    '[PT_PRODTYPE]'#9#9'Was produced this turn on planet'#13#10 +
    '[PT_PRODAMOUNT]'#9#9'Will produce this amount this turn on planet'#13#10 +
    '[PT_PRODAMOUNTFULL]'#9'Will produce this amount on planet when full developed'#13#10 +
    '[ST_NOSTATIONARY]'#9#9'Shiptype is intended to move'#13#10 +
    '[ST_DRIVEMASS]'#9#9'Mass used for drives'#13#10 +
    '[ST_ATTACKSCOUNT]'#9#9'Number of attacks'#13#10 +
    '[ST_WEAPONSMASS]'#9#9'Weapons '#13#10 +
    '[ST_SHIELDSMASS]'#9#9'Mass used for shields'#13#10 +
    '[ST_CARGOMASS]'#9#9'Mass used for cargo'#13#10 +
    '[ST_MASS]'#9#9#9'Total mass'#13#10 +
    '[ST_NAME]'#9#9#9'Name of shiptype';

  SPLANETEXPR =
    '[PLAYERNAME]'#9#9#9'Name of player'#13#10 +
    '[PT_X]'#9#9#9#9'X position of planet'#13#10 +
    '[PT_Y]'#9#9#9#9'Y position of planet'#13#10 +
    '[PT_SIZE]'#9#9#9'Size of planet'#13#10 +
    '[PT_RES]'#9#9#9'Resources of planet'#13#10 +
    '[PT_POPULATION]'#9#9'Current population of planet'#13#10 +
    '[PT_INDUSTRY]'#9#9'Current industry of planet'#13#10 +
    '[PT_EFFINDUSTRY]'#9#9'Effective industry of planet'#13#10 +
    '[PT_EFFMASS]'#9#9#9'Ability to produce this amount of ship mass on planet'#13#10 +
    '[PT_CAP]'#9#9#9'Current capital stockpiles on planet'#13#10 +
    '[PT_MAT]'#9#9#9'Current material stockpiles on planet'#13#10 +
    '[PT_COL]'#9#9#9'Current colonist stockpiles on planet'#13#10 +
    '[PT_MYMASS]'#9#9#9'My total groups mass on planet'#13#10 +
    '[PT_FRIENDLYMASS]'#9#9'Friendly total groups mass on planet'#13#10 +
    '[PT_ENEMYMASS]'#9#9'Enemy total groups mass on planet'#13#10 +
    '[PT_SENTMASS]'#9#9'My total groups mass of groups that will arive next turn on planet'#13#10 +
    '[PT_SENTMASSETA2]'#9#9'My total groups mass of groups that will arive in two turns on planet'#13#10 +
    '[PT_SENTMASSETA3PLUS]'#9#9'My total groups mass of groups that will arive in three or more turns on planet'#13#10 +
    '[PT_PRODTYPE]'#9#9'Was produced this turn on planet'#13#10 +
    '[PT_PRODAMOUNT]'#9#9'Will produce this amount this turn on planet'#13#10 +
    '[PT_PRODAMOUNTFULL]'#9'Will produce this amount on planet when full developed'#13#10 +
    '[PT_NAME]'#9#9#9'Name of planet'#13#10 +
    '[PT_LASTOWNERNAME]'#9'Name of last known owner';

var
  frmExpressionFilters: TfrmExpressionFilters;
  gDoGroupInverse: boolean;
  gDoPlanetInverse: boolean;


function DoExprGroup(Expression: string; gr: TObject): integer;
function DoExprPlanet(Expression: string; PT: TPlanet): integer;

function EvalGroupCallback(wparam: word; lparam: longint): longint; stdcall;
function EvalPlanetCallback(wparam: word; lparam: longint): longint; stdcall;

implementation

uses
  UfrmMain, eval32, HyperStr, UfrmOrders, mkStrUtils, UfrmSelectExpression;

{$R *.DFM}

function EvalGroupCallback(wparam: word; lparam: longint): longint; stdcall;
var
  strPlanet1,
    strPlanet2: string;
  planet1,
    planet2: TPlanet;
  group: TGroup;
  extX, extY, extX1, extY1: single;
begin
  Result := res_error;
  case wparam of
    ep_Var:
      begin
        if TObject(PEvalVar(lparam)^.lpUserParams) is TGroup then
          group := TGroup(PEvalVar(lparam)^.lpUserParams)
        else begin
          if not (TObject(PEvalVar(lparam)^.lpUserParams) is TSendedGroup) then exit;
          group := TSendedGroup(PEvalVar(lparam)^.lpUserParams).orgGroup;
          group.SourcePlanet := TSendedGroup(PEvalVar(lparam)^.lpUserParams).sendFrom;
          group.DestPlanet := TSendedGroup(PEvalVar(lparam)^.lpUserParams).sendTo;
          group.ETA := TSendedGroup(PEvalVar(lparam)^.lpUserParams).ETA;
        end;
        with PEvalVar(lparam)^ do begin
          if StrLComp(lpszName, 'GR_COUNT]', 9) = 0 then begin
            rcVal.dwType := res_Numeric;
            if TObject(lpUserParams) is TGroup then
              rcVal.xValue := group.Aantal
            else
              rcVal.xValue := TSendedGroup(lpUserParams).sendAantal;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_ETA]', 7) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.ETA;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_DESTINATION]', 15) = 0 then begin
            rcVal.dwType := res_Text;
            rcVal.lpszValue := nil;
            rcVal.dwLength := 0;
            if Assigned(group.DestPlanet) then begin
              wparam := Length(group.DestPlanet.Name);
              if wparam <> 0 then begin
                rcVal.dwLength := wparam;
                try
                  GetMem(rcVal.lpszValue, wparam + 1)
                except
                  exit
                end;
                StrPCopy(rcVal.lpszValue, group.DestPlanet.Name);
              end;
            end;
            Result := res_Text;
          end else if StrLComp(lpszName, 'GR_SOURCE]', 10) = 0 then begin
            rcVal.dwType := res_Text;
            rcVal.lpszValue := nil;
            rcVal.dwLength := 0;
            if Assigned(group.SourcePlanet) then begin
              wparam := Length(group.SourcePlanet.Name);
              if wparam <> 0 then begin
                rcVal.dwLength := wparam;
                try
                  GetMem(rcVal.lpszValue, wparam + 1)
                except
                  exit
                end;
                StrPCopy(rcVal.lpszValue, group.SourcePlanet.Name);
              end;
            end;
            Result := res_Text;
          end else if StrLComp(lpszName, 'GR_AVAILABLE]', 13) = 0 then begin
            rcVal.dwType := res_Numeric;
            if TObject(lpUserParams) is TGroup then
              rcVal.xValue := GetMaxToSend(group)
            else begin
              if (TSendedGroup(lpUserParams).sendToGo = 0) then
                rcVal.xValue := GetMaxToSend(group)
              else
                rcVal.xValue := 0;
            end;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_TURN]', 8) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Turn;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_RANGE]', 9) = 0 then begin
            rcVal.dwType := res_Numeric;
            if TObject(lpUserParams) is TGroup then
              rcVal.xValue := group.Range
            else
              rcVal.xValue := TSendedGroup(lpUserParams).sendToGo;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_WEAPONSTECH]', 15) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.WeaponsTech;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_SHIELDSTECH]', 15) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.ShieldsTech;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_CARGOTECH]', 13) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.CargoTech;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_LOAD]', 8) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Lading;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_EFFCARGO]', 12) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.EffCargo;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_EFFWEAPON]', 13) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.EffWeapon;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_EFFSHIELD]', 13) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.EffShield;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_EFFSHIELDLOADED]', 18) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.EffShieldLoaded;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_EFFSPEED]', 12) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.EffSpeed;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_EFFSPEEDLOADED]', 18) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.EffSpeedLoaded;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_EFFSPEEDNOW]', 15) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.EffSpeedNow;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_UPGRADECOST]', 15) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.UpgradeCost;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'GR_FLEETNAME]', 13) = 0 then begin
            rcVal.dwType := res_Text;
            wparam := Length(group.FleetName);
            if wparam <> 0 then begin
              try
                GetMem(rcVal.lpszValue, wparam + 1)
              except
                exit
              end;
              StrPCopy(rcVal.lpszValue, group.FleetName);
            end else
              rcVal.lpszValue := nil;
            rcVal.dwLength := wparam;
            Result := res_Text;
          end else if StrLComp(lpszName, 'PLAYERNAME]', 11) = 0 then begin
            rcVal.dwType := res_Text;
            wparam := Length(qReportPlayer.Name);
            if wparam <> 0 then begin
              try
                GetMem(rcVal.lpszValue, wparam + 1)
              except
                exit
              end;
              StrPCopy(rcVal.lpszValue, qReportPlayer.Name);
            end else
              rcVal.lpszValue := nil;
            rcVal.dwLength := wparam;
            Result := res_Text;
          end else if StrLComp(lpszName, 'GR_OWNERWAR]', 12) = 0 then begin
            rcVal.dwType := res_Boolean;
            if group.Player.war then rcVal.xValue := 1.0
                                else rcVal.xValue := 0.0;
            Result := res_Boolean;
          end else if StrLComp(lpszName, 'GR_NAME]', 8) = 0 then begin
            rcVal.dwType := res_Text;
            wparam := Length(group.Player.Name);
            if wparam <> 0 then begin
              try
                GetMem(rcVal.lpszValue, wparam + 1)
              except
                exit
              end;
              StrPCopy(rcVal.lpszValue, group.Player.Name);
            end else
              rcVal.lpszValue := nil;
            rcVal.dwLength := wparam;
            Result := res_Text;
          end else if StrLComp(lpszName, 'PT_X]', 5) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.X / 100;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_Y]', 5) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.Y / 100;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_SIZE]', 8) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.Size;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_RES]', 7) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.Resources;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_POPULATION]', 14) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.PopulationCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_INDUSTRY]', 12) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.IndustryCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_EFFINDUSTRY]', 15) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.EffIndustryCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_EFFMASS]', 11) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.EffMassProduceCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_CAP]', 7) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.CapitalCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_MAT]', 7) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.MaterialCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_COL]', 7) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.ColonistCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_MYMASS]', 10) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.MyShipMass;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_FRIENDLYMASS]', 16) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.FriendShipMass;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_ENEMYMASS]', 13) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.EnemyShipMass;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_SENTMASS]', 12) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.SendedShipMass;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_SENTMASSETA2]', 16) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.SendedShipMassETA2;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_SENTMASSETA3PLUS]', 20) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group.Planet.SendedShipMassETA2Plus;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_NAME]', 8) = 0 then begin
            rcVal.dwType := res_Text;
            rcVal.lpszValue := nil;
            rcVal.dwLength := 0;
            if integer(group.Planet) > 1 then begin
              wparam := Length(group.Planet.Name);
              if wparam <> 0 then begin
                rcVal.dwLength := wparam;
                try
                  GetMem(rcVal.lpszValue, wparam + 1)
                except
                  exit
                end;
                StrPCopy(rcVal.lpszValue, group.Planet.Name);
              end;
            end;
            Result := res_Text;
          end else if StrLComp(lpszName, 'PT_PRODTYPE]', 12) = 0 then begin
            rcVal.dwType := res_Text;
            rcVal.lpszValue := nil;
            rcVal.dwLength := 0;
            if integer(TGroup(lpUserParams).Planet) > 1 then begin
              wparam := Length(group.Planet.ProduceType);
              if wparam <> 0 then begin
                rcVal.dwLength := wparam;
                try
                  GetMem(rcVal.lpszValue, wparam + 1)
                except
                  exit
                end;
                StrPCopy(rcVal.lpszValue, uppercase(group.Planet.ProduceType));
              end;
            end;
            Result := res_Text;
          end else if StrLComp(lpszName, 'PT_OWNERNAME]', 13) = 0 then begin
            rcVal.dwType := res_Text;
            rcVal.lpszValue := nil;
            rcVal.dwLength := 0;
            if integer(TGroup(lpUserParams).Planet) > 1 then begin
              wparam := Length(group.Planet.LastOwnerName);
              if wparam <> 0 then begin
                rcVal.dwLength := wparam;
                try
                  GetMem(rcVal.lpszValue, wparam + 1)
                except
                  exit
                end;
                StrPCopy(rcVal.lpszValue, group.Planet.LastOwnerName);
              end;
            end;
            Result := res_Text;
          end else if StrLComp(lpszName, 'ST_NOSTATIONARY]', 16) = 0 then begin
            rcVal.dwType := res_Boolean;
            if TShipType(lpUserParams).IsStationary then
              rcVal.xValue := 0
            else
              rcVal.xValue := 1;
            Result := res_Boolean;
          end else if StrLComp(lpszName, 'ST_DRIVEMASS]', 13) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group._Type.Drive;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'ST_ATTACKSCOUNT]', 16) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group._Type.Attacks;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'ST_WEAPONSMASS]', 15) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group._Type.Weapons;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'ST_SHIELDSMASS]', 15) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group._Type.Shields;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'ST_CARGOMASS]', 13) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group._Type.Cargo;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'ST_MASS]', 8) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := group._Type.Mass;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'ST_NAME]', 8) = 0 then begin
            rcVal.dwType := res_Text;
            wparam := Length(group._Type.Name);
            if wparam <> 0 then begin
              try
                GetMem(rcVal.lpszValue, wparam + 1)
              except
                exit
              end;
              StrPCopy(rcVal.lpszValue, group._Type.Name);
            end else
              rcVal.lpszValue := nil;
            rcVal.dwLength := wparam;
            Result := res_Text;
          end;
        end;
      end;
    ep_Func:
      begin
        with TEvalFunc(pointer(lparam)^) do begin
          if StrLComp(lpszName, 'DISTANCE(', 9) = 0 then begin
            if lpParams = nil then begin
             { At first call lpParams=nil: it means that Eval32 checks argument number}
              if dwParamCount = 2 then Result := 0
            end else if (lpParams^[1].dwType = res_Text) and (lpParams^[1].lpszValue <> nil) and
              (lpParams^[2].dwType = res_Text) and (lpParams^[2].lpszValue <> nil) then
            begin
              strPlanet1 := lpParams^[1].lpszValue;
              strPlanet2 := lpParams^[2].lpszValue;
              planet1 := FindPlanetWithname(strPlanet1);
              planet2 := FindPlanetWithname(strPlanet2);
              if not Assigned(planet1) or not Assigned(planet2) then begin
                Result := res_Error;
                Exit;
              end;
              extX := planet1.X;
              extY := planet1.Y;
              extX1 := planet2.X;
              extY1 := planet2.Y;
              rcRes.xValue := sqrt((extX - extX1) * (extX - extX1) + (extY - extY1) * (extY - extY1)) / 100;
              rcRes.dwType := res_Numeric;
              Result := res_Numeric
            end;
            exit
          end;
          if StrLComp(lpszName, 'ATOI(', 5) = 0 then begin
            if lpParams = nil then begin
             { At first call lpParams=nil: it means that Eval32 checks argument number}
              if dwParamCount = 1 then Result := 0
            end else if (lpParams^[1].dwType = res_Text) and (lpParams^[1].lpszValue <> nil) then
            begin
              strPlanet1 := lpParams^[1].lpszValue;
              rcRes.xValue := mkAtoI(strPlanet1);
              rcRes.dwType := res_Numeric;
              Result := res_Numeric
            end;
            exit
          end;
          if StrLComp(lpszName, 'INVERT(', 7) = 0 then begin
            if lpParams = nil then begin
             { At first call lpParams=nil: it means that Eval32 checks argument number}
              if dwParamCount = 1 then Result := 0
            end else begin
              gDoGroupInverse := true;
              rcRes.dwType    := lpParams^[1].dwType;
              rcRes.xValue    := lpParams^[1].xValue;
              rcRes.lpszValue := lpParams^[1].lpszValue;
              rcRes.dwLength  := lpParams^[1].dwLength;
              rcRes.dtValue   := lpParams^[1].dtValue;
              Result := lpParams^[1].dwType;
            end;
            exit
          end;
        end;
      end;
  end;
end;

function EvalPlanetCallback(wparam: word; lparam: longint): longint; stdcall;
var
  strPlanet1,
    strPlanet2: string;
  planet1,
    planet2: TPlanet;
  extX, extY, extX1, extY1: single;
begin
  Result := res_error;
  case wparam of
    ep_Var:
      begin
        with PEvalVar(lparam)^ do begin
          if StrLComp(lpszName, 'PT_X]', 5) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).X / 100;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_Y]', 5) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).Y / 100;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_SIZE]', 8) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).Size;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_RES]', 7) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).Resources;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_POPULATION]', 14) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).PopulationCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_INDUSTRY]', 12) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).IndustryCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_EFFINDUSTRY]', 15) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).EffIndustryCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_EFFMASS]', 11) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).EffMassProduceCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_PRODAMOUNT]', 13) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).ProduceAmount;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_PRODAMOUNTFULL]', 17) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).ProduceAmountFull;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_CAP]', 7) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).CapitalCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_MAT]', 7) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).MaterialCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_COL]', 7) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).ColonistCur;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_MYMASS]', 10) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).MyShipMass;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_FRIENDLYMASS]', 16) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).FriendShipMass;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_ENEMYMASS]', 13) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).EnemyShipMass;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_SENTMASS]', 12) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).SendedShipMass;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_SENTMASSETA2]', 16) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).SendedShipMassETA2;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_SENTMASSETA3PLUS]', 20) = 0 then begin
            rcVal.dwType := res_Numeric;
            rcVal.xValue := TPlanet(lpUserParams).SendedShipMassETA2Plus;
            Result := res_Numeric;
          end else if StrLComp(lpszName, 'PT_LASTOWNERNAME]', 17) = 0 then begin
            rcVal.dwType := res_Text;
            wparam := Length(TPlanet(lpUserParams).LastOwnerName);
            if wparam <> 0 then begin
              try
                GetMem(rcVal.lpszValue, wparam + 1)
              except
                exit
              end;
              StrPCopy(rcVal.lpszValue, TPlanet(lpUserParams).LastOwnerName);
            end else
              rcVal.lpszValue := nil;
            rcVal.dwLength := wparam;
            Result := res_Text;
          end else if StrLComp(lpszName, 'PLAYERNAME]', 11) = 0 then begin
            rcVal.dwType := res_Text;
            wparam := Length(qReportPlayer.Name);
            if wparam <> 0 then begin
              try
                GetMem(rcVal.lpszValue, wparam + 1)
              except
                exit
              end;
              StrPCopy(rcVal.lpszValue, qReportPlayer.Name);
            end else
              rcVal.lpszValue := nil;
            rcVal.dwLength := wparam;
            Result := res_Text;
          end else if StrLComp(lpszName, 'PT_NAME]', 8) = 0 then begin
            rcVal.dwType := res_Text;
            wparam := Length(TPlanet(lpUserParams).Name);
            if wparam <> 0 then begin
              try
                GetMem(rcVal.lpszValue, wparam + 1)
              except
                exit
              end;
              StrPCopy(rcVal.lpszValue, TPlanet(lpUserParams).Name);
            end else
              rcVal.lpszValue := nil;
            rcVal.dwLength := wparam;
            Result := res_Text;
          end else if StrLComp(lpszName, 'PT_PRODTYPE]', 12) = 0 then begin
            rcVal.dwType := res_Text;
            rcVal.lpszValue := nil;
            rcVal.dwLength := 0;
            wparam := Length(TPlanet(lpUserParams).ProduceType);
            if wparam <> 0 then begin
              rcVal.dwLength := wparam;
              try
                GetMem(rcVal.lpszValue, wparam + 1)
              except
                exit
              end;
              StrPCopy(rcVal.lpszValue, uppercase(TPlanet(lpUserParams).ProduceType));
            end;
            Result := res_Text;
          end;
        end;
      end;
    ep_Func:
      begin
        with TEvalFunc(pointer(lparam)^) do begin
          if StrLComp(lpszName, 'DISTANCE(', 9) = 0 then begin
            if lpParams = nil then begin
             { At first call lpParams=nil: it means that Eval32 checks argument number}
              if dwParamCount = 2 then Result := 0
            end else if (lpParams^[1].dwType = res_Text) and (lpParams^[1].lpszValue <> nil) and
              (lpParams^[2].dwType = res_Text) and (lpParams^[2].lpszValue <> nil) then
            begin
              strPlanet1 := lpParams^[1].lpszValue;
              strPlanet2 := lpParams^[2].lpszValue;
              planet1 := FindPlanetWithname(strPlanet1);
              planet2 := FindPlanetWithname(strPlanet2);
              if not Assigned(planet1) or not Assigned(planet2) then begin
                Result := res_Error;
                Exit;
              end;
              extX := planet1.X;
              extY := planet1.Y;
              extX1 := planet2.X;
              extY1 := planet2.Y;
              rcRes.xValue := sqrt((extX - extX1) * (extX - extX1) + (extY - extY1) * (extY - extY1)) / 100;
              rcRes.dwType := res_Numeric;
              Result := res_Numeric
            end;
            exit
          end;
          if StrLComp(lpszName, 'ATOI(', 5) = 0 then begin
            if lpParams = nil then begin
             { At first call lpParams=nil: it means that Eval32 checks argument number}
              if dwParamCount = 1 then Result := 0
            end else if (lpParams^[1].dwType = res_Text) and (lpParams^[1].lpszValue <> nil) then
            begin
              strPlanet1 := lpParams^[1].lpszValue;
              rcRes.xValue := mkAtoI(strPlanet1);
              rcRes.dwType := res_Numeric;
              Result := res_Numeric
            end;
            exit
          end;
          if StrLComp(lpszName, 'INVERT(', 7) = 0 then begin
            if lpParams = nil then begin
             { At first call lpParams=nil: it means that Eval32 checks argument number}
              if dwParamCount = 1 then Result := 0
            end else begin
              gDoPlanetInverse := true;
              rcRes.dwType    := lpParams^[1].dwType;
              rcRes.xValue    := lpParams^[1].xValue;
              rcRes.lpszValue := lpParams^[1].lpszValue;
              rcRes.dwLength  := lpParams^[1].dwLength;
              rcRes.dtValue   := lpParams^[1].dtValue;
              Result := lpParams^[1].dwType;
            end;
            exit
          end;
        end;
      end;
  end;
end;

procedure TfrmExpressionFilters.FormCreate(Sender: TObject);
var
  i: integer;
begin
  FFilteredplanets := Tlist.Create;
  for i := 0 to planets.Count - 1 do
    FFilteredplanets.Add(planets.Objects[i]);
end;

function DoExprGroup(Expression: string; gr: TObject): integer;
var
  szTxt: array[0..511] of char;
  rcRes: TEvalValue;
  i: longint;
begin
  Result := -1;
  StrPCopy(szTxt, Expression);
  i := Evaluate(szTxt, @EvalGroupCallback, rcRes, gr);
  if i = res_Error then exit;
  case rcRes.dwType of
    res_Numeric,
      res_Boolean:
      begin
        if rcRes.xValue > 0 then
          result := 1
        else
          Result := 0;
      end;
  end;
end;

function DoExprPlanet(Expression: string; PT: TPlanet): integer;
var
  szTxt: array[0..511] of char;
  rcRes: TEvalValue;
  i: longint;
begin
  Result := -1;
  StrPCopy(szTxt, Expression);
  i := Evaluate(szTxt, @EvalPlanetCallback, rcRes, pt);
  if i = res_Error then exit;
  case rcRes.dwType of
    res_Numeric,
      res_Boolean:
      begin
        if rcRes.xValue <> 0 then
          result := 1
        else
          Result := 0;
      end;
  end;
end;

procedure TfrmExpressionFilters.FormDestroy(Sender: TObject);
begin
  FFilteredplanets.Free;
end;

procedure TfrmExpressionFilters.DoFiltering;
var
  i, j: integer;
  planet: Tplanet;
  player: Tplayer;
  group: Tgroup;
  tmpList: TList;
  SendedGroup: TSendedGroup;
begin
  FFilteredplanets.clear;
  gDoGroupInverse := false;
  gDoPlanetInverse := false;
  if RadioGroup1.ItemIndex = 0 then begin
    for i := 0 to players.Count - 1 do begin
      player := TPlayer(players.Objects[i]);
      if player <> qReportPlayer then begin
        for j := 0 to player.Groups.Count - 1 do begin
          group := Tgroup(player.Groups[j]);
          if FFilteredplanets.IndexOf(group.Planet) <> -1 then continue;
          if DoExprGRforGroup(group) then begin
            FFilteredplanets.Add(group.Planet);
            continue;
          end;
        end;
      end;
    end;
    // Sent groups
    for i := 0 to SendedGroups.Count -1 do begin
      planet := nil;
      SendedGroup := TSendedGroup(SendedGroups.Objects[i]);
      if Assigned(SendedGroup.sendTo) then planet := SendedGroup.sendTo
                                      else planet := SendedGroup.sendFrom;
      if FFilteredplanets.IndexOf(planet) <> -1 then continue;
      if DoExprGRforGroup(SendedGroup) then begin
        FFilteredplanets.Add(planet);
      end;
    end;
  end else begin
    for i := 0 to planets.Count - 1 do begin
      planet := TPlanet(planets.Objects[i]);
      if FFilteredplanets.IndexOf(planet) <> -1 then continue;
      if DoExprPTForPlanet(planet) then
        FFilteredplanets.Add(planet);
    end;
  end;
  if gDoGroupInverse or gDoGroupInverse then begin
    tmpList := TList.Create;
    try
      for i := 0 to planets.Count - 1 do
        if FFilteredplanets.IndexOf(planets.Objects[i]) = -1 then
          tmpList.Add(planets.Objects[i]);

      FFilteredplanets.Clear;
      FFilteredplanets.Capacity := tmpList.Count;
      FFilteredplanets.Count := tmpList.Count;
      move(tmpList.List^, FFilteredplanets.List^, tmpList.Count * sizeof(Pointer));
    finally
      tmpList.Free;
    end;
  end;
end;

procedure TfrmExpressionFilters.RzDialogButtons1ClickOk(Sender: TObject);
begin
  modalResult := mrNone;
  case RadioGroup1.ItemIndex of
    0: SelectGroupExpression(FExpression);
  else
    SelectPlanetExpression(FExpression);
  end;
  if FExpression = '' then begin
    modalResult := mrCancel;
    Exit;
  end else
    DoFiltering;
  modalResult := mrOK;
end;

function TfrmExpressionFilters.DoExprGRforGroup(group: TObject): boolean;
var
  intRes: integer;
begin
  intRes := DoExprGroup(FExpression, group);
  if intRes = -1 then raise Exception.CreateFmt('Error in expression: %s', [FExpression]);
  result := intRes = 1;
end;

function TfrmExpressionFilters.DoExprPTForPlanet(
  planet: Tplanet): boolean;
var
  intRes: integer;
begin
  intRes := DoExprPlanet(FExpression, planet);
  if intRes = -1 then raise Exception.CreateFmt('Error in expression: %s', [FExpression]);
  result := intRes = 1;
end;

procedure TfrmExpressionFilters.ClearFilteredPlanets;
var
  i: integer;
begin
  FFilteredplanets.Clear;
  for i := 0 to planets.Count - 1 do
    FFilteredplanets.Add(planets.Objects[i]);
end;

end.

