unit UfrmGroups;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, OvcBase, OvcState, EC_Main, TopWnd, SysMenu,
  ComCtrls, UTypes, ExtCtrls, StdCtrls,
  mkListView, UmkListviewExport;

type
  TfrmGroups = class(TForm)
    SystemMenu1: TSystemMenu;
    TopMostWindow1: TTopMostWindow;
    OvcFormState1: TOvcFormState;
    mnuSysMenu: TPopupMenu;
    mniTopMost: TMenuItem;
    mniExport: TMenuItem;
    OvcComponentState1: TOvcComponentState;
    mnuGroups: TPopupMenu;
    N1: TMenuItem;
    mniExpressions: TMenuItem;
    mniMarkInMap: TMenuItem;
    mniSendGroupsTo: TMenuItem;
    mniSendGroupTo: TMenuItem;
    mniUpgrade: TMenuItem;
    N2: TMenuItem;
    mniAddToDefender: TMenuItem;
    mniAddToAttacker: TMenuItem;
    mniUnMarkPlanetsInMap: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    mniCalculateDistancestothisPlanet: TMenuItem;
    mniSendGroupsToPlanets: TMenuItem;
    N5: TMenuItem;
    SelectAllGroups1: TMenuItem;
    N6: TMenuItem;
    mniExpressions1: TMenuItem;
    Panel1: TPanel;
    btnExpressions: TButton;
    Label1: TLabel;
    Label2: TLabel;
    cbxGROwners: TComboBox;
    cbxPTOwners: TComboBox;
    btnRefresh: TButton;
    Export1: TMenuItem;
    FindGroupinorders1: TMenuItem;
    Button1: TButton;
    Viewplanetscentered1: TMenuItem;
    mkListView1: TmkListView;
    mniUnload: TMenuItem;
    procedure mniTopMostClick(Sender: TObject);
    procedure mniExportClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure mnuGroupsPopup(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mniMarkInMapClick(Sender: TObject);
    procedure mniUnMarkPlanetsInMapClick(Sender: TObject);
    procedure mniSendGroupsToClick(Sender: TObject);
    procedure mniSendGroupToClick(Sender: TObject);
    procedure mniUpgradeClick(Sender: TObject);
    procedure mniAddToDefenderClick(Sender: TObject);
    procedure mniAddToAttackerClick(Sender: TObject);
    procedure mniExpressionsClick(Sender: TObject);
    procedure mniCalculateDistancestothisPlanetClick(Sender: TObject);
    procedure mniSendGroupsToPlanetsClick(Sender: TObject);
    procedure SelectAllGroups1Click(Sender: TObject);
    procedure cbxGROwnersClick(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure FindGroupinorders1Click(Sender: TObject);
    procedure lvGroupsSortBegin(Sender: TObject; SortColumn: Integer;
      Ascending: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Viewplanetscentered1Click(Sender: TObject);
    procedure mkListView1Data(Sender: TObject; Item: TListItem);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure mkListView1Click(Sender: TObject);
    procedure mkListView1SortBegin(SortDirection: TmkSortDirection;
      SortColumn: Integer);
    procedure FormHide(Sender: TObject);
    procedure mniUnloadClick(Sender: TObject);
  private
    FSelectedGroups: Tlist;
    FPlanet: TPlanet;
    FExpression: string;
    FDoNotSelect: boolean;
    FOldIdleEvent: TIdleEvent;
    FLastIndex: integer;
    FExportMkListView: TExportMkListView;
    procedure DoOnIdle(Sender: TObject; var Done: boolean);
  protected
    procedure lvDataAddGroup(ObjectItem: TObject);
    procedure ClearDataListview;
    function CreateSelectedGroups(blnOnlyMainPlayer: boolean): boolean;
    { Private declarations }
  public
    property SelectedGroups: Tlist read FSelectedGroups;

    procedure BuildFullViewList;
    procedure lvBuildList;
    procedure DoRefresh;
    { Public declarations }
  end;

var
  frmGroups: TfrmGroups;
  viewGroups: Tlist;

implementation

uses
  UfrmMain, UFiles, UfrmNewMap, UfrmPlanets, UfrmPlanetSelect, UfrmOrders,
  UfrmBattleSimulator, UfrmSelectExpression, UfrmPlanetsList;

{$R *.DFM}

function DoBigGroupDataComp(Item1, Item2: Pointer;
                            SortDirection: TmkSortDirection;
                            aColumn: integer): Integer;
begin
  case aColumn of
    0: Result := CompareInt(PBigGroupData(Item1).GroupNr,
                            PBigGroupData(Item2).GroupNr);
    1: Result := CompareInt(PBigGroupData(Item1).Count,
                            PBigGroupData(Item2).Count);
    2: Result := CompareInt(PBigGroupData(Item1).Avail,
                            PBigGroupData(Item2).Avail);
    3: Result := CompareInt(PBigGroupData(Item1).ETA,
                            PBigGroupData(Item2).ETA);
    4: Result := CompareText(PBigGroupData(Item1).GRO,
                             PBigGroupData(Item2).GRO);
    5: Result := CompareText(PBigGroupData(Item1).Planet,
                             PBigGroupData(Item2).Planet);
    6: Result := CompareText(PBigGroupData(Item1).PRO,
                             PBigGroupData(Item2).PRO);
    7: Result := CompareText(PBigGroupData(Item1).SourceP,
                             PBigGroupData(Item2).SourceP);
    8: Result := CompareText(PBigGroupData(Item1).ShipType,
                             PBigGroupData(Item2).ShipType);
    9: Result := CompareFloat(PBigGroupData(Item1).Distance,
                              PBigGroupData(Item2).Distance);
    10: Result := CompareFloat(PBigGroupData(Item1).EffSpeed,
                               PBigGroupData(Item2).EffSpeed);
    11: Result := CompareInt(PBigGroupData(Item1).Attacks,
                             PBigGroupData(Item2).Attacks);
    12: Result := CompareFloat(PBigGroupData(Item1).EffWeapons,
                              PBigGroupData(Item2).EffWeapons);
    13: Result := CompareFloat(PBigGroupData(Item1).EffShield,
                              PBigGroupData(Item2).EffShield);
    14: Result := CompareFloat(PBigGroupData(Item1).EffCargo,
                              PBigGroupData(Item2).EffCargo);
    15: Result := CompareFloat(PBigGroupData(Item1).UpgradeCosts,
                              PBigGroupData(Item2).UpgradeCosts);
  end;
  if SortDirection = sdDesc then
    Result := -Result;
end;

procedure TfrmGroups.mniTopMostClick(Sender: TObject);
begin
  mniTopMost.Checked := not mniTopMost.Checked;
  TopMostWindow1.AlwaysOnTop := mniTopMost.Checked;
end;

procedure TfrmGroups.mniExportClick(Sender: TObject);
begin
  FExportMkListView.Choose;
end;

procedure TfrmGroups.lvDataAddGroup(ObjectItem: TObject);
var
  sngDist: single;
  group: TGroup;
  SendedGroup: TSendedGroup;
  planet: TPlanet;
  dx, dy: Single;
  BigGroupData: PBigGroupData;
begin
  if ObjectItem is TGroup then begin
    group := TGroup(ObjectItem);
    SendedGroup := nil;
    planet := group.Planet;
  end else begin
    SendedGroup := TSendedGroup(ObjectItem);
    group := SendedGroup.orgGroup;
    group.SourcePlanet := SendedGroup.sendFrom;
    group.DestPlanet := SendedGroup.sendTo;
    group.ETA := SendedGroup.ETA;
    if SendedGroup.sendToGo > 0 then
      planet := SendedGroup.sendTo
    else
      planet := group.Planet;
  end;
  new(BigGroupData);
  if group.Player = qReportPlayer then
    BigGroupData.GroupNr := Format('%d', [group.nr])
  else
    BigGroupData.GroupNr := '';
  if Assigned(SendedGroup) and (SendedGroup.sendToGo > 0) then
    BigGroupData.Count := Format('%d', [SendedGroup.SendAantal])
  else
    BigGroupData.Count := Format('%d', [group.Aantal]);
  if group.Player = qReportPlayer then begin
    if Assigned(SendedGroup) and SendedGroup.IsOrgGroup and
       not (SendedGroup.sendToGo > 0) then
      BigGroupData.Avail := Format('%d', [GetMaxToSend(group)])
    else
      BigGroupData.Avail := '0';
  end else
    BigGroupData.Avail := '';
  BigGroupData.ETA := Format('%d', [group.ETA]);
  BigGroupData.GRO := group.player.Name;
  BigGroupData.Planet := planet.Name;
  BigGroupData.PRO := planet.LastOwnerName;

  if (group.ETA > 0) and assigned(group.SourcePlanet) then
    BigGroupData.SourceP := group.SourcePlanet.Name
  else
    BigGroupData.SourceP := '';
  BigGroupData.ShipType := group._Type.Name;
  if Assigned(FPlanet) then begin
    dx := FPlanet.x - planet.x;
    dy := FPlanet.y - planet.y;
    sngDist := sqrt(dx * dx + dy * dy) / 100;
    BigGroupData.Distance := Format('%04.2f', [sngDist]);
  end else
    BigGroupData.Distance := '0';
  if Assigned(SendedGroup) then
    BigGroupData.EffSpeed := FloatToStrF(SendedGroup.GetSpeed, ffFixed, 5, 2)
  else
    BigGroupData.EffSpeed := FloatToStrF(group.EffSpeedNow, ffFixed, 5, 2);
  BigGroupData.Attacks := Format('%d', [group._Type.Attacks]);
  BigGroupData.EffWeapons := FloatToStrF(group.EffWeapon, ffFixed, 5, 2);
  BigGroupData.EffShield := FloatToStrF(group.EffShield, ffFixed, 5, 2);
  BigGroupData.EffCargo := FloatToStrF(group.EffCargo, ffFixed, 5, 2);
  BigGroupData.UpgradeCosts := FloatToStrF(group.UpgradeCost, ffFixed, 5, 2);
  BigGroupData.Data := ObjectItem;
  mkListview1.ViewList.Add(BigGroupData);
end;

procedure TfrmGroups.lvBuildList;
var
  i: integer;
  TempViewGroups: TList;
  TempViewGroups2: TList;
  PlanetOwner1: string;
  PlanetOwner2: string;
  GroupOwner1: string;
  GroupOwner2: string;
  objectItem: TObject;
  grIndex, ptIndex: integer;
begin
  FDoNotSelect := true;
  TempViewGroups := nil;
  TempViewGroups2 := nil;
  mkListView1.Items.BeginUpdate;
  try
    ClearDataListview;
    TempViewGroups := TList.Create;
    TempViewGroups2 := TList.Create;
    TempViewGroups.Capacity := viewGroups.Count;
    TempViewGroups.Count := viewGroups.Count;
    move(viewGroups.List^, TempViewGroups.List^, viewGroups.Count * sizeof(Pointer));
    for i := 0 to SendedGroups.Count -1 do
      TempViewGroups.Add(SendedGroups.Objects[i]);

    if FExpression <> '' then begin
      TempViewGroups2.Capacity := TempViewGroups.Count;
      TempViewGroups2.Count := TempViewGroups.Count;
      move(TempViewGroups.List^, TempViewGroups2.List^, TempViewGroups.Count * sizeof(Pointer));
      frmSelectExpressions.Expression := FExpression;
      frmSelectExpressions.DoFilterGroups(TempViewGroups2, TempViewGroups);
    end;
    ptIndex := cbxPTOwners.ItemIndex;
    grIndex := cbxGrOwners.ItemIndex;
    PlanetOwner1 := cbxPTOwners.Items[ptIndex];
    GroupOwner1 := cbxGrOwners.Items[grIndex];

    for i := 0 to TempViewGroups.Count - 1 do begin
      objectItem := TempViewGroups[i];
      if objectItem is TGroup then begin
        GroupOwner2 := TGroup(objectItem).Player.Name;
        PlanetOwner2 := TGroup(objectItem).Planet.LastOwnerName
      end else begin
        GroupOwner2 := TSendedGroup(objectItem).orgGroup.Player.Name;
        if Assigned(TSendedGroup(objectItem).sendTo) then
          PlanetOwner2 := TSendedGroup(objectItem).sendTo.LastOwnerName
        else
          PlanetOwner2 := TGroup(objectItem).Planet.LastOwnerName;
      end;
      if ((grIndex = 0) or (GroupOwner1 = GroupOwner2)) and
        ((ptIndex = 0) or (PlanetOwner1 = PlanetOwner2)) then begin
        lvDataAddGroup(objectItem);
      end;
    end;
  finally
    mkListview1.Items.Count := mkListview1.ViewList.Count;
    mkListview1.ViewList.MkSort;
    mkListView1.Items.EndUpdate;
    TempViewGroups.Free;
    FDoNotSelect := false;
  end;
end;

procedure TfrmGroups.FormShow(Sender: TObject);
var
  vCols: string;
begin
  BuildFullViewList;
  lvBuildList;
  OvcFormState1.Storage.Open;
  vCols := OvcFormState1.Storage.ReadString('frmGroups', 'mkListview1_Order', '');
  OvcFormState1.Storage.Close;
  MkListviewColumnsFromString(mkListView1, vCols);
end;

procedure TfrmGroups.BuildFullViewList;
var
  i, j: integer;
  player: TPlayer;
  group: TGroup;
  planet: TPlanet;
  list: TStringList;
begin
  for i := 0 to planets.Count - 1 do begin
    planet := TPlanet(planets.objects[i]);
    planet.MyShipMass := 0;
    planet.FriendShipMass := 0;
    planet.EnemyShipMass := 0;
  end;
  list := nil;
  try
    list := TStringList.Create;
    for i := 0 to players.Count - 1 do begin
      player := TPlayer(players.Objects[i]);
      if Assigned(player) then begin
        for j := 0 to player.Groups.Count - 1 do begin
          if j = 0 then cbxGrOwners.Items.Add(player.Name);
          group := TGroup(player.Groups.Items[j]);
          if Assigned(group) and (group.Turn = LastTurn)  and (group.Range = 0)  then begin
            planet := group.Planet;
            if group.Player = qReportPlayer then
              planet.MyShipMass := planet.MyShipMass + group._Type.Mass * group.Aantal
            else
              if group.Player.War then
                planet.EnemyShipMass := planet.EnemyShipMass + group._Type.Mass * group.Aantal
              else
                planet.FriendShipMass := planet.FriendShipMass + group._Type.Mass * group.Aantal;

            if list.IndexOf(Planet.LastOwnerName) = -1 then
              list.Add(Planet.LastOwnerName);
            if group.Player <> qReportPlayer then
              viewGroups.Add(group);
          end;
        end;
      end;
    end;
    cbxPTOwners.Items.Assign(list);
    cbxGrOwners.Sorted := True;
    cbxGrOwners.Items.Insert(0, '(All)');
    cbxGrOwners.ItemIndex := 0;
    cbxPTOwners.Sorted := True;
    cbxPTOwners.Items.Insert(0, '(All)');
    cbxPTOwners.ItemIndex := 0;
  finally
    list.Free;
  end;
end;

procedure TfrmGroups.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  WindowState := wsMinimized;
  CanClose := false;
end;

procedure TfrmGroups.FormDestroy(Sender: TObject);
begin
  viewGroups.Clear;
  ClearDataListview;
  FSelectedGroups.Free;
  FExportMkListView.Free;
end;

procedure TfrmGroups.mnuGroupsPopup(Sender: TObject);
begin
  mniMarkInMap.Enabled := mkListView1.SelCount > 0;
  mniSendGroupsToPlanets.Enabled := mkListView1.SelCount > 0;
  mniSendGroupsTo.Enabled := mkListView1.SelCount > 0;
  mniSendGroupTo.Enabled := mkListView1.SelCount = 1;
  mniUpgrade.Enabled := mkListView1.SelCount > 0;
  mniAddToDefender.Enabled := mkListView1.SelCount > 0;
  mniAddToAttacker.Enabled := mkListView1.SelCount > 0;
  mniCalculateDistancestothisPlanet.Enabled := mkListView1.SelCount = 1;
end;

procedure TfrmGroups.FormCreate(Sender: TObject);
begin
  FSelectedGroups := Tlist.Create;
  FExpression := '';
  FDoNotSelect := false;
  FLastIndex := -1;
  mkListView1.ViewList.CompareFunc := DoBigGroupDataComp;
  FExportMkListView := TExportMkListView.Create(Self);
  FExportMkListView.ExportType := xHTML;
  FExportMkListView.Options := [ExportAllWhenNoneSelected,
                                SelectedRowsOnly,
                                ShowClipboardMsg,
                                ShowProgress,
                                TimeStamp];
  FExportMkListView.Header := 'Groups';
  FExportMkListView.Footer := frmMKGal.Caption;
  FExportMkListView.Title := 'MKGal';
  FExportMkListView.ViewOnly := true;
  FExportMkListView.ListView := mkListView1;
end;

function TfrmGroups.CreateSelectedGroups(
  blnOnlyMainPlayer: boolean): boolean;
var
  i: integer;
begin
  FSelectedGroups.Clear;
  for i := 0 to mkListView1.Items.Count - 1 do begin
    if mkListView1.Items[i].Selected then
      if not blnOnlyMainPlayer or (blnOnlyMainPlayer
         and (PBigGroupData(mkListView1.ViewList[i]).Data is TSendedGroup)) then
        FSelectedGroups.Add(PBigGroupData(mkListView1.ViewList[i]).Data);
  end;
  Result := FSelectedGroups.Count > 0;
end;

procedure TfrmGroups.mniMarkInMapClick(Sender: TObject);
var
  i: integer;
begin
  if CreateSelectedGroups(false) then begin
    frmNewMap.RemoveCursors;
    for i := 0 to FSelectedGroups.Count - 1 do begin
      if (TObject(FSelectedGroups[i]) is TSendedGroup) then begin
         if TSendedGroup(FSelectedGroups[i]).sendToGo > 0 then
           frmNewMap.AddCursor(TSendedGroup(FSelectedGroups[i]).sendTo)
         else
           frmNewMap.AddCursor(TSendedGroup(FSelectedGroups[i]).orgGroup.Planet);
      end else
        frmNewMap.AddCursor(TGroup(FSelectedGroups[i]).Planet)
    end;
  end;
end;

procedure TfrmGroups.mniUnMarkPlanetsInMapClick(Sender: TObject);
begin
  frmNewMap.RemoveCursors;
end;

procedure TfrmGroups.mniSendGroupsToClick(Sender: TObject);
var
  sendedGroup: TSendedGroup;
  i: integer;
begin
  if frmPlanetSelect.working then Exit;
  if CreateSelectedGroups(true) then begin
    frmPlanetSelect.working := True;
    frmPlanetSelect.SelectedGroups.Clear;
    for i := 0 to FSelectedGroups.Count - 1 do
      if FSelectedGroups[i] <> nil then begin
        sendedGroup := TSendedGroup(FSelectedGroups[i]);
        if (sendedGroup.orgGroup.EffSpeed > 0) and (sendedGroup.sendToGo = 0) then
          frmPlanetSelect.SelectedGroups.AddObject(IntToStr(sendedGroup.orgGroup.Nr), sendedGroup.orgGroup);
      end;
    if frmPlanetSelect.SelectedGroups.Count > 0 then
    begin
      frmPlanetSelect.MaxShips := 1;
      frmPlanetSelect.SelectedPlanets.Clear;
      frmPlanetSelect.SelectMulti := False;
      frmPlanetSelect.Execute;
    end
    else
      frmPlanetSelect.working := False;
  end;
end;

procedure TfrmGroups.mniSendGroupToClick(Sender: TObject);
var
  sendedGroup: TSendedGroup;
  i: integer;
begin
  if frmPlanetSelect.working then Exit;
  if CreateSelectedGroups(true) then begin
    frmPlanetSelect.working := True;
    frmPlanetSelect.SelectedGroups.Clear;
    for i := 0 to FSelectedGroups.Count - 1 do begin
      sendedGroup := TSendedGroup(FSelectedGroups[i]);
      if (sendedGroup.orgGroup.EffSpeed > 0) and (sendedGroup.sendToGo = 0) then begin
        frmPlanetSelect.MaxShips := sendedGroup.orgGroup.Aantal;
        frmPlanetSelect.SelectedGroups.AddObject(IntToStr(sendedGroup.orgGroup.Nr), sendedGroup.orgGroup);
      end;
    end;
    if frmPlanetSelect.SelectedGroups.Count > 0 then
    begin
      frmPlanetSelect.SelectedPlanets.Clear;
      frmPlanetSelect.SelectMulti := True;
      frmPlanetSelect.Execute;
    end
    else
      frmPlanetSelect.working := False;
  end;
end;

procedure TfrmGroups.mniUpgradeClick(Sender: TObject);
var
  sendedGroup: TSendedGroup;
  i: integer;
  list: TStrings;
  orders: string;
begin
  if CreateSelectedGroups(true) then begin
    list := TStringlist.Create;
    try
      for i := 0 to FSelectedGroups.Count - 1 do begin
        sendedGroup := TSendedGroup(FSelectedGroups[i]);
        list.Add(IntToStr(sendedGroup.orgGroup.Nr));
      end;
      if list.Count > 0 then
      begin
        for i := 0 to list.Count - 2 do
          orders := orders + 'G ' + list.Strings[i] + #13#10;
        orders := orders + 'G ' + list.Strings[list.Count - 1];
        frmOrders.InsertCommand(orders);
        frmOrders.AnalyseAndDoOutput;
      end;
    finally
      list.free;
    end;
  end;
end;

procedure TfrmGroups.mniAddToDefenderClick(Sender: TObject);
var
  group: TGroup;
  i: integer;
begin
  if CreateSelectedGroups(false) then begin
    for i := 0 to FSelectedGroups.Count - 1 do begin
      if TObject(FSelectedGroups[i]) is TSendedGroup then
        group := NewGroup(TSendedGroup(FSelectedGroups[i]).orgGroup)
      else
        group := NewGroup(FSelectedGroups[i]);
      frmBattleSimulator.AddGroupToDefenders(group);
    end;
  end;
  frmBattleSimulator.UpdateBattleSim;
end;

procedure TfrmGroups.mniAddToAttackerClick(Sender: TObject);
var
  group: TGroup;
  i: integer;
begin
  if CreateSelectedGroups(false) then begin
    for i := 0 to FSelectedGroups.Count - 1 do begin
      if TObject(FSelectedGroups[i]) is TSendedGroup then
        group := NewGroup(TSendedGroup(FSelectedGroups[i]).orgGroup)
      else
        group := NewGroup(FSelectedGroups[i]);
      frmBattleSimulator.AddGroupToAttackers(group);
    end;
  end;
  frmBattleSimulator.UpdateBattleSim;
end;

procedure TfrmGroups.mniExpressionsClick(Sender: TObject);
var
  i: integer;
  Groups: TList;
  TempViewGroups: TList;
  PlanetOwner1: string;
  PlanetOwner2: string;
  GroupOwner1: string;
  GroupOwner2: string;
  objectItem: TObject;
  grIndex, ptIndex: integer;
begin
  Groups := nil;
  TempViewGroups := nil;
  try
    Groups := TList.Create;
    TempViewGroups := TList.Create;
    TempViewGroups.Capacity := viewGroups.Count;
    TempViewGroups.Count := viewGroups.Count;
    move(viewGroups.List^, TempViewGroups.List^, viewGroups.Count * sizeof(Pointer));
    for i := 0 to SendedGroups.Count -1 do
      TempViewGroups.Add(SendedGroups.Objects[i]);
{    for i := 0 to lvGroups.Items.Count - 1 do
      groups.Add(lvGroups.Items[i].Data);}
    GroupExpressionsExecute(TempViewGroups, Groups, FExpression);
    if FExpression = '' then begin
      Groups.Clear;
      for i := 0 to TempViewGroups.Count -1 do
        Groups.Add(TempViewGroups[i]);
    end;
    ptIndex := cbxPTOwners.ItemIndex;
    grIndex := cbxGrOwners.ItemIndex;
    PlanetOwner1 := cbxPTOwners.Items[ptIndex];
    GroupOwner1 := cbxGrOwners.Items[grIndex];
    FDoNotSelect := true;
    mkListView1.Items.BeginUpdate;
    try
      ClearDataListview;
      for i := 0 to Groups.Count - 1 do begin
        objectItem := Groups[i];
        if objectItem is TGroup then begin
          GroupOwner2 := TGroup(objectItem).Player.Name;
          PlanetOwner2 := TGroup(objectItem).Planet.LastOwnerName;
        end else begin
          GroupOwner2 := TSendedGroup(objectItem).orgGroup.Player.Name;
          if Assigned(TSendedGroup(objectItem).sendTo) then
            PlanetOwner2 := TSendedGroup(objectItem).sendTo.LastOwnerName
          else
            PlanetOwner2 := TGroup(objectItem).Planet.LastOwnerName;
        end;
        if ((grIndex = 0) or (GroupOwner1 = GroupOwner2)) and
          ((ptIndex = 0) or (PlanetOwner1 = PlanetOwner2)) then
          lvDataAddGroup(objectItem);
      end;
    finally
      mkListView1.Items.Count := mkListView1.ViewList.Count;
      mkListview1.ViewList.MkSort;
      mkListView1.Items.EndUpdate;
      FDoNotSelect := false;
    end;
  finally
    TempViewGroups.Free;
  end;
end;

procedure TfrmGroups.mniCalculateDistancestothisPlanetClick(
  Sender: TObject);
var
  BigGroupData: PBigGroupData;
begin
  BigGroupData := mkListView1.ViewList[mkListView1.Selected.Index];
  if BigGroupData.Data is TSendedGroup then begin
    if TSendedGroup(BigGroupData.Data).sendToGo > 0 then
      Fplanet := TSendedGroup(BigGroupData.Data).sendTo
    else
      Fplanet := TSendedGroup(BigGroupData.Data).orgGroup.Planet;
  end else
    Fplanet := TGroup(BigGroupData.Data).Planet;
  lvBuildList;
end;

procedure TfrmGroups.mniSendGroupsToPlanetsClick(Sender: TObject);
var
  sendedGroup: TsendedGroup;
  i: integer;
  intMaxShips: integer;
begin
  if frmPlanetSelect.working then Exit;
  if CreateSelectedGroups(true) then begin
    frmPlanetSelect.working := True;
    frmPlanetSelect.SelectedGroups.Clear;
    intMaxShips := 0;
    for i := 0 to FSelectedGroups.Count - 1 do
      if FSelectedGroups[i] <> nil then begin
        sendedGroup := TSendedGroup(FSelectedGroups[i]);
        if (sendedGroup.orgGroup.EffSpeed > 0) and (sendedGroup.sendToGo = 0) then begin
          frmPlanetSelect.SelectedGroups.AddObject(IntToStr(sendedGroup.orgGroup.Nr), sendedGroup.orgGroup);
          intMaxShips := intMaxShips + sendedGroup.orgGroup.Aantal;
        end;
      end;
    if frmPlanetSelect.SelectedGroups.Count > 0 then
    begin
      frmPlanetSelect.MaxShips := intMaxShips;
      frmPlanetSelect.SelectedPlanets.Clear;
      frmPlanetSelect.SelectMulti := True;
      frmPlanetSelect.Execute;
    end
    else
      frmPlanetSelect.working := False;
  end;
end;

procedure TfrmGroups.SelectAllGroups1Click(Sender: TObject);
begin
  mkListView1.SelectAll;
end;

procedure TfrmGroups.cbxGROwnersClick(Sender: TObject);
begin
  lvBuildList;
end;

procedure TfrmGroups.DoRefresh;
var
  OldCur: TCursor;
begin
  OldCur := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  try
    lvBuildList;
  finally
    Screen.Cursor := OldCur;
  end;
end;

procedure TfrmGroups.btnRefreshClick(Sender: TObject);
begin
  DoRefresh;
end;

procedure TfrmGroups.FindGroupinorders1Click(Sender: TObject);
var
  BigGroupData: PBigGroupData;
begin
  if Assigned(mkListView1.Selected) then begin
    BigGroupData := mkListView1.ViewList[mkListView1.Selected.Index];
    frmOrders.FindFirstGroupInOrders(BigGroupData.GroupNr);
  end;
end;

procedure TfrmGroups.lvGroupsSortBegin(Sender: TObject;
  SortColumn: Integer; Ascending: Boolean);
var
  sColumn: string;
  sSort: string;
begin
  if not Ascending then sSort := 'Ascending'
                   else sSort := 'Descending';
  case SortColumn of
    0: sColumn := 'Group Number';
    1: sColumn := 'Number of Ships';
    2: sColumn := 'Available to sent';
    3: sColumn := 'ETA';
    4: sColumn := 'Owner of this group';
    5: sColumn := 'Planet Name';
    6: sColumn := 'Planet Owner';
    7: sColumn := 'Sourceplanet Name';
    8: sColumn := 'Shiptype';
    9: sColumn := 'Distance';
    10: sColumn := 'Effective Speed';
    11: sColumn := 'Number of Attacks';
    12: sColumn := 'Effective Weapon';
    13: sColumn := 'Effective Shield';
    14: sColumn := 'Effective Cargo';
    15: sColumn := 'Upgrade Costs';
  else
    sColumn := 'Something :-)';
  end;
  Caption := Format('Groups - sort %s on %s', [sSort, sColumn]);
end;

procedure TfrmGroups.Button1Click(Sender: TObject);
var
  i: integer;
  group: TGroup;
  Groups, GroupsAll: TList;
  vOldExpression: string;
begin
  Groups := nil;
  GroupsAll := nil;
  try
    Groups := TList.Create;
    GroupsAll := TList.Create;
    for i := 0 to mkListView1.ViewList.Count - 1 do begin
      groups.Add(PBigGroupData(mkListView1.ViewList[i]).Data);
      GroupsAll.Add(PBigGroupData(mkListView1.ViewList[i]).Data);
    end;
    vOldExpression := FExpression;
    if GroupExpressionsExecute(GroupsAll, Groups, FExpression) then begin
      if vOldExpression <> '' then
        FExpression := '(' + vOldExpression + ') and (' + FExpression + ')';
    end;

    mkListView1.Items.BeginUpdate;
    FDoNotSelect := true;
    try
      ClearDataListview;
      for i := 0 to Groups.Count - 1 do begin
        group := TGroup(Groups.Items[i]);
        lvDataAddGroup(group);
      end;
    finally
      mkListView1.Items.Count := mkListView1.ViewList.Count;
      mkListview1.ViewList.MkSort;
      mkListView1.Items.EndUpdate;
      FDoNotSelect := false;
    end;
  finally
    Groups.Free;
    GroupsAll.Free;
  end;
end;

procedure TfrmGroups.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_F5) then
    DoRefresh;
  if (Key = VK_F6) then
    frmOrders.DoAnalyseButton;
end;

procedure TfrmGroups.Viewplanetscentered1Click(Sender: TObject);
begin
  Viewplanetscentered1.Checked := not Viewplanetscentered1.Checked;
end;

procedure TfrmGroups.ClearDataListview;
var
  i: integer;
  BigGroupData: PBigGroupData;
begin
  mkListView1.Items.Clear;
  for i := 0 to mklistview1.ViewList.Count -1 do begin
    BigGroupData := mklistview1.ViewList[i];
    BigGroupData.GroupNr := '';
    BigGroupData.Count := '';
    BigGroupData.Avail := '';
    BigGroupData.ETA := '';
    BigGroupData.GRO := '';
    BigGroupData.Planet := '';
    BigGroupData.PRO := '';
    BigGroupData.SourceP := '';
    BigGroupData.ShipType := '';
    BigGroupData.Distance := '';
    BigGroupData.EffSpeed := '';
    BigGroupData.Attacks := '';
    BigGroupData.EffWeapons := '';
    BigGroupData.EffShield := '';
    BigGroupData.EffCargo := '';
    BigGroupData.UpgradeCosts := '';
    Dispose(BigGroupData);
  end;
  mkListView1.ViewList.Clear;
end;

procedure TfrmGroups.mkListView1Data(Sender: TObject; Item: TListItem);
var
  BigGroupData: PBigGroupData;
begin
  BigGroupData := mklistview1.ViewList[item.index];
  item.Caption := BigGroupData.GroupNr;
  item.SubItems.Add(BigGroupData.Count);
  item.SubItems.Add(BigGroupData.Avail);
  item.SubItems.Add(BigGroupData.ETA);
  item.SubItems.Add(BigGroupData.GRO);
  item.SubItems.Add(BigGroupData.Planet);
  item.SubItems.Add(BigGroupData.PRO);
  item.SubItems.Add(BigGroupData.SourceP);
  item.SubItems.Add(BigGroupData.ShipType);
  item.SubItems.Add(BigGroupData.Distance);
  item.SubItems.Add(BigGroupData.EffSpeed);
  item.SubItems.Add(BigGroupData.Attacks);
  item.SubItems.Add(BigGroupData.EffWeapons);
  item.SubItems.Add(BigGroupData.EffShield);
  item.SubItems.Add(BigGroupData.EffCargo);
  item.SubItems.Add(BigGroupData.UpgradeCosts);
end;

procedure TfrmGroups.FormActivate(Sender: TObject);
begin
  FOldIdleEvent := Application.OnIdle;
  Application.OnIdle := DoOnIdle;
end;

procedure TfrmGroups.FormDeactivate(Sender: TObject);
begin
  Application.OnIdle := FOldIdleEvent;
end;

procedure TfrmGroups.DoOnIdle(Sender: TObject; var Done: boolean);
var
  BigGroupData: PBigGroupData;
begin
{  if Assigned(mkListview1.selected) and not FDoNotSelect then begin
    if FLastIndex = mkListview1.selected.Index then exit;
    FLastIndex := mkListview1.selected.Index;
    BigGroupData := mklistview1.ViewList[mkListview1.selected.index];
    if (TObject(BigGroupData.Data) is TSendedGroup) then begin
      if Assigned(TSendedGroup(BigGroupData.Data).sendTo) then
        frmPlanets.ShowPlanet(TSendedGroup(BigGroupData.Data).sendTo, Viewplanetscentered1.Checked)
      else
        frmPlanets.ShowPlanet(TSendedGroup(BigGroupData.Data).orgGroup.Planet, Viewplanetscentered1.Checked);
    end else
      frmPlanets.ShowPlanet(TGroup(BigGroupData.Data).planet, Viewplanetscentered1.Checked);
  end;}

  if Assigned(mkListView1.Selected) then begin
    BigGroupData := mklistview1.ViewList[mkListview1.selected.index];
    if BigGroupData.Data is TSendedGroup then begin
      if Assigned(TSendedGroup(BigGroupData.Data).sendTo) then
        frmNewMap.GroupCursor.SetGroup(TSendedGroup(BigGroupData.Data).sendTo.X,
                                       TSendedGroup(BigGroupData.Data).sendTo.Y,
                                       TSendedGroup(BigGroupData.Data).OrgGroup.EffSpeed,
                                       TSendedGroup(BigGroupData.Data).OrgGroup.EffSpeedLoaded)
      else
        frmNewMap.GroupCursor.SetGroup(TSendedGroup(BigGroupData.Data).orgGroup.Planet.X,
                                       TSendedGroup(BigGroupData.Data).orgGroup.Planet.Y,
                                       TSendedGroup(BigGroupData.Data).orgGroup.EffSpeed,
                                       TSendedGroup(BigGroupData.Data).orgGroup.EffSpeedLoaded);
    end else
      frmNewMap.GroupCursor.SetGroup(0, 0, 0, 0);
    if FLastIndex <> mkListview1.selected.Index then begin
      FLastIndex := mkListview1.selected.Index;
      BigGroupData := mklistview1.ViewList[mkListview1.selected.index];
      if (TObject(BigGroupData.Data) is TSendedGroup) then begin
        if Assigned(TSendedGroup(BigGroupData.Data).sendTo) then
          frmPlanets.ShowPlanet2(TSendedGroup(BigGroupData.Data).sendTo, Viewplanetscentered1.Checked)
        else
          frmPlanets.ShowPlanet2(TSendedGroup(BigGroupData.Data).orgGroup.Planet, Viewplanetscentered1.Checked);
      end else
        frmPlanets.ShowPlanet2(TGroup(BigGroupData.Data).planet, Viewplanetscentered1.Checked);
    end else
      frmNewMap.Repaint;
  end else
    frmNewMap.Repaint;
end;

procedure TfrmGroups.mkListView1Click(Sender: TObject);
var
  BigGroupData: PBigGroupData;
begin
{  if Assigned(mkListView1.Selected) then begin
    BigGroupData := mklistview1.ViewList[mkListview1.selected.index];
    if BigGroupData.Data is TSendedGroup then begin
      if Assigned(TSendedGroup(BigGroupData.Data).sendTo) then
        frmNewMap.GroupCursor.SetGroup(TSendedGroup(BigGroupData.Data).sendTo.X,
                                       TSendedGroup(BigGroupData.Data).sendTo.Y,
                                       TSendedGroup(BigGroupData.Data).OrgGroup.EffSpeed,
                                       TSendedGroup(BigGroupData.Data).OrgGroup.EffSpeedLoaded)
      else
        frmNewMap.GroupCursor.SetGroup(TSendedGroup(BigGroupData.Data).orgGroup.Planet.X,
                                       TSendedGroup(BigGroupData.Data).orgGroup.Planet.Y,
                                       TSendedGroup(BigGroupData.Data).orgGroup.EffSpeed,
                                       TSendedGroup(BigGroupData.Data).orgGroup.EffSpeedLoaded);
    end else
      frmNewMap.GroupCursor.SetGroup(0, 0, 0, 0);
    if FLastIndex <> mkListview1.selected.Index then begin
      FLastIndex := mkListview1.selected.Index;
      BigGroupData := mklistview1.ViewList[mkListview1.selected.index];
      if (TObject(BigGroupData.Data) is TSendedGroup) then begin
        if Assigned(TSendedGroup(BigGroupData.Data).sendTo) then
          frmPlanets.ShowPlanet2(TSendedGroup(BigGroupData.Data).sendTo, Viewplanetscentered1.Checked)
        else
          frmPlanets.ShowPlanet2(TSendedGroup(BigGroupData.Data).orgGroup.Planet, Viewplanetscentered1.Checked);
      end else
        frmPlanets.ShowPlanet2(TGroup(BigGroupData.Data).planet, Viewplanetscentered1.Checked);
    end else
      frmNewMap.Repaint;
  end else
    frmNewMap.Repaint;}
end;

procedure TfrmGroups.mkListView1SortBegin(SortDirection: TmkSortDirection;
  SortColumn: Integer);
var
  sColumn: string;
  sSort: string;
begin
  if SortDirection = sdAsc then sSort := 'Ascending'
                           else sSort := 'Descending';
  case SortColumn of
    0: sColumn := 'Group Number';
    1: sColumn := 'Number of Ships';
    2: sColumn := 'Available to sent';
    3: sColumn := 'ETA';
    4: sColumn := 'Owner of this group';
    5: sColumn := 'Planet Name';
    6: sColumn := 'Planet Owner';
    7: sColumn := 'Sourceplanet Name';
    8: sColumn := 'Shiptype';
    9: sColumn := 'Distance';
    10: sColumn := 'Effective Speed';
    11: sColumn := 'Number of Attacks';
    12: sColumn := 'Effective Weapon';
    13: sColumn := 'Effective Shield';
    14: sColumn := 'Effective Cargo';
    15: sColumn := 'Upgrade Costs';
  else
    sColumn := 'Something :-)';
  end;
  Caption := Format('Groups - sort %s on %s', [sSort, sColumn]);
end;

procedure TfrmGroups.FormHide(Sender: TObject);
var
  vCols: string;
begin
  MkListviewColumnsToString(mkListView1, vCols);
  OvcFormState1.Storage.Open;
  OvcFormState1.Storage.WriteString('frmGroups', 'mkListview1_Order', vCols);
  OvcFormState1.Storage.Close;
end;

procedure TfrmGroups.mniUnloadClick(Sender: TObject);
var
  sendedGroup: TSendedGroup;
  i: integer;
  list: TStrings;
  orders: string;
begin
  if CreateSelectedGroups(true) then begin
    list := TStringlist.Create;
    try
      for i := 0 to FSelectedGroups.Count - 1 do begin
        sendedGroup := TSendedGroup(FSelectedGroups[i]);
        if sendedGroup.sendQuantity > 0 then
          list.Add(IntToStr(sendedGroup.orgGroup.Nr));
      end;
      if list.Count > 0 then
      begin
        for i := 0 to list.Count - 2 do
          orders := orders + 'U ' + list.Strings[i] + #13#10;
        orders := orders + 'U ' + list.Strings[list.Count - 1];
        frmOrders.InsertCommand(orders);
        frmOrders.AnalyseAndDoOutput;
      end;
    finally
      list.free;
    end;
  end;
end;

initialization
  viewGroups := Tlist.Create;
finalization
  viewGroups.Free;
end.
