unit UfrmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, AppEvent, ComCtrls, ToolWin,
  Buttons, OvcBase, OvcFiler, OvcStore, OvcState, Menus, SysMenu, TopWnd,
  RxCalc, OvcDlg, OvcClcDg;

type
  TfrmMKGal = class(TForm)
    AppEvents1: TAppEvents;
    StatusBar1: TStatusBar;
    btnPlayers: TSpeedButton;
    btnGraph: TSpeedButton;
    btnPlanets: TSpeedButton;
    btnMap: TSpeedButton;
    btnBombings: TSpeedButton;
    btnIncomingGroups: TSpeedButton;
    btnShipDesign: TSpeedButton;
    btnBattles: TSpeedButton;
    btnBatSim: TSpeedButton;
    btnOrders: TSpeedButton;
    btnTurnReports: TSpeedButton;
    btnConfigIni: TSpeedButton;
    btnAbout: TSpeedButton;
    OvcIniFileStore1: TOvcIniFileStore;
    OvcFormState1: TOvcFormState;
    btnExtra: TSpeedButton;
    SystemMenu1: TSystemMenu;
    MKGalSysMenu: TPopupMenu;
    mniTopMost: TMenuItem;
    TopMostWindow1: TTopMostWindow;
    btnGroups: TSpeedButton;
    pmuExtra: TPopupMenu;
    DoExport1: TMenuItem;
    AddTabstoAllReports1: TMenuItem;
    Calculator1: TMenuItem;
    btnPlanetsList: TSpeedButton;
    MinimizeAll1: TMenuItem;
    N1: TMenuItem;
    SaveStatus1: TMenuItem;
    btnRoutes: TSpeedButton;
    btnOverView: TSpeedButton;
    DebugError1: TMenuItem;
    btnNotes: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure AppEvents1Hint(Sender: TObject);
    procedure btnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnAboutClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormHide(Sender: TObject);
    procedure mniTopMostClick(Sender: TObject);
    procedure DoExport1Click(Sender: TObject);
    procedure btnExtraClick(Sender: TObject);
    procedure AddTabstoAllReports1Click(Sender: TObject);
    procedure Calculator1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MinimizeAll1Click(Sender: TObject);
    procedure SaveStatus1Click(Sender: TObject);
    procedure btnOverViewClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DebugError1Click(Sender: TObject);
  private
    FCanWindowClose: boolean;
    FTitle: string;
    FCalculator: TOvcfrmCalculatorDlg;
    procedure SetTitle(value: string);
    { Private declarations }
  public
    property CanWindowClose: boolean read FCanWindowClose;
    property Title: string read FTitle write SetTitle;
    { Public declarations }
  end;

var
  frmMKGal: TfrmMKGal;

implementation

uses Utypes, UfrmPlayers, UfrmPlanets, UfrmBattles,
  UfrmShipDesign, UfrmGraph, UfrmBattleSimulator, UfrmOrders,
  UfrmIncomingGroups, UfrmTurnReports, UfrmAbout, UfrmBombings, UfrmConfigIni,
  UfrmGroupFilter, UfrmNewMap, UExportToMDB, UfrmGroups, UfrmPlanetslist,
  UfrmRoutes, UfrmOverView, UFiles, UfrmEditor;

{$R *.DFM}

procedure TfrmMKGal.SetTitle(value: string);
begin
  if value <> FTitle then
  begin
    Caption := value;
    FTitle := value;
  end;
end;

procedure TfrmMKGal.FormShow(Sender: TObject);
var
  tmpInt: integer;
begin
  OvcIniFileStore1.Open;
  tmpInt := OvcIniFileStore1.ReadInteger('TfrmMKGal', 'Left', -1);
  if tmpInt <> -1 then Left := tmpInt;
  tmpInt := OvcIniFileStore1.ReadInteger('TfrmMKGal', 'Top', -1);
  if tmpInt <> -1 then Top := tmpInt;
  OvcIniFileStore1.Close;
  btnPlayers.Tag := integer(frmPLayers);
  btnPlanets.Tag := integer(frmPlanets);
  btnMap.Tag := integer(frmNewMap);
  btnBattles.Tag := integer(frmBattles);
  btnShipDesign.Tag := integer(frmShipDesign);
  btnGraph.Tag := integer(frmGraph);
  btnBatSim.Tag := integer(frmBattleSimulator);
  btnOrders.Tag := integer(frmOrders);
  btnIncomingGroups.Tag := integer(frmIncomingGroups);
  btnTurnReports.Tag := integer(frmTurnReports);
  btnBombings.Tag := integer(frmBombings);
  btnConfigIni.Tag := integer(frmConfigIni);
  btnGroups.Tag := integer(frmGroups);
  btnPlanetsList.Tag := integer(frmPlanetsList);
  btnRoutes.Tag := integer(frmRoutes);
  btnNotes.Tag := integer(frmEditor);
  DoExport1.Enabled := GetDBEngine;
  Screen.Cursor := crHourGlass;
  Application.ProcessMessages;
  frmPLayers.Show;
  Application.ProcessMessages;
  frmPlanets.Show;
  Application.ProcessMessages;
  frmNewMap.Show;
  Application.ProcessMessages;
  frmBattles.Show;
  Application.ProcessMessages;
  frmShipDesign.Show;
  Application.ProcessMessages;
  frmGraph.Show;
  Application.ProcessMessages;
  frmBattleSimulator.Show;
  Application.ProcessMessages;
  frmOrders.Show;
  Application.ProcessMessages;
  frmIncomingGroups.Show;
  Application.ProcessMessages;
  frmTurnReports.Show;
  Application.ProcessMessages;
  frmBombings.Show;
  Application.ProcessMessages;
  frmConfigIni.Show;
  Application.ProcessMessages;
  frmGroups.Show;
  Application.ProcessMessages;
  frmPlanetsList.Show;
  Application.ProcessMessages;
  frmRoutes.Show;
  Application.ProcessMessages;
  frmEditor.Show;
  Screen.Cursor := crDefault;
end;

procedure TfrmMKGal.AppEvents1Hint(Sender: TObject);
begin
  StatusBar1.simpleText := Application.Hint;
end;

procedure TfrmMKGal.btnMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Assigned(TComponent(TComponent(Sender).tag)) then
    if TForm(TComponent(Sender).tag).WindowState = wsMinimized then
      TForm(TComponent(Sender).tag).WindowState := wsNormal
    else
      if mbRight = Button then
        TForm(TComponent(Sender).tag).WindowState := wsMinimized
      else
        TForm(TComponent(Sender).tag).BringToFront;
end;

procedure TfrmMKGal.btnAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TfrmMKGal.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  ExtraPlanetInfoList.WriteInfo(ExtractFilePath(ParamStr(0)) + 'ExtrInf.ini');
end;

procedure TfrmMKGal.FormHide(Sender: TObject);
begin
  OvcFormState1.Storage.Open;
  OvcFormState1.Storage.WriteInteger('TfrmMKGal', 'Left', Left);
  OvcFormState1.Storage.WriteInteger('TfrmMKGal', 'Top', Top);
  OvcFormState1.Storage.Close;
end;

procedure TfrmMKGal.mniTopMostClick(Sender: TObject);
begin
  mniTopMost.Checked := not mniTopMost.Checked;
  TopmostWindow1.AlwaysOnTop := mniTopMost.Checked;
end;

procedure TfrmMKGal.DoExport1Click(Sender: TObject);
begin
  DoExport;
end;

procedure TfrmMKGal.btnExtraClick(Sender: TObject);
var
  myPoint: TPoint;
begin
  myPoint.x := btnExtra.Left;
  myPoint.y := btnExtra.Top + btnExtra.Height;
  myPoint := ClientToScreen(myPoint);
  pmuExtra.Popup(myPoint.x, myPoint.y);
end;

procedure TfrmMKGal.AddTabstoAllReports1Click(Sender: TObject);
begin
  AddTabsToAllReports;
end;

procedure TfrmMKGal.Calculator1Click(Sender: TObject);
begin
  FCalculator.Show;
end;

procedure TfrmMKGal.FormCreate(Sender: TObject);
begin
  FCalculator := TOvcfrmCalculatorDlg.Create(nil);
  FCalculator.PanelButtons.Visible := False;
end;

procedure TfrmMKGal.FormDestroy(Sender: TObject);
begin
  FCalculator.Free;
end;

procedure TfrmMKGal.MinimizeAll1Click(Sender: TObject);
begin
  frmPLayers.WindowState := wsMinimized;
  frmPlanets.WindowState := wsMinimized;
  frmNewMap.WindowState := wsMinimized;
  frmBattles.WindowState := wsMinimized;
  frmShipDesign.WindowState := wsMinimized;
  frmGraph.WindowState := wsMinimized;
  frmBattleSimulator.WindowState := wsMinimized;
  frmOrders.WindowState := wsMinimized;
  frmIncomingGroups.WindowState := wsMinimized;
  frmTurnReports.WindowState := wsMinimized;
  frmBombings.WindowState := wsMinimized;
  frmConfigIni.WindowState := wsMinimized;
  frmGroups.WindowState := wsMinimized;
  frmPlanetsList.WindowState := wsMinimized;
  frmRoutes.WindowState := wsMinimized;
  frmEditor.WindowState := wsMinimized;
end;

procedure TfrmMKGal.SaveStatus1Click(Sender: TObject);
var
  i, j: integer;
  vTmp: string;
begin
  try
    frmEditor.DoSave;
  except

  end;
  try
    frmOrders.Memo1.Lines.SaveToFile(ExtractFilePath(ParamStr(0)) + 'orders_' + GetGameStr);
    vTmp := frmOrders.Memo1.Lines.Text;
  except
    ;
  end;
  try
    frmOrders.Memo1.Lines.Clear;
    for i := 0 to Application.ComponentCount - 1 do begin
      if Application.Components[i] is TForm then begin
        with TForm(Application.Components[i]) do begin
          for j := 0 to ComponentCount - 1 do begin
            try
              if Components[j] is TOvcFormState then
                TOvcFormState(Components[j]).SaveState
              else
                if Components[j] is TOvcComponentState then
                  TOvcComponentState(Components[j]).SaveState;
            except
              on e: Exception do
                Application.ShowException(e);
            end;
          end;
        end;
      end;
    end;
  finally
    frmOrders.Memo1.Lines.Text := vTmp;
  end;
end;

procedure TfrmMKGal.btnOverViewClick(Sender: TObject);
begin
  frmOverView.ShowModal;
end;

procedure TfrmMKGal.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_F6) then
    frmOrders.DoAnalyseButton;
end;

procedure TfrmMKGal.DebugError1Click(Sender: TObject);
begin
  PChar(nil)^ := #0;
end;

initialization
  Application.HelpFile := ExtractFilePath(ParamStr(0)) + 'MKGal.hlp';
end.

