unit UfrmOverView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, RzDlgBtn, StdCtrls, ComCtrls;

type
  tTabsSingle = array[0..2] of Single;
  TfrmOverView = class(TForm)
    TabControl1: TTabControl;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    lblPopulation: TLabel;
    lblIndustry: TLabel;
    lblEffIndustry: TLabel;
    lblTotalTech: TLabel;
    lblDriveTech: TLabel;
    lblWeaponsTech: TLabel;
    lblShieldTech: TLabel;
    lblCargoTech: TLabel;
    RzDialogButtons1: TRzDialogButtons;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    lblCOL: TLabel;
    lblCAP: TLabel;
    lblMAT: TLabel;
    lblPopulationDelta: TLabel;
    lblIndustryDelta: TLabel;
    lblEffIndustryDelta: TLabel;
    lblTotalTechDelta: TLabel;
    lblDriveTechDelta: TLabel;
    lblWeaponsTechDelta: TLabel;
    lblShieldTechDelta: TLabel;
    lblCargoTechDelta: TLabel;
    lblPopulationPercent: TLabel;
    procedure FormShow(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
  private
    Fpopulation: tTabsSingle;
    fIndustry: tTabsSingle;
    fEffIndustry: tTabsSingle;
    fTotalTech: tTabsSingle;
    fDriveTech: tTabsSingle;
    fWeaponsTech: tTabsSingle;
    fShieldTech: tTabsSingle;
    fCargoTech: tTabsSingle;
    fCOL: tTabsSingle;
    fCAP: tTabsSingle;
    fMAT: tTabsSingle;

    fcalculated: tTabsSingle;
    { Private declarations }
  public
    procedure CalcCurrentTurn(index: integer);
    procedure NextTurn(index: integer);
    procedure ShowValues;
    { Public declarations }
  end;

var
  frmOverView: TfrmOverView;

implementation

{$R *.DFM}

uses
  UFiles, UTypes, UfrmOrders, UDevelop;

{ TfrmOverView }

procedure TfrmOverView.CalcCurrentTurn(index: integer);
var
  i: integer;
  planet: TPlanet;
begin
  Fpopulation[Index] := qReportPlayer.PopulationCur;
  fIndustry[Index] := qReportPlayer.IndustryCur;
  fEffIndustry[Index] := qReportPlayer.EffIndustryCur;
  fDriveTech[Index] := qReportPlayer.DriveCur;
  fWeaponsTech[Index] := qReportPlayer.WeaponsCur;
  fShieldTech[Index] := qReportPlayer.ShieldCur;
  fCargoTech[Index] := qReportPlayer.CargoCur;
  fTotalTech[Index] := fDriveTech[Index] +
                       fWeaponsTech[Index] +
                       fShieldTech[Index] +
                       fCargoTech[Index];
  fCOL[Index] := 0;
  fCAP[Index] := 0;
  fMAT[Index] := 0;
  for i := 0 to planets.Count - 1 do begin
    planet := TPlanet(planets.objects[i]);
    if planet.PlayerCur = qReportPlayer then begin
      fCOL[Index] := fCOL[Index] + planet.ColonistCur;
      fCAP[Index] := fCAP[Index] + planet.CapitalCur;
      fMAT[Index] := fMAT[Index] + planet.MaterialCur;
    end;
  end;
end;

procedure TfrmOverView.NextTurn(index: integer);
var
  planet: TPlanet;
  i: integer;
  devPlanet: Tdevplanet;
begin
  for i := 0 to planets.Count - 1 do begin
    planet := TPlanet(planets.objects[i]);
    if planet.PlayerCur = qReportPlayer then begin
      case planet.ProcucingType of
        DRIVE:   fDriveTech[Index] := fDriveTech[Index] + planet.ProduceAmount;
        WEAPONS: fWeaponsTech[Index] := fWeaponsTech[Index] + planet.ProduceAmount;
        SHIELDS: fShieldTech[Index] := fShieldTech[Index] + planet.ProduceAmount;
        CARGO:   fCargoTech[Index] := fCargoTech[Index] + planet.ProduceAmount;
      end;
    end;
  end;
  fTotalTech[Index] := fDriveTech[Index] +
                       fWeaponsTech[Index] +
                       fShieldTech[Index] +
                       fCargoTech[Index];

  Fpopulation[Index] := 0;
  fIndustry[Index] := 0;
  fEffIndustry[Index] := 0;
  fCOL[Index] := 0;
  fCAP[Index] := 0;
  fMAT[Index] := 0;
  for i := 0 to devplanets.Count -1 do begin
    devPlanet := TdevPlanet(devPlanets.Objects[i]);
    if Assigned(devPlanet) and Assigned(devPlanet.orgPlanet) then begin
      if not Assigned(devPlanet.orgPlanet.PlayerCur) or
        (devPlanet.orgPlanet.PlayerCur = qReportPlayer) then begin
        Fpopulation[Index] := Fpopulation[Index] + devPlanet.devPopulation[1];
        fIndustry[Index] := fIndustry[Index] + devPlanet.devIndustry[1];
        fCOL[Index] := fCOL[Index] + devPlanet.devCOL[1];
        fCAP[Index] := fCAP[Index] + devPlanet.devCAP[1];
        fMAT[Index] := fMAT[Index] + devPlanet.devMAT[1];
      end;
    end;

  end;
  fEffIndustry[Index] := fIndustry[Index] +
                         (Fpopulation[Index] -
                          fIndustry[Index]) / 4;
end;

procedure TfrmOverView.ShowValues;
var
  index: integer;
begin
  for index := 2 downto 0 do begin
    if fcalculated[Index] = 0 then begin

      if Index = 2 then
        AnalyseerOrdersWithoutSending
      else
        frmOrders.DoAnalyseButton;
      CalcCurrentTurn(index);
      fcalculated[Index] := 1;
      if Index > 0 then
        NextTurn(index);
    end;
  end;
  if TabControl1.TabIndex > 0 then begin
    lblPopulationDelta.Caption := Format('%5.2f', [Fpopulation[TabControl1.TabIndex] - Fpopulation[0]]);
    lblIndustryDelta.Caption := Format('%5.2f', [fIndustry[TabControl1.TabIndex] - fIndustry[0]]);
    lblEffIndustryDelta.Caption := Format('%5.2f', [fEffIndustry[TabControl1.TabIndex] - fEffIndustry[0]]);
    lblTotalTechDelta.Caption := Format('%5.2f', [fTotalTech[TabControl1.TabIndex] - fTotalTech[0]]);
    lblDriveTechDelta.Caption := Format('%5.2f', [fDriveTech[TabControl1.TabIndex] - fDriveTech[0]]);
    lblWeaponsTechDelta.Caption := Format('%5.2f', [fWeaponsTech[TabControl1.TabIndex] - fWeaponsTech[0]]);
    lblShieldTechDelta.Caption := Format('%5.2f', [fShieldTech[TabControl1.TabIndex] - fShieldTech[0]]);
    lblCargoTechDelta.Caption := Format('%5.2f', [fCargoTech[TabControl1.TabIndex] - fCargoTech[0]]);
    if Fpopulation[0] > 0 then lblPopulationPercent.Caption := Format('(%5.2f)', [(Fpopulation[TabControl1.TabIndex] - Fpopulation[0]) / Fpopulation[0] * 100]) else lblPopulationPercent.Caption := '';
  end else begin
    lblPopulationDelta.Caption := '';
    lblIndustryDelta.Caption := '';
    lblEffIndustryDelta.Caption := '';
    lblTotalTechDelta.Caption := '';
    lblDriveTechDelta.Caption := '';
    lblWeaponsTechDelta.Caption := '';
    lblShieldTechDelta.Caption := '';
    lblCargoTechDelta.Caption := '';
    lblPopulationPercent.Caption := '';
  end;
  lblPopulation.Caption := Format('%5.2f', [Fpopulation[TabControl1.TabIndex]]);
  lblIndustry.Caption := Format('%5.2f', [fIndustry[TabControl1.TabIndex]]);
  lblEffIndustry.Caption := Format('%5.2f', [fEffIndustry[TabControl1.TabIndex]]);
  lblTotalTech.Caption := Format('%5.3f', [fTotalTech[TabControl1.TabIndex]]);
  lblDriveTech.Caption := Format('%5.3f', [fDriveTech[TabControl1.TabIndex]]);
  lblWeaponsTech.Caption := Format('%5.3f', [fWeaponsTech[TabControl1.TabIndex]]);
  lblShieldTech.Caption := Format('%5.3f', [fShieldTech[TabControl1.TabIndex]]);
  lblCargoTech.Caption := Format('%5.3f', [fCargoTech[TabControl1.TabIndex]]);

  lblCOL.Caption := Format('%5.3f', [fCOL[TabControl1.TabIndex]]);
  lblCAP.Caption := Format('%5.3f', [fCAP[TabControl1.TabIndex]]);
  lblMAT.Caption := Format('%5.3f', [fMAT[TabControl1.TabIndex]]);
end;

procedure TfrmOverView.FormShow(Sender: TObject);
begin
  fcalculated[0] := 0;
  fcalculated[1] := 0;
  fcalculated[2] := 0;
  ShowValues;
end;

procedure TfrmOverView.TabControl1Change(Sender: TObject);
begin
  ShowValues;
end;

end.
