unit UfrmPlanetslist;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, EnhListView, ExtListView, StdCtrls, ExtCtrls, UTypes, UFiles,
  OvcBase, OvcState, Menus, EC_Main, mkListView, UmkListviewExport;

type
  TfrmPlanetslist = class(TForm)
    Panel1: TPanel;
    cbxPlayers: TComboBox;
    Label1: TLabel;
    OvcFormState1: TOvcFormState;
    pmuLvPlanets: TPopupMenu;
    Orders1: TMenuItem;
    Export1: TMenuItem;
    CalculateDistanceFrom1: TMenuItem;
    N1: TMenuItem;
    SelectAll1: TMenuItem;
    Expressions1: TMenuItem;
    N2: TMenuItem;
    btnExpressions: TButton;
    FindPlanetinOrders1: TMenuItem;
    mniAddToClipboardAsDevPlanets1: TMenuItem;
    mniAddToClipboardAsPlanetstoProduce1: TMenuItem;
    UnmarkPlanetsinMap1: TMenuItem;
    MarkPlanetsinMap1: TMenuItem;
    N4: TMenuItem;
    btnRefresh: TButton;
    btnCalculate: TButton;
    ClaimOwnership1: TMenuItem;
    Button1: TButton;
    Viewplanetscentered1: TMenuItem;
    OvcComponentState1: TOvcComponentState;
    mniCreateEliteName: TMenuItem;
    mkListView1: TmkListView;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);
    procedure pmuLvPlanetsPopup(Sender: TObject);
    procedure CalculateDistanceFrom1Click(Sender: TObject);
    procedure Export1Click(Sender: TObject);
    procedure cbxPlayersClick(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure Expressions1Click(Sender: TObject);
    procedure FindPlanetinOrders1Click(Sender: TObject);
    procedure mniAddToClipboardAsDevPlanets1Click(Sender: TObject);
    procedure mniAddToClipboardAsPlanetstoProduce1Click(Sender: TObject);
    procedure UnmarkPlanetsinMap1Click(Sender: TObject);
    procedure MarkPlanetsinMap1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure btnCalculateClick(Sender: TObject);
    procedure ClaimOwnership1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Viewplanetscentered1Click(Sender: TObject);
    procedure mniCreateEliteNameClick(Sender: TObject);
    procedure mkListView1Data(Sender: TObject; Item: TListItem);
    procedure mkListView1SortBegin(SortDirection: TmkSortDirection;
      SortColumn: Integer);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    FSelectedPlanets: TList;
    FLastIndex: integer;
    FOldIdleEvent: TIdleEvent;
    FExportMkListView: TExportMkListView;
    procedure DoOnIdle(Sender: TObject; var Done: boolean);
    procedure AddDataPlanet(planet: TPlanet; owner: string);
    function CreateSelectedPlanets(MainPlayer: boolean): boolean;
    function ShouldWeAdd(planet: TPlanet; out owner: string): boolean;
    procedure ClearDataListView;
    { Private declarations }
  public
    property SelectedPlanets: TList read FSelectedPlanets;
    procedure DoRefresh;
    { Public declarations }
  end;

var
  frmPlanetslist: TfrmPlanetslist;

function DoBigPlanetDataComp(Item1, Item2: Pointer;
                             SortDirection: TmkSortDirection;
                             aColumn: integer): Integer;
function CompareInt(aInt1, aInt2: integer): integer; overload;
function CompareInt(aInt1, aInt2: string): integer; overload;
function CompareFloat(aFloat1, aFloat2: single): integer; overload;
function CompareFloat(aFloat1, aFloat2: string): integer;  overload;

implementation

uses
  UfrmMain, UfrmNewMap, UfrmPlanets, UfrmSelectExpression, UfrmOrders, clipbrd,
  UfrmCalculations, mkStrUtils, UfrmAutoCargoSettings;

{$R *.DFM}

function CompareInt(aInt1, aInt2: integer): integer; overload;
begin
  if aInt1 < aInt2 then Result := -1
  else
    if aInt1 > aInt2 then Result := 1
    else
      Result := 0;
end;

function CompareInt(aInt1, aInt2: string): integer; overload;
begin
  Result := CompareInt(mkAtoI(aInt1), mkAtoI(aInt2));
end;

function CompareFloat(aFloat1, aFloat2: single): integer; overload;
begin
  if aFloat1 < aFloat2 then Result := -1
  else
    if aFloat1 > aFloat2 then Result := 1
    else
      Result := 0;
end;

function CompareFloat(aFloat1, aFloat2: string): integer;  overload;
begin
  if aFloat1 = '' then
    Result := -1
  else
    if aFloat2 = '' then
      Result := 1
    else
      Result := CompareFloat(StrToFloat(aFloat1), StrToFloat(aFloat2));
end;

function DoBigPlanetDataComp(Item1, Item2: Pointer;
                               SortDirection: TmkSortDirection;
                               aColumn: integer): Integer;
begin
  case aColumn of
    0: Result := CompareText(PBigPlanetData(Item1).Name,
                             PBigPlanetData(Item2).Name);
    1: Result := CompareInt(PBigPlanetData(Item1).Nr,
                            PBigPlanetData(Item2).Nr);
    2: Result := CompareText(PBigPlanetData(Item1).Owner,
                             PBigPlanetData(Item2).Owner);
    3: Result := CompareFloat(PBigPlanetData(Item1).Distance,
                              PBigPlanetData(Item2).Distance);
    4: Result := CompareFloat(PBigPlanetData(Item1).EffInd,
                              PBigPlanetData(Item2).EffInd);
    5: Result := CompareFloat(PBigPlanetData(Item1).ShipMass,
                              PBigPlanetData(Item2).ShipMass);
    6: Result := CompareFloat(PBigPlanetData(Item1).Size,
                              PBigPlanetData(Item2).Size);
    7: Result := CompareFloat(PBigPlanetData(Item1).Res,
                              PBigPlanetData(Item2).Res);
    8: Result := CompareFloat(PBigPlanetData(Item1).Pop,
                              PBigPlanetData(Item2).Pop);
    9: Result := CompareFloat(PBigPlanetData(Item1).Ind,
                              PBigPlanetData(Item2).Ind);
    10: Result := CompareFloat(PBigPlanetData(Item1).COL,
                              PBigPlanetData(Item2).COL);
    11: Result := CompareFloat(PBigPlanetData(Item1).CAP,
                              PBigPlanetData(Item2).CAP);
    12: Result := CompareFloat(PBigPlanetData(Item1).MAT,
                              PBigPlanetData(Item2).MAT);
    13: Result := CompareFloat(PBigPlanetData(Item1).MyMass,
                              PBigPlanetData(Item2).MyMass);
    14: Result := CompareFloat(PBigPlanetData(Item1).FrMass,
                              PBigPlanetData(Item2).FrMass);
    15: Result := CompareFloat(PBigPlanetData(Item1).EnMass,
                              PBigPlanetData(Item2).EnMass);
    16: Result := CompareFloat(PBigPlanetData(Item1).SeMass,
                              PBigPlanetData(Item2).SeMass);
    17: Result := CompareText(PBigPlanetData(Item1).ProdType,
                              PBigPlanetData(Item2).ProdType);
    18: if PBigPlanetData(Item1).planet.ProduceAmount <
           PBigPlanetData(Item2).planet.ProduceAmount then
          Result := -1
        else
          if PBigPlanetData(Item1).planet.ProduceAmount >
             PBigPlanetData(Item2).planet.ProduceAmount then
            Result := 1
          else
            Result := 0;
    19: Result := CompareFloat(PBigPlanetData(Item1).Buildability,
                              PBigPlanetData(Item2).Buildability);
  end;
  if SortDirection = sdDesc then
    Result := -Result;
end;

function TfrmPlanetslist.ShouldWeAdd(planet: TPlanet; out owner: string): boolean;
begin
  planet.SetLastOwner;
  case planet.LastOwnerType of
    1: owner := planet.LastOwnerName;
    2: if planet.LastOwnerTurn > -1 then
        owner := format('?(%d) %s', [planet.LastOwnerTurn, planet.LastOwnerName])
      else
        owner := '?';
    3: owner := format('??(%d) %s', [planet.LastOwnerTurn, planet.LastOwnerName]);
  end;
  Result := (cbxPlayers.ItemIndex = 0) or (cbxPlayers.Text = owner);
end;

procedure TfrmPlanetslist.AddDataPlanet(planet: TPlanet; owner: string);
var
  BigPlanetData: PBigPlanetData;
begin
  new(BigPlanetData);
  BigPlanetData.Name := planet.Name;
  BigPlanetData.planet := planet;
  BigPlanetData.Nr := mkIToA(planet.Nr);
  BigPlanetData.Owner := owner;
  BigPlanetData.Distance := FloatToStrF(planet.Distance / 100, ffFixed, 5, 2);
  BigPlanetData.EffInd := FloatToStrF(planet.EffIndustryCur, ffFixed, 5, 2);
  BigPlanetData.ShipMass := FloatToStrF(planet.EffMassProduceCur, ffFixed, 5, 2);
  BigPlanetData.Size := FloatToStrF(planet.Size, ffFixed, 5, 2);
  BigPlanetData.Res := FloatToStrF(planet.Resources, ffFixed, 5, 2);
  BigPlanetData.Pop := FloatToStrF(planet.PopulationCur, ffFixed, 5, 2);
  BigPlanetData.Ind := FloatToStrF(planet.IndustryCur, ffFixed, 5, 2);
  BigPlanetData.COL := FloatToStrF(planet.ColonistCur, ffFixed, 5, 2);
  BigPlanetData.CAP := FloatToStrF(planet.CapitalCur, ffFixed, 5, 2);
  BigPlanetData.MAT := FloatToStrF(planet.MaterialCur, ffFixed, 5, 2);
  BigPlanetData.MyMass := FloatToStrF(planet.MyShipMass, ffFixed, 5, 2);
  BigPlanetData.FrMass := FloatToStrF(planet.FriendShipMass, ffFixed, 5, 2);
  BigPlanetData.EnMass := FloatToStrF(planet.EnemyShipMass, ffFixed, 5, 2);
  BigPlanetData.SeMass := FloatToStrF(planet.SendedShipMass, ffFixed, 5, 2);
  BigPlanetData.ProdType := planet.ProduceType;
  BigPlanetData.ProdAmount := concat(FloatToStrF(planet.ProduceAmount, ffFixed, 5, 3),
    ' (',
    FloatToStrF(planet.ProduceAmountFull, ffFixed, 5, 3),
    ')');
  BigPlanetData.Buildability := FloatToStrF(planet.Buildability, ffFixed, 5, 2);

  mkListview1.ViewList.Add(BigPlanetData);
end;

procedure TfrmPlanetslist.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  WindowState := wsMinimized;
  CanClose := false;
end;

procedure TfrmPlanetslist.FormShow(Sender: TObject);
var
  i: integer;
  planet: TPlanet;
  owner: string;
  vCols: string;
  list: TStringList;
begin
  mniCreateEliteName.Visible := inivars.EliteNameCreation;
  InitBuildability;
  mkListview1.Items.BeginUpdate;
  ClearDataListView;
  list := TStringList.Create;
  try
    for i := 0 to planets.Count - 1 do begin
      planet := TPlanet(planets.Objects[i]);
      ShouldWeAdd(planet, owner);
      if CompareText(owner, qReportPlayer.Name) = 0 then begin
        AddDataPlanet(planet, owner);
      end;
      if list.IndexOf(owner) = -1 then
        list.Add(owner);
    end;
    cbxPlayers.Items.Assign(list);
    cbxPlayers.Sorted := True;
    cbxPlayers.Items.InsertObject(0, '(All)', TObject(0));
    cbxPlayers.ItemIndex := cbxplayers.Items.IndexOf(qReportPlayer.Name);
  finally
    mkListview1.Items.Count := mkListView1.ViewList.Count;
    mkListView1.ViewList.MkSort;
    mkListview1.Items.EndUpdate;
    list.Free;
  end;
  OvcFormState1.Storage.Open;
  vCols := OvcFormState1.Storage.ReadString('frmPlanetslist', 'mkListview1_Order', '');
  OvcFormState1.Storage.Close;
  MkListviewColumnsFromString(mkListView1, vCols);
end;

procedure TfrmPlanetslist.pmuLvPlanetsPopup(Sender: TObject);
var
  blnPlanetSelected: boolean;
  blnPlanetsSelected: boolean;
begin
  blnPlanetSelected := mkListView1.SelCount = 1;
  blnPlanetsSelected := mkListView1.SelCount > 0;
  MarkPlanetsinMap1.Enabled := blnPlanetsSelected;
  CalculateDistanceFrom1.Enabled := blnPlanetSelected;
  ClaimOwnerShip1.Visible := inivars.Gametype = gtGalaxyNG;
  FindPlanetinOrders1.Enabled := blnPlanetSelected;
  mniAddToClipboardAsDevPlanets1.Enabled := blnPlanetsSelected;
  mniAddToClipboardAsPlanetstoProduce1.Enabled := blnPlanetsSelected;
  mniCreateEliteName.Enabled := blnPlanetsSelected;
end;

procedure TfrmPlanetslist.CalculateDistanceFrom1Click(Sender: TObject);
var
  i: integer;
  x0, y0: integer;
begin
  mkListview1.Items.BeginUpdate;
  try
    x0 := PBigPlanetData(mkListview1.ViewList[mkListview1.Selected.index]).planet.X;
    y0 := PBigPlanetData(mkListview1.ViewList[mkListview1.Selected.index]).planet.Y;
    for i := 0 to mkListview1.Items.Count - 1 do begin
      PBigPlanetData(mkListview1.ViewList[i]).planet.SetDistanceFrom(x0, y0);
      PBigPlanetData(mkListview1.ViewList[i]).Distance := format('%5.2f', [PBigPlanetData(mkListview1.ViewList[i]).planet.Distance / 100]);
    end;
  finally
    mkListview1.Items.EndUpdate;
  end;
end;

procedure TfrmPlanetslist.Export1Click(Sender: TObject);
begin
  FExportMkListView.Choose;
end;

procedure TfrmPlanetslist.cbxPlayersClick(Sender: TObject);
var
  i: integer;
  planet: TPlanet;
  owner: string;
begin
  mkListview1.Items.BeginUpdate;
  Screen.Cursor := crHourGlass;
  try
    ClearDataListView;
    for i := 0 to planets.Count - 1 do begin
      planet := TPlanet(planets.Objects[i]);
      if ShouldWeAdd(planet, owner) then begin
        AddDataPlanet(planet, owner);
      end;
    end;
  finally
    mkListview1.Items.Count := mkListview1.ViewList.Count;
    mkListView1.ViewList.MkSort;
    mkListview1.Items.EndUpdate;
    Screen.Cursor := crDefault;
  end;
end;

procedure TfrmPlanetslist.SelectAll1Click(Sender: TObject);
begin
  mkListView1.SelectAll;
end;

procedure TfrmPlanetslist.Expressions1Click(Sender: TObject);
var
  i: integer;
  planet: Tplanet;
  planetsList: TList;
  owner: string;
begin
  planetsList := TList.Create;
  try
    for i := 0 to mkListView1.ViewList.Count - 1 do
      planetsList.Add(PBigPlanetData(mkListView1.ViewList[i]).planet);
    planetExpressionsExecute(Planets, planetsList);

    mkListView1.Items.BeginUpdate;
    try
      ClearDataListView;
      for i := 0 to planetsList.Count - 1 do begin
        Planet := TPlanet(planetsList.Items[i]);
        if ShouldWeAdd(planet, owner) then
          AddDataPlanet(Planet, owner);
      end;
    finally
      mkListView1.Items.Count := mkListView1.ViewList.Count;
      mkListView1.ViewList.MkSort;
      mkListView1.Items.EndUpdate;
    end;
  finally
    planetsList.Free;
  end;
end;

procedure TfrmPlanetslist.FindPlanetinOrders1Click(Sender: TObject);
begin
  if Assigned(mkListview1.Selected) then
    frmOrders.FindFirstPlanetInOrders(PBigPlanetData(mkListview1.ViewList[mkListview1.Selected.index]).Name);
end;

procedure TfrmPlanetslist.mniAddToClipboardAsDevPlanets1Click(
  Sender: TObject);
begin
  mkListview1.GetSelectedItems;
  OrdersDataDevPlanets(mkListview1.SelectedList, 2);
end;

procedure TfrmPlanetslist.mniAddToClipboardAsPlanetstoProduce1Click(
  Sender: TObject);
begin
  mkListview1.GetSelectedItems;
  OrdersDataProduceOnPlanets(mkListview1.SelectedList, 2);
end;

procedure TfrmPlanetslist.UnmarkPlanetsinMap1Click(Sender: TObject);
begin
  frmNewMap.RemoveCursors;
  frmNewMap.Repaint;
end;

procedure TfrmPlanetslist.MarkPlanetsinMap1Click(Sender: TObject);
var
  i: integer;
begin
  if CreateSelectedPlanets(false) then begin
    frmNewMap.RemoveCursors;
    for i := 0 to FSelectedPlanets.Count - 1 do begin
      frmNewMap.AddCursor(TPlanet(FSelectedPlanets[i]));
    end;
    frmNewMap.Repaint;
  end;
end;

procedure TfrmPlanetslist.FormCreate(Sender: TObject);
begin
  mkListView1.ViewList.CompareFunc := DoBigPlanetDataComp;
  FSelectedPlanets := TList.Create;
  FLastIndex := -1;
  FExportMkListView := TExportMkListView.Create(Self);
  FExportMkListView.ExportType := xHTML;
  FExportMkListView.Options := [ExportAllWhenNoneSelected,
                                SelectedRowsOnly,
                                ShowClipboardMsg,
                                ShowProgress,
                                TimeStamp];
  FExportMkListView.Header := 'Planets';
  FExportMkListView.Footer := frmMKGal.Caption;
  FExportMkListView.Title := 'MKGal';
  FExportMkListView.ViewOnly := true;
  FExportMkListView.ListView := mkListView1;
end;

procedure TfrmPlanetslist.FormDestroy(Sender: TObject);
begin
  ClearDataListView;
  FSelectedPlanets.Free;
  FExportMkListView.Free;
end;

function TfrmPlanetslist.CreateSelectedPlanets(
  MainPlayer: boolean): boolean;
var
  i: integer;
begin
  FSelectedPlanets.Clear;
  for i := 0 to mkListview1.Items.Count - 1 do begin
    if mkListview1.Items[i].Selected then
      if not MainPlayer or (MainPlayer and (PBigPlanetData(mkListview1.ViewList[i]).planet.PlayerCur = qReportplayer)) then
        FSelectedPlanets.Add(PBigPlanetData(mkListview1.ViewList[i]).planet);
  end;
  Result := FSelectedPlanets.Count > 0;
end;

procedure TfrmPlanetslist.btnRefreshClick(Sender: TObject);
begin
  DoRefresh;
end;

procedure TfrmPlanetslist.DoRefresh;
var
  i: integer;
  planet: TPlanet;
  OldCur: TCursor;
  BigPlanetData: PBigPlanetData;
begin
  OldCur := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  mkListView1.Items.BeginUpdate;
  try
    for i := 0 to mkListView1.ViewList.Count - 1 do begin
      BigPlanetData := mkListView1.ViewList[i];
      planet := BigPlanetData.planet;
      BigPlanetData.ShipMass := FloatToStrF(planet.EffMassProduceCur, ffFixed, 5, 2);
      BigPlanetData.SeMass := Format('%5.2f', [planet.SendedShipMass]);
      BigPlanetData.ProdType := planet.ProduceType;
      BigPlanetData.ProdAmount := Format('%5.3f (%5.3f)', [planet.ProduceAmount, planet.ProduceAmountFull]);
      BigPlanetData.Buildability := Format('%5.2f', [planet.Buildability]);
    end;
  finally
    mkListView1.Items.EndUpdate;
    Screen.Cursor := OldCur;
  end;
end;

procedure TfrmPlanetslist.btnCalculateClick(Sender: TObject);
begin
  CreateSelectedPlanets(false);
  frmCalculations.ShowModal;
end;

procedure TfrmPlanetslist.ClaimOwnership1Click(Sender: TObject);
begin
  mkListview1.GetSelectedItems;
  OrdersDataClaimPlanets(mkListview1.SelectedList, 2);
end;

procedure TfrmPlanetslist.Button1Click(Sender: TObject);
var
  i: integer;
  planet: Tplanet;
  planetsList: TList;
  AllPlanets: TStringList;
  owner: string;
begin
  planetsList := nil;
  AllPlanets := nil;
  try
    planetsList := TList.Create;
    AllPlanets := TStringList.Create;
    for i := 0 to mkListView1.ViewList.Count - 1 do begin
      planetsList.Add(PBigPlanetData(mkListView1.ViewList[i]).planet);
      AllPlanets.AddObject(PBigPlanetData(mkListView1.ViewList[i]).name, PBigPlanetData(mkListView1.ViewList[i]).planet);
    end;

    planetExpressionsExecute(AllPlanets, planetsList);

    mkListView1.Items.BeginUpdate;
    try
      ClearDataListView;
      for i := 0 to planetsList.Count - 1 do begin
        Planet := TPlanet(planetsList.Items[i]);
        ShouldWeAdd(planet, owner);
        AddDataPlanet(Planet, owner);
      end;
    finally
      mkListView1.Items.Count := mkListView1.ViewList.Count;
      mkListView1.ViewList.MkSort;
      mkListView1.Items.EndUpdate;
    end;
  finally
    planetsList.Free;
    AllPlanets.Free;
  end;
end;

procedure TfrmPlanetslist.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_F5) then
    DoRefresh;
  if (Key = VK_F6) then
    frmOrders.DoAnalyseButton;
end;

procedure TfrmPlanetslist.Viewplanetscentered1Click(Sender: TObject);
begin
  Viewplanetscentered1.Checked := not Viewplanetscentered1.Checked;
end;

procedure TfrmPlanetslist.mniCreateEliteNameClick(Sender: TObject);
var
  i: integer;
  planet: TPlanet;
begin
  for i := 0 to mkListview1.Items.Count - 1 do begin
    if mkListview1.Items[i].Selected then begin
      planet := PBigPlanetData(mkListview1.ViewList[i]).planet;
      if planet.PlayerCur = qreportPlayer then begin
        frmPlanets.CreateRandomName(planet);
      end;
    end;
  end;
end;

procedure TfrmPlanetslist.ClearDataListView;
var
  i: integer;
  BigPlanetData: PBigPlanetData;
begin
  mkListview1.Items.Clear;
  for i := 0 to mkListview1.ViewList.Count -1 do begin
    BigPlanetData := mkListview1.ViewList[i];
    BigPlanetData.Name := '';
    BigPlanetData.Nr := '';
    BigPlanetData.Owner := '';
    BigPlanetData.Distance := '';
    BigPlanetData.EffInd := '';
    BigPlanetData.ShipMass := '';
    BigPlanetData.Size := '';
    BigPlanetData.Res := '';
    BigPlanetData.Pop := '';
    BigPlanetData.Ind := '';
    BigPlanetData.COL := '';
    BigPlanetData.CAP := '';
    BigPlanetData.MAT := '';
    BigPlanetData.MyMass := '';
    BigPlanetData.FrMass := '';
    BigPlanetData.EnMass := '';
    BigPlanetData.SeMass := '';
    BigPlanetData.ProdType := '';
    BigPlanetData.ProdAmount := '';
    BigPlanetData.Buildability := '';
    dispose(BigPlanetData);
  end;
  mkListview1.ViewList.Clear;
end;

procedure TfrmPlanetslist.mkListView1Data(Sender: TObject;
  Item: TListItem);
var
  BigPlanetData: PBigPlanetData;
begin
  BigPlanetData := mklistview1.ViewList[item.index];
  Item.Caption := BigPlanetData.Name;
  Item.SubItems.Add(BigPlanetData.Nr);
  Item.SubItems.Add(BigPlanetData.Owner);
  Item.SubItems.Add(BigPlanetData.Distance);
  Item.SubItems.Add(BigPlanetData.EffInd);
  Item.SubItems.Add(BigPlanetData.ShipMass);
  Item.SubItems.Add(BigPlanetData.Size);
  Item.SubItems.Add(BigPlanetData.Res);
  Item.SubItems.Add(BigPlanetData.Pop);
  Item.SubItems.Add(BigPlanetData.Ind);
  Item.SubItems.Add(BigPlanetData.COL);
  Item.SubItems.Add(BigPlanetData.CAP);
  Item.SubItems.Add(BigPlanetData.MAT);
  Item.SubItems.Add(BigPlanetData.MyMass);
  Item.SubItems.Add(BigPlanetData.FrMass);
  Item.SubItems.Add(BigPlanetData.EnMass);
  Item.SubItems.Add(BigPlanetData.SeMass);
  Item.SubItems.Add(BigPlanetData.ProdType);
  Item.SubItems.Add(BigPlanetData.ProdAmount);
  Item.SubItems.Add(BigPlanetData.Buildability);
end;

procedure TfrmPlanetslist.mkListView1SortBegin(
  SortDirection: TmkSortDirection; SortColumn: Integer);
var
  sColumn: string;
  sSort: string;
begin
  if SortDirection = sdAsc then sSort := 'Ascending'
                           else sSort := 'Descending';
  case SortColumn of
    0: sColumn := 'Name';
    1: sColumn := 'Unique number of Planet';
    2: sColumn := 'Owner of Planet';
    3: sColumn := 'Distance';
    4: sColumn := 'Effective Industry';
    5: sColumn := 'Shipmass Production';
    6: sColumn := 'Size';
    7: sColumn := 'Resources';
    8: sColumn := 'Population';
    9: sColumn := 'Industry';
    10: sColumn := 'COL Stockpiles';
    11: sColumn := 'CAP Stockpiles';
    12: sColumn := 'MAT Stockpiles';
    13: sColumn := 'My Shipmass';
    14: sColumn := 'Shipmass of other nations with Peace';
    15: sColumn := 'Shipmass of other nations with War';
    16: sColumn := 'Sent Shipmass';
    17: sColumn := 'Current Production Type';
    18: sColumn := 'Current Production Amount';
    19: sColumn := 'Buildability';
  else
    sColumn := 'Something :-)';
  end;
  Caption := Format('Planets list - sort %s on %s', [sSort, sColumn]);
end;

procedure TfrmPlanetslist.FormActivate(Sender: TObject);
begin
  FOldIdleEvent := Application.OnIdle;
  Application.OnIdle := DoOnIdle;
end;

procedure TfrmPlanetslist.FormDeactivate(Sender: TObject);
begin
  Application.OnIdle := FOldIdleEvent;
end;

procedure TfrmPlanetslist.DoOnIdle(Sender: TObject; var Done: boolean);
begin
  if not (Assigned(frmNewMap) and Assigned(frmPlanets)) then Exit;
  if frmNewMap.DoNotpointPlanet then Exit;
  if Assigned(mkListview1.selected) then begin
    if FLastIndex <> mkListview1.selected.Index then begin
      FLastIndex := mkListview1.selected.Index;
      frmPlanets.ShowPlanet2(PBigPlanetData(mkListview1.ViewList[FLastIndex]).planet, Viewplanetscentered1.Checked);
    end;
  end;
end;

procedure TfrmPlanetslist.FormHide(Sender: TObject);
var
  vCols: string;
begin
  MkListviewColumnsToString(mkListView1, vCols);
  OvcFormState1.Storage.Open;
  OvcFormState1.Storage.WriteString('frmPlanetsList', 'mkListview1_Order', vCols);
  OvcFormState1.Storage.Close;
end;

end.
