unit UfrmPlayers;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, EnhListView, ExtListView, OvcBase, OvcState, EC_LView,
  EC_Main, EC_ExtLView;

type
  TfrmPlayers = class(TForm)
    PopupMenu1: TPopupMenu;
    mniGraph: TMenuItem;
    lvPlayers: TdfsExtListView;
    OvcFormState1: TOvcFormState;
    mniExport: TMenuItem;
    ExportExtListView1: TExportExtListView;
    N1: TMenuItem;
    CreateMessageTothisplayer1: TMenuItem;
    SetWartothisPlayer1: TMenuItem;
    SetPeacetothisPlayer1: TMenuItem;
    CreateGlobalMessage1: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lvPlayers1Click(Sender: TObject);
    procedure mniGraphClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mniExportClick(Sender: TObject);
    procedure lvPlayersKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure SetWartothisPlayer1Click(Sender: TObject);
    procedure SetPeacetothisPlayer1Click(Sender: TObject);
    procedure CreateGlobalMessage1Click(Sender: TObject);
    procedure CreateMessageTothisplayer1Click(Sender: TObject);
    procedure lvPlayersSortBegin(Sender: TObject; SortColumn: Integer;
      Ascending: Boolean);
  private
    FIsInitialized: boolean;
    procedure DoInit;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPlayers: TfrmPlayers;

implementation

uses Utypes, UfrmGraph, UfrmMain, UfrmOrders, UfrmNewMap, UfrmCreateMessage;

{$R *.DFM}

var
  SortDown: boolean;

procedure TfrmPlayers.DoInit;
var
  i: integer;
  tTech, dTTech,
    drive, dDrive,
    weapon, dWeapon,
    shield, dShield,
    cargo, dCargo: single;
  player: Tplayer;
begin
  if not FIsInitialized then
  begin
    for i := 0 to players.Count - 1 do
    begin
      player := TPlayer(players.Objects[i]);
      with lvPlayers.Items.Add do
      begin
        drive := player.DriveCur;
        dDrive := player.DriveDCur;
        weapon := player.WeaponsCur;
        dWeapon := player.WeaponsDCur;
        shield := player.ShieldCur;
        dShield := player.ShieldDCur;
        cargo := player.CargoCur;
        dCargo := player.CargoDCur;
        tTech := drive + weapon + shield + cargo;
        dTTech := dDrive + dweapon + dshield + dcargo;
        Caption := player.Name;
        SubItems.Add(IntToStr(Round(player.EffIndustryCur)));
        SubItems.Add(IntToStr(Round(player.EffIndustryDCur)));
        SubItems.Add(format('%3.2f', [tTech]));
        SubItems.Add(format('%2.2f', [dTTech]));
        SubItems.Add(format('%3.2f', [drive]));
        SubItems.Add(format('%2.2f', [dDrive]));
        SubItems.Add(format('%3.2f', [weapon]));
        SubItems.Add(format('%2.2f', [dWeapon]));
        SubItems.Add(format('%3.2f', [shield]));
        SubItems.Add(format('%2.2f', [dshield]));
        SubItems.Add(format('%3.2f', [cargo]));
        SubItems.Add(format('%2.2f', [dcargo]));
        SubItems.Add(IntToStr(player.PlanetsCur));
        SubItems.Add(IntToStr(player.PlanetsDCur));
        SubItems.Add(IntToStr(Round(player.PopulationCur)));
        SubItems.Add(IntToStr(Round(player.PopulationDCur)));
        SubItems.Add(format('%4.2f', [player.PopulationPercentCur]));
        SubItems.Add(IntToStr(Round(player.IndustryCur)));
        SubItems.Add(IntToStr(Round(player.IndustryDCur)));
        SubItems.Add(IntToStr(Round(player.maxPopulationCur)));
        SubItems.Add(IntToStr(Round(player.maxPopulationCurD)));
        if player.War then SubItems.Add('Yes')
        else SubItems.Add('No');
        SubItems.Add(player.OldNames);
        data := players.Objects[i];
      end;
    end;
    FIsInitialized := True;
  end;
end;

procedure TfrmPlayers.FormShow(Sender: TObject);
begin
  DoInit;
end;

procedure TfrmPlayers.FormCreate(Sender: TObject);
begin
  FIsInitialized := False;
end;

function SortPlayers(lParam1, lParam2, lParamSort: Integer): Integer; stdcall;
var
  item1, item2: single;
begin
  if lParamSort = 0 then
    Result := -AnsiCompareText(TListItem(lParam1).Caption, TListItem(lParam2).Caption)
  else
  begin
    item1 := StrToFloat(TListItem(lParam1).SubItems[lParamSort - 1]);
    item2 := StrToFloat(TListItem(lParam2).SubItems[lParamSort - 1]);
    if item1 < item2 then
      Result := -1
    else
      if item1 > item2 then
        Result := 1
      else
        Result := 0;
  end;
  if SortDown then Result := -Result;
end;

procedure TfrmPlayers.lvPlayers1Click(Sender: TObject);
begin
  if Assigned(lvPlayers.Selected) then
    frmNewMap.SelectPlanets(lvPlayers.Selected.Data);
end;

procedure TfrmPlayers.mniGraphClick(Sender: TObject);
var
  i: integer;
begin
  frmGraph.ClearPlayersList;
  for i := 0 to lvPlayers.Items.Count - 1 do
    if lvPlayers.items[i].selected then
      frmGraph.PlayerList.Add(lvPlayers.items[i].data);
  frmGraph.ReCalculate;
end;

procedure TfrmPlayers.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  WindowState := wsMinimized;
  CanClose := false;
end;

procedure TfrmPlayers.mniExportClick(Sender: TObject);
begin
  ExportExtListview1.Footer := frmMKGal.Caption;
  ExportExtListview1.Choose;
end;

procedure TfrmPlayers.lvPlayersKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i: integer;
begin
  if ssCTRL in Shift then
    case Key of
      ord('A'), ord('a'): with TdfsExtListview(Sender) do begin
          BeginUpdate;
          for i := 0 to Items.Count - 1 do
            Items[i].Selected := True;
          EndUpdate;
        end;
    end;
end;

procedure TfrmPlayers.PopupMenu1Popup(Sender: TObject);
begin
  CreateMessageTothisplayer1.Enabled := lvPlayers.SelCount = 1;
  SetWartothisPlayer1.Enabled := lvPlayers.SelCount = 1;
  SetPeacetothisPlayer1.Enabled := lvPlayers.SelCount = 1;
  if assigned(lvPlayers.Selected) then begin
    SetPeacetothisPlayer1.Visible := TPlayer(lvPlayers.Selected.Data).War;
    SetWartothisPlayer1.Visible := not TPlayer(lvPlayers.Selected.Data).War;
  end;
end;

procedure TfrmPlayers.SetWartothisPlayer1Click(Sender: TObject);
begin
  frmOrders.InsertOtherCommand('W ' + TPlayer(lvPlayers.Selected.Data).Name);
end;

procedure TfrmPlayers.SetPeacetothisPlayer1Click(Sender: TObject);
begin
  frmOrders.InsertOtherCommand('A ' + TPlayer(lvPlayers.Selected.Data).Name);
end;

procedure TfrmPlayers.CreateGlobalMessage1Click(Sender: TObject);
begin
  frmCreateMessage.SendTo := '';
  if frmCreateMessage.ShowModal = mrOK then begin
    frmOrders.InsertOtherCommand(frmCreateMessage.StrMessage);
  end;
end;

procedure TfrmPlayers.CreateMessageTothisplayer1Click(Sender: TObject);
begin
  frmCreateMessage.SendTo := TPlayer(lvPlayers.Selected.Data).Name;
  if frmCreateMessage.ShowModal = mrOK then begin
    frmOrders.InsertOtherCommand(frmCreateMessage.StrMessage);
  end;
end;

procedure TfrmPlayers.lvPlayersSortBegin(Sender: TObject;
  SortColumn: Integer; Ascending: Boolean);
var
  sColumn: string;
  sSort: string;
begin
  if not Ascending then sSort := 'Ascending'
                   else sSort := 'Descending';
  case SortColumn of
    0: sColumn := 'Name';
    1: sColumn := 'Effective Industry';
    2: sColumn := 'Delta Effective Industry';
    3: sColumn := 'Total Technology';
    4: sColumn := 'Delta Total Technology';
    5: sColumn := 'Total Drive Technology';
    6: sColumn := 'Delta Drive Technology';
    7: sColumn := 'Total Weapons Technology';
    8: sColumn := 'Delta Weapons Technology';
    9: sColumn := 'Total Shields Technology';
    10: sColumn := 'Delta Shields Technology';
    11: sColumn := 'Total Cargo Technology';
    12: sColumn := 'Delta Cargo Technology';
    13: sColumn := 'Total Number of Planets';
    14: sColumn := 'Delta Number of Planets';
    15: sColumn := 'Total Population';
    16: sColumn := 'Delta Population';
    17: sColumn := 'Population Percent Growth';
    18: sColumn := 'Total Industry';
    19: sColumn := 'Delta Industry';
    20: sColumn := 'Maximal Population when all fully developed';
    21: sColumn := 'Delta Maximal Population when all fully developed';
    22: sColumn := 'War';
    23: sColumn := 'Old players names';
  else
    sColumn := 'Something :-)';
  end;
  Caption := Format('Players - sort %s on %s', [sSort, sColumn]);
end;

end.
