unit UfrmRoutes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, EnhListView, ExtListView, OvcBase, UTypes, OvcState, Menus, Commctrl;

type
  TfrmRoutes = class(TForm)
    lvRoutes: TdfsExtListView;
    OvcFormState1: TOvcFormState;
    pmuRoutes: TPopupMenu;
    DeleteRoute1: TMenuItem;
    DeleteAllRoutesforthisPlanet1: TMenuItem;
    N1: TMenuItem;
    DeleteAllRoutes1: TMenuItem;
    DeleteSelectedRoutes1: TMenuItem;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);
    procedure lvRoutesHotTrack(Sender: TObject; var ItemIndex: Integer;
      SubItemIndex: Integer; Location: TPoint; var AllowSelect: Boolean);
    procedure pmuRoutesPopup(Sender: TObject);
    procedure DeleteRoute1Click(Sender: TObject);
    procedure DeleteAllRoutesforthisPlanet1Click(Sender: TObject);
    procedure DeleteAllRoutes1Click(Sender: TObject);
    procedure DeleteSelectedRoutes1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    FPointPlanet: Tplanet;
    FPointLastplanet: TPlanet;
    FItem, FSubItem: Integer;
    { Private declarations }
  public
    procedure DoFillLvRoutes;
    { Public declarations }
  end;

var
  frmRoutes: TfrmRoutes;

implementation

{$R *.DFM}

uses
  UfrmMain, UfrmPlanets, UfrmOrders;

const
  SROUTETYPES: array[0..3] of string = ('CAP', 'COL', 'MAT', 'EMP');

procedure TfrmRoutes.DoFillLvRoutes;
var
  i: integer;
  route: TRoute;
  listItem: TListItem;
begin
  lvRoutes.BeginUpdate;
  try
    FPointPlanet := nil;
    FPointLastPlanet := nil;
    lvRoutes.Items.Clear;
    routes.Sorted := true;
    for i := 0 to routes.Count - 1 do begin
      route := TRoute(routes.objects[i]);
      if Assigned(route) and (assigned(route.COLTo) or Assigned(route.CAPTo) or
        Assigned(route.MATTo) or Assigned(route.EMPTo)) then begin
        listItem := lvRoutes.Items.Add;
        listItem.Data := route;
        listItem.Caption := route.PlanetFrom.Name;
        if Assigned(route.CAPTo) then
          listItem.SubItems.Add(route.CAPTo.Name)
        else
          listItem.SubItems.Add('');
        if Assigned(route.COLTo) then
          listItem.SubItems.Add(route.COLTo.Name)
        else
          listItem.SubItems.Add('');
        if Assigned(route.MATTo) then
          listItem.SubItems.Add(route.MATTo.Name)
        else
          listItem.SubItems.Add('');
        if Assigned(route.EMPTo) then
          listItem.SubItems.Add(route.EMPTo.Name)
        else
          listItem.SubItems.Add('');
      end;
    end;

  finally
    lvRoutes.EndUpdate;
  end;
end;

procedure TfrmRoutes.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  WindowState := wsMinimized;
  CanClose := false;
end;

procedure TfrmRoutes.FormShow(Sender: TObject);
begin
  DoFillLvRoutes;
end;

procedure TfrmRoutes.lvRoutesHotTrack(Sender: TObject;
  var ItemIndex: Integer; SubItemIndex: Integer; Location: TPoint;
  var AllowSelect: Boolean);
var
  route: TRoute;
begin
  FPointPlanet := nil;
  FItem := ItemIndex;
  FSubItem := SubItemIndex;
  if (ItemIndex <> -1) and Assigned(lvRoutes.Items[ItemIndex].Data) then begin
    route := TRoute(lvRoutes.Items[ItemIndex].Data);
    if SubItemIndex = 0 then
      FPointPlanet := route.PlanetFrom
    else
      if (SubItemIndex = 1) and Assigned(route.CapTo) then
        FPointPlanet := route.CapTo
      else
        if (SubItemIndex = 2) and Assigned(route.ColTo) then
          FPointPlanet := route.ColTo
        else
          if (SubItemIndex = 3) and Assigned(route.MatTo) then
            FPointPlanet := route.MatTo
          else
            if (SubItemIndex = 4) and Assigned(route.EmpTo) then
              FPointPlanet := route.EmpTo;
  end;
  if Assigned(FPointPlanet) and (FPointPlanet <> FPointLastPlanet) then begin
    FPointLastPlanet := FPointPlanet;
    if SubItemIndex = 0 then
      frmPlanets.ShowPlanet(FPointPlanet, true)
    else
      frmPlanets.ShowPlanet2(FPointPlanet, true);
  end;
end;

procedure TfrmRoutes.pmuRoutesPopup(Sender: TObject);
var
  CurPoint: TPoint;
  Info: TLVHitTestInfo;
begin
  GetCursorPos(CurPoint);
  CurPoint := lvRoutes.ScreenToClient(CurPoint);
  FItem := -1;
  FSubItem := 0;
  FPointPlanet := nil;

  Info.pt := CurPoint;
  if ListView_SubItemHitTest(lvRoutes.Handle, @Info) <> -1 then
    if (Info.iItem > -1) and (lvRoutes.Items[Info.iItem] <> nil) then begin
      FItem := Info.iItem;
      FSubItem := Info.iSubItem;
      FPointPlanet := lvRoutes.Items[FItem].Data;
    end;

  DeleteRoute1.Enabled := Assigned(FPointPlanet) and (FSubItem > 0) and
    (lvRoutes.Items[FItem].SubItems[FSubItem - 1] <> '');
  DeleteAllRoutesforthisPlanet1.Enabled := Assigned(FPointPlanet);
  DeleteAllRoutes1.Enabled := lvRoutes.Items.Count > 0;
  DeleteSelectedRoutes1.Enabled := lvRoutes.SelCount > 0;
end;

procedure TfrmRoutes.DeleteRoute1Click(Sender: TObject);
var
  strPlanet: string;
  i: integer;
begin
  strPlanet := lvRoutes.Items[FItem].Caption;
  case FSubItem of
    1: frmOrders.InsertRouteCommand('R ' + strPlanet + ' CAP');
    2: frmOrders.InsertRouteCommand('R ' + strPlanet + ' COL');
    3: frmOrders.InsertRouteCommand('R ' + strPlanet + ' MAT');
    4: frmOrders.InsertRouteCommand('R ' + strPlanet + ' EMP');
  end;
  lvRoutes.Items[FItem].SubItems[FSubItem - 1] := '';
  strPlanet := '';
  for i := 0 to 3 do
    strPlanet := strPlanet + lvRoutes.Items[FItem].SubItems[i];
  if strPlanet = '' then
    lvRoutes.Items.Delete(FItem);
end;

procedure TfrmRoutes.DeleteAllRoutesforthisPlanet1Click(Sender: TObject);
var
  i: integer;
  strPlanet: string;
begin
  strPlanet := lvRoutes.Items[FItem].Caption;
  for i := 0 to 3 do
    if lvroutes.Items[FItem].SubItems[i] <> '' then
      frmOrders.InsertRouteCommand('R ' + strPlanet + ' ' + SROUTETYPES[i]);
  lvRoutes.Items.Delete(FItem);
end;

procedure TfrmRoutes.DeleteAllRoutes1Click(Sender: TObject);
var
  i: integer;
  strPlanet: string;
begin
  while lvRoutes.Items.Count > 0 do begin
    strPlanet := lvRoutes.Items[0].Caption;
    for i := 0 to 3 do
      if lvroutes.Items[0].SubItems[i] <> '' then
        frmOrders.InsertRouteCommand('R ' + strPlanet + ' ' + SROUTETYPES[i]);
    lvRoutes.Items.Delete(0);
  end;
end;

procedure TfrmRoutes.DeleteSelectedRoutes1Click(Sender: TObject);
var
  i, j: integer;
  strPlanet: string;
begin
  j := 0;
  while j < lvRoutes.Items.Count do begin
    if lvRoutes.Items[j].Selected then begin
      strPlanet := lvRoutes.Items[j].Caption;
      for i := 0 to 3 do
        if lvroutes.Items[j].SubItems[i] <> '' then
          frmOrders.InsertRouteCommand('R ' + strPlanet + ' ' + SROUTETYPES[i]);
      lvRoutes.Items.Delete(j);
    end else
      inc(j);
  end;
end;

procedure TfrmRoutes.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_F6) then
    frmOrders.DoAnalyseButton;
end;

end.
