unit UfrmSelectExpression;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, OvcState,
  UfrmExpressionBuilder, UExpression, ActnList, OvcBase;

type
  TfrmSelectExpressions = class(TForm)
    OvcFormState1: TOvcFormState;
    MainMenu1: TMainMenu;
    mniEdit: TMenuItem;
    mniNew: TMenuItem;
    mniChange: TMenuItem;
    mniDelete: TMenuItem;
    mniTestExpression: TMenuItem;
    mnuLstExpressions: TPopupMenu;
    mniPopNew: TMenuItem;
    mniPopChange: TMenuItem;
    mniPopDelete: TMenuItem;
    mniPopTestExpressions: TMenuItem;
    Help1: TMenuItem;
    mniValidVars: TMenuItem;
    lstExpressions: TListBox;
    Expressions: TExpressions;
    ExpressionsTemplatesGroups: TExpressions;
    ExprDialogListsGroups: TExprDialogLists;
    ExpressionBuilder: TExpressionBuilder;
    Panel1: TPanel;
    Panel2: TPanel;
    btnGlobal: TButton;
    btnLocal: TButton;
    btnCancel: TButton;
    Panel3: TPanel;
    btnUp: TButton;
    lstExpressionsGlobal: TListBox;
    Panel4: TPanel;
    ActionList1: TActionList;
    actUp: TAction;
    actDown: TAction;
    Panel5: TPanel;
    btnDown: TButton;
    actUseGlobal: TAction;
    actUseLocal: TAction;
    ExpressionsGlobal: TExpressions;
    Global1: TMenuItem;
    mniNewGlobal: TMenuItem;
    mniChangeGlobal: TMenuItem;
    mniDeleteGlobal: TMenuItem;
    mniTestExpressionGlobal: TMenuItem;
    pmuExpressionsGlobal: TPopupMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    ExpressionsTemplatesPlanets: TExpressions;
    ExprDialogListsPlanets: TExprDialogLists;
    Splitter1: TSplitter;
    mniPopCopy: TMenuItem;
    Copy1: TMenuItem;
    procedure mniNewClick(Sender: TObject);
    procedure mniEditClick(Sender: TObject);
    procedure mnuLstExpressionsPopup(Sender: TObject);
    procedure mniDeleteClick(Sender: TObject);
    procedure mniChangeClick(Sender: TObject);
    procedure mniValidVarsClick(Sender: TObject);
    procedure mniPopTestExpressionsClick(Sender: TObject);
    procedure mniPopTestExpressionsPlanetsClick(Sender: TObject);
    procedure ExpressionBuilderTestButtonClick(Sender: TObject);
    procedure ExpressionBuilderTestButtonPlanetsClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure actUpUpdate(Sender: TObject);
    procedure actDownUpdate(Sender: TObject);
    procedure mniNewGlobalClick(Sender: TObject);
    procedure mniChangeGlobalClick(Sender: TObject);
    procedure mniDeleteGlobalClick(Sender: TObject);
    procedure mniTestExpressionGlobalClick(Sender: TObject);
    procedure mniTestExpressionsGlobalPlanetsClick(Sender: TObject);
    procedure btnGlobalClick(Sender: TObject);
    procedure btnLocalClick(Sender: TObject);
    procedure actUseGlobalUpdate(Sender: TObject);
    procedure actUseLocalUpdate(Sender: TObject);
    procedure actUpExecute(Sender: TObject);
    procedure actDownExecute(Sender: TObject);
    procedure mniPopCopyClick(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
  private
    FExpression: string;
    FExpressionFileName: string;
    FHelpString: string;
  protected
    procedure NewExpression;
    procedure NewExpressionGlobal;
    { Private declarations }
  public
    property Expression: string read FExpression write FExpression;
    property ExpressionFileName: string read FExpressionFileName write FExpressionFileName;
    procedure DoFilterGroups(const Allgroups, groups: TList);
    procedure DoFilterPlanets(const AllPlanets: TStrings; const planets: TList);
    procedure PrepareDialogForGroups;
    procedure PrepareDialogForPlanets;
    { Public declarations }
  end;

var
  frmSelectExpressions: TfrmSelectExpressions;

function GroupExpressionsExecute(const Allgroups, groups: Tlist; var expression: string): boolean;
function SelectGroupExpression(var Expression: string): boolean;
function PlanetExpressionsExecute(const Allplanets: TStrings;const planets: Tlist): boolean;
function SelectPlanetExpression(var Expression: string): boolean;

implementation

{$R *.DFM}

uses
  UfrmMain, MKstrUtils, UfrmExpressionFilters, UTypes, eval32,
  HyperStr, UFiles, stabUtil, xProcs, UAddTabs;

function GroupExpressionsExecute(const Allgroups, groups: Tlist; var expression: string): boolean;
begin
  Result := false;
  frmSelectExpressions.PrepareDialogForGroups;
  if frmSelectExpressions.ShowModal = mrOk then begin
    groups.Clear;
    frmSelectExpressions.DoFilterGroups(Allgroups, groups);
    expression := frmSelectExpressions.Expression;
    Result := true;
  end else
    expression := '';
end;

function SelectGroupExpression(var Expression: string): boolean;
begin
  Expression := '';
  frmSelectExpressions.PrepareDialogForGroups;
  if frmSelectExpressions.ShowModal = mrOk then
    Expression := frmSelectExpressions.Expression;
  Result := Expression <> '';
end;

function planetExpressionsExecute(const Allplanets: TStrings; const planets: Tlist): boolean;
var
  i: integer;
begin
  planets.Clear;
  frmSelectExpressions.PrepareDialogForPlanets;
  if frmSelectExpressions.ShowModal = mrOk then begin
    frmSelectExpressions.DoFilterplanets(Allplanets, planets);
  end else
    for i := 0 to Allplanets.Count -1 do begin
      planets.Add(AllPlanets.objects[i]);
    end;
  Result := true;
end;

function SelectPlanetExpression(var Expression: string): boolean;
begin
  Expression := '';
  frmSelectExpressions.PrepareDialogForPlanets;
  if frmSelectExpressions.ShowModal = mrOk then
    Expression := frmSelectExpressions.Expression;
  Result := Expression <> '';
end;

{ TfrmGroupsExpressions }

procedure TfrmSelectExpressions.DoFilterGroups(const Allgroups, groups: TList);
var
  strExpression: string;
  i: integer;
  tmpList: TList;
begin
  groups.Clear;
  strExpression := Expression;

  if strExpression = '' then begin
    for i := 0 to AllGroups.Count - 1 do
      groups.Add(AllGroups[i]);
  end else begin
    for i := 0 to AllGroups.Count - 1 do
      if DoExprGroup(strExpression, Allgroups[i]) <> 0 then
        groups.Add(AllGroups[i]);
    if gDoGroupInverse then begin
      tmpList := TList.Create;
      try
        for i := 0 to AllGroups.Count - 1 do
          if groups.IndexOf(AllGroups[i]) = -1 then
            tmpList.Add(AllGroups[i]);
        groups.Clear;
        groups.Capacity := tmpList.Count;
        groups.Count := tmpList.Count;
        move(tmpList.List^, groups.List^, tmpList.Count * sizeof(Pointer));
      finally
        tmpList.Free;
      end;
    end;
  end;
end;

procedure TfrmSelectExpressions.mniNewClick(Sender: TObject);
begin
  NewExpression;
end;

procedure TfrmSelectExpressions.NewExpression;
begin
  ExpressionBuilder.Expressions := Expressions;
  ExpressionBuilder.Execute(-1);
  Expressions.ExpressionList.FillTStringWithNames(lstExpressions.Items)
end;

procedure TfrmSelectExpressions.mniEditClick(Sender: TObject);
begin
  mniChange.Enabled := lstExpressions.ItemIndex <> -1;
  mniDelete.Enabled := lstExpressions.ItemIndex <> -1;
  mniTestExpression.Enabled := lstExpressions.ItemIndex <> -1;
end;

procedure TfrmSelectExpressions.mnuLstExpressionsPopup(Sender: TObject);
begin
  mniPopChange.Enabled := lstExpressions.ItemIndex <> -1;
  mniPopDelete.Enabled := lstExpressions.ItemIndex <> -1;
  mniPopCopy.Enabled := lstExpressions.ItemIndex <> -1;
  mniPopTestExpressions.Enabled := lstExpressions.ItemIndex <> -1;
end;

procedure TfrmSelectExpressions.mniDeleteClick(Sender: TObject);
var
  i: integer;
  strExpr: string;
begin
  i := lstExpressions.ItemIndex;
  if i <> -1 then begin
    strExpr := lstExpressions.Items[i];
    lstExpressions.Items.Delete(i);
    i := Expressions.ExpressionList.FindName(strExpr);
    if i <> -1 then
      Expressions.ExpressionList.Items[i].Free;
  end;
end;

procedure TfrmSelectExpressions.mniChangeClick(Sender: TObject);
var
  index: integer;
begin
  ExpressionBuilder.Expressions := Expressions;
  index := lstExpressions.ItemIndex;
  if index <> -1 then begin
    index := Expressions.ExpressionList.FindName(lstExpressions.Items[index]);
    ExpressionBuilder.Execute(index);
    Expressions.ExpressionList.FillTStringWithNames(lstExpressions.Items);
  end;
end;

procedure TfrmSelectExpressions.mniValidVarsClick(Sender: TObject);
begin
  ShowMessage(FHelpString);
end;

procedure TfrmSelectExpressions.mniPopTestExpressionsClick(
  Sender: TObject);
var
  tmpGR: TGroup;
  rcRes: TEvalValue;
  strExpression: string;
  i: integer;
begin
  if qreportPlayer.Groups.Count > 0 then
    tmpGR := qreportPlayer.Groups[0]
  else
    tmpGR := nil;
  i := lstExpressions.ItemIndex;
  if i = -1 then Exit;

  strExpression := lstExpressions.Items[i];
  strExpression := Expressions.findExpressionWithName(strExpression);
  if strExpression = '' then Exit;

  if Evaluate(@strExpression[1], @EvalGroupCallback, rcRes, tmpGR) = res_Error then begin
    ShowMessage(Format('Expression: %s results error', [strExpression]));
    exit;
  end;
  ShowMessage('Checked expressions seems ok');
end;

procedure TfrmSelectExpressions.ExpressionBuilderTestButtonClick(
  Sender: TObject);
var
  strExpr: string;
  tmpGR: TGroup;
  rcRes: TEvalValue;
begin
  if Assigned(Sender) then begin
    strExpr := TfrmExpressionBuilder(Sender).Expression;
    if qreportPlayer.Groups.Count > 0 then
      tmpGR := qreportPlayer.Groups[0]
    else
      tmpGR := nil;

    if Evaluate(@strExpr[1], @EvalGroupCallback, rcRes, tmpGR) = res_Error then begin
      ShowMessage(Format('Expression: %s results error', [strExpr]));
      exit;
    end;
    ShowMessage('Checked expressions seems ok');
  end;
end;

procedure TfrmSelectExpressions.ExpressionBuilderTestButtonPlanetsClick(
  Sender: TObject);
var
  strExpr: string;
  tmpPT: Tplanet;
  rcRes: TEvalValue;
begin
  if Assigned(Sender) then begin
    strExpr := TfrmExpressionBuilder(Sender).Expression;
    if planets.Count > 0 then
      tmpPT := TPlanet(planets.Objects[0])
    else
      tmpPT := nil;

    if Evaluate(@strExpr[1], @EvalplanetCallback, rcRes, tmpPT) = res_Error then begin
      ShowMessage(Format('Expression: %s results error', [strExpr]));
      exit;
    end;
    ShowMessage('Checked expression seems ok');
  end;
end;

procedure TfrmSelectExpressions.FormShow(Sender: TObject);
begin
  Expressions.CurrentExpression := '';
  Expressions.ExpressionList.Clear;
  ComponentFromFile(Expressions, FExpressionFileName + GetGameStr);
  Expressions.ExpressionList.FillTStringWithNames(lstExpressions.Items);
  if lstExpressions.Items.IndexOf(Expressions.CurrentExpression) <> -1 then
    lstExpressions.ItemIndex := lstExpressions.Items.IndexOf(Expressions.CurrentExpression);
  ExpressionsGlobal.CurrentExpression := '';
  ExpressionsGlobal.ExpressionList.Clear;
  ComponentFromFile(ExpressionsGlobal, FExpressionFileName + 'Global');
  ExpressionsGlobal.ExpressionList.FillTStringWithNames(lstExpressionsGlobal.Items);
  if lstExpressionsGlobal.Items.IndexOf(ExpressionsGlobal.CurrentExpression) <> -1 then
    lstExpressionsGlobal.ItemIndex := lstExpressionsGlobal.Items.IndexOf(ExpressionsGlobal.CurrentExpression);
end;

procedure TfrmSelectExpressions.FormHide(Sender: TObject);
begin
  if lstExpressions.ItemIndex <> -1 then
    Expressions.CurrentExpression := lstExpressions.Items[lstExpressions.ItemIndex]
  else
    Expressions.CurrentExpression := '';
  ComponentToFile(Expressions, FExpressionFileName + GetGameStr);
  if lstExpressionsGlobal.ItemIndex <> -1 then
    ExpressionsGlobal.CurrentExpression := lstExpressionsGlobal.Items[lstExpressionsGlobal.ItemIndex]
  else
    ExpressionsGlobal.CurrentExpression := '';
  ComponentToFile(ExpressionsGlobal, FExpressionFileName + 'Global');
end;

procedure TfrmSelectExpressions.actUpUpdate(Sender: TObject);
var
  index: integer;
  strExprName: string;
begin
  index := lstExpressionsGlobal.ItemIndex;
  if index <> -1 then
    strExprName := lstExpressionsGlobal.Items[index];
  TAction(Sender).Enabled := (Index <> -1) and (lstExpressions.Items.IndexOf(strExprName) = -1);
end;

procedure TfrmSelectExpressions.actDownUpdate(Sender: TObject);
var
  index: integer;
  strExprName: string;
begin
  index := lstExpressions.ItemIndex;
  if index <> -1 then
    strExprName := lstExpressions.Items[index];
  TAction(Sender).Enabled := (Index <> -1) and (lstExpressionsGlobal.Items.IndexOf(strExprName) = -1);
end;

procedure TfrmSelectExpressions.NewExpressionGlobal;
begin
  ExpressionBuilder.Expressions := ExpressionsGlobal;
  ExpressionBuilder.Execute(-1);
  ExpressionsGlobal.ExpressionList.FillTStringWithNames(lstExpressionsGlobal.Items)
end;

procedure TfrmSelectExpressions.mniNewGlobalClick(Sender: TObject);
begin
  NewExpressionGlobal;
end;

procedure TfrmSelectExpressions.mniChangeGlobalClick(Sender: TObject);
var
  index: integer;
begin
  ExpressionBuilder.Expressions := ExpressionsGlobal;
  index := lstExpressionsGlobal.ItemIndex;
  if index <> -1 then begin
    index := ExpressionsGlobal.ExpressionList.FindName(lstExpressionsGlobal.Items[index]);
    ExpressionBuilder.Execute(index);
    ExpressionsGlobal.ExpressionList.FillTStringWithNames(lstExpressionsGlobal.Items);
  end;
end;

procedure TfrmSelectExpressions.mniDeleteGlobalClick(Sender: TObject);
var
  i: integer;
  strExpr: string;
begin
  i := lstExpressionsGlobal.ItemIndex;
  if i <> -1 then begin
    strExpr := lstExpressionsGlobal.Items[i];
    lstExpressionsGlobal.Items.Delete(i);
    i := ExpressionsGlobal.ExpressionList.FindName(strExpr);
    if i <> -1 then
      ExpressionsGlobal.ExpressionList.Items[i].Free;
  end;
end;

procedure TfrmSelectExpressions.mniTestExpressionGlobalClick(
  Sender: TObject);
var
  tmpGR: TGroup;
  rcRes: TEvalValue;
  strExpression: string;
  i: integer;
begin
  if qreportPlayer.Groups.Count > 0 then
    tmpGR := qreportPlayer.Groups[0]
  else
    tmpGR := nil;
  i := lstExpressionsGlobal.ItemIndex;
  if i = -1 then Exit;

  strExpression := lstExpressionsGlobal.Items[i];
  strExpression := ExpressionsGlobal.findExpressionWithName(strExpression);
  if strExpression = '' then Exit;

  if Evaluate(@strExpression[1], @EvalGroupCallback, rcRes, tmpGR) = res_Error then begin
    ShowMessage(Format('Expression: %s results error', [strExpression]));
    exit;
  end;
  ShowMessage('Checked expressions seems ok');
end;

procedure TfrmSelectExpressions.btnGlobalClick(Sender: TObject);
var
  index: integer;
begin
  FExpression := '';
  index := lstExpressionsGlobal.ItemIndex;
  if index = -1 then Exit;
  FExpression := ExpressionsGlobal.findExpressionWithName(lstExpressionsGlobal.Items[index]);
end;

procedure TfrmSelectExpressions.btnLocalClick(Sender: TObject);
var
  index: integer;
begin
  FExpression := '';
  index := lstExpressions.ItemIndex;
  if index = -1 then Exit;
  FExpression := Expressions.findExpressionWithName(lstExpressions.Items[index]);
end;

procedure TfrmSelectExpressions.actUseGlobalUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := lstExpressionsGlobal.ItemIndex <> -1;
end;

procedure TfrmSelectExpressions.actUseLocalUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := lstExpressions.ItemIndex <> -1;
end;

procedure TfrmSelectExpressions.actUpExecute(Sender: TObject);
var
  index: integer;
  strExprName: string;
  strExpr: string;
begin
  index := lstExpressionsGlobal.ItemIndex;
  if index = -1 then exit;
  strExprName := lstExpressionsGlobal.Items[index];
  index := ExpressionsGlobal.ExpressionList.FindName(strExprName);
  if index <> -1 then begin
    strExpr := ExpressionsGlobal.ExpressionList[index].Expression;
    with Expressions.ExpressionList.Add do begin
      Expression := strExpr;
      ExpressionName := strExprName;
    end;
    ExpressionsGlobal.ExpressionList[index].Free;
  end;
  Expressions.ExpressionList.FillTStringWithNames(lstExpressions.Items);
  ExpressionsGlobal.ExpressionList.FillTStringWithNames(lstExpressionsGlobal.Items);
end;

procedure TfrmSelectExpressions.actDownExecute(Sender: TObject);
var
  index: integer;
  strExprName: string;
  strExpr: string;
begin
  index := lstExpressions.ItemIndex;
  if index = -1 then exit;
  strExprName := lstExpressions.Items[index];
  index := Expressions.ExpressionList.FindName(strExprName);
  if index <> -1 then begin
    strExpr := Expressions.ExpressionList[index].Expression;
    with ExpressionsGlobal.ExpressionList.Add do begin
      Expression := strExpr;
      ExpressionName := strExprName;
    end;
    Expressions.ExpressionList[index].Free;
  end;
  Expressions.ExpressionList.FillTStringWithNames(lstExpressions.Items);
  ExpressionsGlobal.ExpressionList.FillTStringWithNames(lstExpressionsGlobal.Items);
end;

procedure TfrmSelectExpressions.PrepareDialogForGroups;
begin
  FExpressionFileName := ExtractFilePath(ParamStr(0)) + 'Groups Expressions_';
  mniPopTestExpressions.OnClick := mniPopTestExpressionsClick;
  mniTestExpression.OnClick := mniPopTestExpressionsClick;
  mniTestExpressionGlobal.OnClick := mniTestExpressionGlobalClick;
  MenuItem4.OnClick := mniTestExpressionGlobalClick;
  ExpressionBuilder.ExpressionTemplates := ExpressionsTemplatesGroups;
  ExpressionBuilder.ExprDialogLists :=ExprDialogListsGroups;
  ExpressionBuilder.OnTestButtonClick := ExpressionBuilderTestButtonClick;
  FHelpString := SGROUPEXPR;
  Caption := 'Groups Expressions';
  gDoGroupInverse := false;
end;

procedure TfrmSelectExpressions.PrepareDialogForPlanets;
begin
  FExpressionFileName := ExtractFilePath(ParamStr(0)) + 'Planets Expressions_';
  mniPopTestExpressions.OnClick := mniPopTestExpressionsPlanetsClick;
  mniTestExpression.OnClick := mniPopTestExpressionsPlanetsClick;
  mniTestExpressionGlobal.OnClick := mniTestExpressionsGlobalPlanetsClick;
  MenuItem4.OnClick := mniTestExpressionsGlobalPlanetsClick;
  ExpressionBuilder.ExpressionTemplates := ExpressionsTemplatesPlanets;
  ExpressionBuilder.ExprDialogLists :=ExprDialogListsPlanets;
  ExpressionBuilder.OnTestButtonClick := ExpressionBuilderTestButtonPlanetsClick;
  FHelpString := SPLANETEXPR;
  Caption := 'Planets Expressions';
  gDoPlanetInverse := false;
end;

procedure TfrmSelectExpressions.DoFilterPlanets(const AllPlanets: TStrings;
  const planets: TList);
var
  strExpression: string;
  i: integer;
begin
  planets.Clear;
  strExpression := Expression;

  if strExpression = '' then begin
    for i := 0 to Allplanets.Count - 1 do
      planets.Add(Allplanets.Objects[i]);
  end else begin
    for i := 0 to Allplanets.Count - 1 do
      if DoExprplanet(strExpression, TPlanet(Allplanets.Objects[i])) <> 0 then
        planets.Add(Allplanets.Objects[i]);
  end;
end;

procedure TfrmSelectExpressions.mniPopTestExpressionsPlanetsClick(
  Sender: TObject);
var
  tmpPT: Tplanet;
  rcRes: TEvalValue;
  strExpression: string;
  i: integer;
begin
  if planets.Count > 0 then
    tmpPT := TPlanet(planets.Objects[0])
  else
    tmpPT := nil;
  i := lstExpressions.ItemIndex;
  if i = -1 then Exit;

  strExpression := lstExpressions.Items[i];
  strExpression := Expressions.findExpressionWithName(strExpression);
  if strExpression = '' then Exit;

  if Evaluate(@strExpression[1], @EvalplanetCallback, rcRes, tmpPT) = res_Error then begin
    ShowMessage(Format('Expression: %s results error', [strExpression]));
    exit;
  end;
  ShowMessage('Checked expression seems ok');
end;

procedure TfrmSelectExpressions.mniTestExpressionsGlobalPlanetsClick(
  Sender: TObject);
var
  tmpPT: Tplanet;
  rcRes: TEvalValue;
  strExpression: string;
  i: integer;
begin
  if planets.Count > 0 then
    tmpPT := TPlanet(planets.Objects[0])
  else
    tmpPT := nil;
  i := lstExpressionsGlobal.ItemIndex;
  if i = -1 then Exit;

  strExpression := lstExpressionsGlobal.Items[i];
  strExpression := ExpressionsGlobal.findExpressionWithName(strExpression);
  if strExpression = '' then Exit;

  if Evaluate(@strExpression[1], @EvalplanetCallback, rcRes, tmpPT) = res_Error then begin
    ShowMessage(Format('Expression: %s results error', [strExpression]));
    exit;
  end;
  ShowMessage('Checked expression seems ok');
end;

procedure TfrmSelectExpressions.mniPopCopyClick(Sender: TObject);
var
  index: integer;
  ExpressionItem: TExpressionItem;
begin
  index := Expressions.ExpressionList.FindName(lstExpressions.Items[lstExpressions.ItemIndex]);
  if index <> -1 then begin
    ExpressionItem := Expressions.ExpressionList.Add;
    ExpressionItem.Assign(Expressions.ExpressionList[index]);
    ExpressionBuilder.Expressions := Expressions;
    if ExpressionBuilder.Execute(ExpressionItem.Index) then begin
      Expressions.ExpressionList.FillTStringWithNames(lstExpressions.Items);
    end else begin
      ExpressionItem.Free;
    end;
  end;
end;

procedure TfrmSelectExpressions.Copy1Click(Sender: TObject);
var
  index: integer;
  ExpressionItem: TExpressionItem;
begin
  index := ExpressionsGlobal.ExpressionList.FindName(lstExpressionsGlobal.Items[lstExpressionsGlobal.ItemIndex]);
  if index <> -1 then begin
    ExpressionItem := ExpressionsGlobal.ExpressionList.Add;
    ExpressionItem.Assign(ExpressionsGlobal.ExpressionList[index]);
    ExpressionBuilder.Expressions := ExpressionsGlobal;
    if ExpressionBuilder.Execute(ExpressionItem.Index) then begin
      ExpressionsGlobal.ExpressionList.FillTStringWithNames(lstExpressionsGlobal.Items);
    end else begin
      ExpressionItem.Free;
    end;
  end;
end;

end.
