unit UfrmSetExtraInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, UTypes, OvcBase, OvcState;

type
  TfrmSetExtraInfo = class(TForm)
    Label1: TLabel;
    lblPlanetName: TLabel;
    Label2: TLabel;
    cbxPlayers: TComboBox;
    btnOK: TButton;
    btnCancel: TButton;
    btnDelete: TButton;
    OvcFormState1: TOvcFormState;
    procedure FormCreate(Sender: TObject);
    procedure cbxPlayersClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
  private
    FPlanet: TPlanet;
    FPlayer: TPlayer;
    function GetPlanetName: string;
    procedure SetPlanetName(const Value: string);
    procedure SetPlanet(const Value: TPlanet);
    procedure SetPlayer(const Value: TPlayer);
    { Private declarations }
  public
    property PlanetName: string read GetPlanetName write SetPlanetName;
    property Planet: TPlanet read FPlanet write SetPlanet;
    property Player: TPlayer read FPlayer write SetPlayer;
    { Public declarations }
  end;

var
  frmSetExtraInfo: TfrmSetExtraInfo;

implementation

uses
  UfrmMain;

{$R *.DFM}

procedure TfrmSetExtraInfo.FormCreate(Sender: TObject);
var
  i: integer;
  player: TPlayer;
  oldNames: string;
begin
  cbxPlayers.Items.BeginUpdate;
  cbxPlayers.Clear;
  try
    cbxPlayers.Items.AddObject('Unknown', TObject(1));
    for i := 0 to players.Count - 1 do
    begin
      player := TPlayer(players.Objects[i]);
      oldNames := '';
      if player.OldNames <> '' then
        oldNames := ' (' + player.OldNames + ')';
      if player.PopulationCur > 0 then
        cbxPlayers.Items.AddObject(player.Name + oldNames, player);
    end;
  finally
    cbxPlayers.Items.EndUpdate;
  end;
end;

function TfrmSetExtraInfo.GetPlanetName: string;
begin
  Result := lblplanetName.Caption;
end;

procedure TfrmSetExtraInfo.SetPlanet(const Value: TPlanet);
begin
  FPlanet := Value;
end;

procedure TfrmSetExtraInfo.SetPlanetName(const Value: string);
begin
  lblplanetName.Caption := Value;
end;

procedure TfrmSetExtraInfo.SetPlayer(const Value: TPlayer);
var
  i: integer;
begin
  for i := 0 to cbxPlayers.Items.Count - 1 do
    if cbxPlayers.Items.Objects[i] = value then
      cbxPlayers.ItemIndex := i;
  FPlayer := Value;
end;

procedure TfrmSetExtraInfo.cbxPlayersClick(Sender: TObject);
begin
  FPlayer := Tplayer(cbxPlayers.items.objects[cbxPlayers.ItemIndex]);
end;

procedure TfrmSetExtraInfo.btnDeleteClick(Sender: TObject);
begin
  FPlayer := nil;
end;

end.
