unit UfrmSetupOrders;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmSetupOrders = class(TForm)
    Label1: TLabel;
    edtFirstLine: TEdit;
    btnOK: TButton;
    btnCancel: TButton;
    cbxChangeRaceName: TCheckBox;
    Label2: TLabel;
    edtRaceName: TEdit;
    lblPasswordWarning: TLabel;
    procedure btnOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    FOrdersMemo: TStrings;
    function FindPassword(gameName: string): string;
    procedure SetOrdersMemo(const Value: TStrings);
    { Private declarations }
  public
    property OrdersMemo: TStrings read FOrdersMemo write SetOrdersMemo;
    { Public declarations }
  end;

var
  frmSetupOrders: TfrmSetupOrders;

implementation

{$R *.DFM}

uses
  xProcs, UFiles, UTypes, HyperStr;

{ TfrmSetupOrders }

procedure TfrmSetupOrders.SetOrdersMemo(const Value: TStrings);
begin
  FOrdersMemo := Value;
end;

procedure TfrmSetupOrders.btnOKClick(Sender: TObject);
begin
  if (FOrdersMemo.Count = 0) or Question('Are you sure you want to create a new setup for the orders?'#13 +
    'Old commands will be lost!') then
  begin
    FOrdersMemo.Clear;
    FOrdersMemo.Add(edtFirstLine.Text);
    if cbxChangeRacename.Checked then begin
      FOrdersMemo.Add('');
      FOrdersMemo.Add('C ' + edtRacename.Text);
    end;
    FOrdersMemo.Add('');
    FOrdersMemo.Add(';-MKGal Group Insertion start-');
    FOrdersMemo.Add(';-MKGal Group Insertion end-');
    FOrdersMemo.Add(';-MKGal Find Insertion start-');
    FOrdersMemo.Add(';-MKGal Find Insertion end-');
    FOrdersMemo.Add('#END');
    Close;
  end;
end;

procedure TfrmSetupOrders.FormShow(Sender: TObject);
var
  tmpPassword: string;
begin
  if (edtFirstLine.Text = '#') or (edtFirstLine.Text = '') then begin
    if inivars.Gametype = gtGalaxyNG then begin
      tmpPassword := FindPassword(strGameName);
      lblPasswordWarning.Visible := tmpPassword <> '';
      edtFirstLine.Text := '#GALAXY ' + strGameName + ' ' + qreportPlayer.Name + ' ' + tmpPassword;
    end else
      edtFirstLine.Text := '#GALAXY ' + strGameName + ' ' + qreportPlayer.Name;
  end;
  if edtRacename.Text = '' then begin
    edtRacename.Text := qreportPlayer.Name;
  end;
end;

function TfrmSetupOrders.FindPassword(gameName: string): string;
var
  report: TStringList;
  reportFile, strLine: string;
  i: integer;
  CharTable: string;
begin
  Result := '';
  CharTable := BuildTable(#$A0' ');
  report := TStringList.Create;
  try
    reportFile := format(strSpelD, [strSpelC[1], 0]);
    if FileExists(reportFile) then begin
      report.LoadFromFile(reportFile);
      for i := 0 to report.Count - 1 do begin
        if CompareText(report[i], 'First line of your orders should now be:') = 0 then
          if i < report.Count then begin
            strLine := report[i + 1];
            Result := Fetch(strLine, CharTable, 4, False); //copy(strLine, ScanB(strLine, ' ', -1), length(strLine));
            gameName := Fetch(strLine, CharTable, 2, False);
          end;
      end;
    end;
  finally
    report.Free;
  end;
end;

procedure TfrmSetupOrders.btnCancelClick(Sender: TObject);
begin
  Close;
end;

end.
