unit UfrmShipDesign;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, RXCtrls, UTypes, Buttons, RXSpin, Mask, ToolEdit,
  CurrEdit, RxCalc, OvcState, OvcBase;

type
  TfrmShipDesign = class(TForm)
    cbxPlayer: TComboBox;
    lbxShipTypes: TTextListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    edtDrive: TEdit;
    edtAttacks: TEdit;
    edtWeapons: TEdit;
    edtShields: TEdit;
    edtCargo: TEdit;
    Label7: TLabel;
    edtDriveTech: TEdit;
    edtWeaponsTech: TEdit;
    edtShieldsTech: TEdit;
    edtCargoTech: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    lblNormalDrive: TLabel;
    lblNormalWeapons: TLabel;
    lblNormalShield: TLabel;
    lblNormalCargo: TLabel;
    lblNormalMass: TLabel;
    lblLoadedDrive: TLabel;
    lblLoadedWeapons: TLabel;
    lblLoadedShield: TLabel;
    lblLoadedCargo: TLabel;
    lblLoadedMass: TLabel;
    btnAddToDefenders: TBitBtn;
    btnAddToAttackers: TBitBtn;
    edtDefendersCount: TRxSpinEdit;
    edtAttackersCount: TRxSpinEdit;
    RxSpinEdit1: TRxSpinEdit;
    Label10: TLabel;
    Label11: TLabel;
    btnStdShip: TButton;
    CheckBox1: TCheckBox;
    RxCalcEdit1: TComboEdit;
    OvcFormState1: TOvcFormState;
    OvcComponentState1: TOvcComponentState;
    btnClipboard: TButton;
    cbxCargoType: TComboBox;
    Label12: TLabel;
    lblNGBlindMass: TLabel;
    procedure edtDriveKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure edtDriveChange(Sender: TObject);
    procedure cbxPlayerChange(Sender: TObject);
    procedure lbxShipTypesClick(Sender: TObject);
    procedure btnAddToDefendersClick(Sender: TObject);
    procedure btnAddToAttackersClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnClipboardClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnStdShipClick(Sender: TObject);
    procedure RxCalcEdit1Change(Sender: TObject);
    procedure RxCalcEdit1ButtonClick(Sender: TObject);
    procedure cbxCargoTypeClick(Sender: TObject);
  private
    FUpdating: integer;
    procedure CalculateShip;
    procedure FillcbxPlayer;
    procedure FilllbxShipTypes(player: TPlayer);
    procedure FillEditBoxes(player: TPlayer; ShipType: TShipType);
    { Private declarations }
  public
    FStdShipName,
      FStdShip: string;
    function GetUsedTurns: string;
    procedure SetUsedTurns(value: string);
    procedure CalculateStdShip;
    procedure SetBaseMassPlanet(planet: TPlanet);
    procedure SetbaseMass(mass: single);
    procedure RefreshShipTypes;
    { Public declarations }
  end;

var
  frmShipDesign: TfrmShipDesign;

implementation

uses UfrmBattleSimulator, clipbrd, UfrmStdShip, HyperStr, UfrmCalculate,
  UfrmOrders, UfrmMain, UFiles;

{$R *.DFM}

procedure TfrmShipDesign.SetBaseMassPlanet(planet: TPlanet);
begin
  if planet.PlayerCur <> qreportPlayer then exit;
  if CheckBox1.Checked and (frmShipDesign.WindowState <> wsMinimized) then
    RxCalcEdit1.Text := Format('%5.2f', [planet.EffMassProduceCur]);
end;

procedure TfrmShipDesign.CalculateStdShip;
var
  sngTotalMass, sngMassRest: single;
  sngDrive, sngDrivePrct, sngWeapons, sngShields, sngShieldPrct: single;
  intAttacks: integer;
  strName, strDrive, strAttacks, strWeapons, strShields: string;
begin
  if RxCalcEdit1.Text = '' then Exit;
  try
    sngTotalMass := trunc(StrToFloat(RxCalcEdit1.Text) * RxSpinEdit1.AsInteger);
  except
    exit;
  end;
  case frmStdShip.RadioGroup1.ItemIndex of
    0: begin sngDrivePrct := 2 / 3; strName := 'Q'; end;
    1: begin sngDrivePrct := 1 / 2; strName := 'A'; end;
    2: begin sngDrivePrct := 1 / 3; strName := 'D'; end;
    3: begin sngDrivePrct := 1 / 4; strName := 'S'; end;
    4: begin sngDrivePrct := 0; strName := 'F'; end;
  else
    begin sngDrivePrct := 0; strName := 'F'; end;
  end;
  sngMassRest := sngTotalMass - sngTotalMass * sngDrivePrct;
  sngDrive := sngTotalMass - sngMassRest;
  case frmStdShip.RadioGroup3.ItemIndex of
    0: sngShieldPrct := 5 / 6;
    1: sngShieldPrct := 4 / 5;
    2: sngShieldPrct := 3 / 4;
    3: sngShieldPrct := 2 / 3;
    4: sngShieldPrct := 1 / 2;
    5: sngShieldPrct := 1 / 3;
    6: sngShieldPrct := 1 / 4;
    7: sngShieldPrct := 1 / 5;
    8: sngShieldPrct := 1 / 6;
    9: sngShieldPrct := 1 / 7;
    10: sngShieldPrct := 1 / 8;
    11: sngShieldPrct := 0;
  else
    sngShieldPrct := 0;
  end;
  sngShields := sngMassRest * sngShieldPrct;
  sngMassRest := sngMassRest - sngShields;
  sngWeapons := 0.0;
  intAttacks := 0;
  case frmStdShip.RadioGroup2.ItemIndex of
    0: begin intAttacks := 1; strName := strName + 'M'; end;
    1: begin intAttacks := 5; strName := strName + 'S'; end;
    2: begin sngWeapons := 1; strName := strName + 'T'; end;
    3: begin sngWeapons := 4; strName := strName + 'Q'; end;
  end;
  case frmStdShip.RadioGroup3.ItemIndex of
    0: strName := strName + '56_';
    1: strName := strName + '45_';
    2: strName := strName + '34_';
    3: strName := strName + '23_';
    4: strName := strName + '12_';
    5: strName := strName + '13_';
    6: strName := strName + '14_';
    7: strName := strName + '15_';
    8: strName := strName + '16_';
    9: strName := strName + '17_';
    10: strName := strName + '18_';
    11: strName := strName + '00_';
  end;
  if intAttacks <> 0 then
  begin
    sngWeapons := sngMassRest / ((intAttacks + 1) div 2);
  end
  else
  begin
    intAttacks := trunc(sngMassRest / sngWeapons) * 2 - 1;
    if intAttacks < 1 then intAttacks := 1;
    sngWeapons := sngMassRest / trunc(((intAttacks + 1) div 2));
  end;
  if sngDrive > 0 then
  begin
    strDrive := format('%4.2f', [sngDrive]);
    sngDrive := StrToFloat(strDrive);
  end
  else
    strDrive := '0';
  edtDrive.Text := strDrive;
  strAttacks := IntToStr(intAttacks);
  edtAttacks.Text := strAttacks;
  strWeapons := format('%4.2f', [sngWeapons]);
  sngWeapons := StrToFloat(strWeapons);
  edtWeapons.Text := strWeapons;
  sngShields := sngTotalMass - sngDrive - ((intAttacks + 1) div 2) * sngWeapons;
  strShields := format('%4.2f', [sngShields]);
  sngShields := StrToFloat(strShields);
  edtShields.Text := strShields;
  edtCargo.Text := '0';
  sngTotalMass := sngDrive + ((intAttacks + 1) div 2) * sngWeapons + sngShields;
  strName := Format('%s%4.0f', [strName, sngTotalMass]);
  ReplaceC(strName, '.', '_');
  SetLength(strName, DeleteC(strName, ' ')); ; // delete blanks
  FStdShipName := strName;
  frmStdShip.Caption := 'Standard Ship (' + strName + ')';
  FStdShip := 'D ' + strName + ' ' + strDrive + ' ' + strAttacks + ' ' + strWeapons +
    ' ' + strShields + ' 0 ; ' + RxSpinEdit1.Text + ' turns to build';
end;

procedure TfrmShipDesign.edtDriveKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
    '0'..'9',
      #8, '.', ',': ;
  else
    Key := #0;
  end;
end;

procedure TfrmShipDesign.CalculateShip;
var
  drive, weapons, shield, cargo: single;
  driveTech, weaponsTech, shieldTech, cargoTech: single;
  attacks: integer;
  st: TShipType;
  group: TGroup;
begin
  if FUpdating > 0 then Exit;
  try
    drive := StrToFloat(edtDrive.Text);
    weapons := StrToFloat(edtWeapons.Text);
    shield := StrToFloat(edtShields.Text);
    cargo := StrToFloat(edtCargo.Text);
    driveTech := StrToFloat(edtDriveTech.Text);
    weaponsTech := StrToFloat(edtWeaponsTech.Text);
    shieldTech := StrToFloat(edtShieldsTech.Text);
    cargoTech := StrToFloat(edtCargoTech.Text);
    attacks := StrToInt(edtAttacks.Text);
    st := TShipType.Create;
    group := TGroup.Create;
    try
      st.Drive := drive;
      st.Attacks := attacks;
      st.Weapons := weapons;
      st.Shields := shield;
      st.Cargo := cargo;
      group._Type := st;
      group.DriveTech := driveTech;
      group.WeaponsTech := weaponsTech;
      group.ShieldsTech := shieldTech;
      group.CargoTech := cargoTech;
      group.Lading := 0;
      lblNormalDrive.Caption := Format('%5.2f', [group.EffSpeed]);
      lblNormalWeapons.Caption := Format('%5.2f', [group.EffWeapon]);
      lblNormalShield.Caption := Format('%5.2f', [group.EffShield]);
      lblNormalCargo.Caption := Format('%5.2f', [st.Cargo]);
      lblNormalMass.Caption := Format('%5.2f', [st.Mass]);
      group.Lading := group.EffCargo;
      lblLoadedDrive.Caption := Format('%5.2f', [group.EffSpeedLoaded]);
      lblLoadedWeapons.Caption := Format('%5.2f', [group.EffWeapon]);
      lblLoadedShield.Caption := Format('%5.2f', [group.EffShieldLoaded]);
      lblLoadedCargo.Caption := Format('%5.2f', [group.EffCargo]);
      lblLoadedMass.Caption := Format('%5.2f', [st.Mass + group.EffCargo]);
    finally
      group.Free;
      st.Free;
    end;
  except
    ;
  end;
end;

procedure TfrmShipDesign.FilllbxShipTypes(player: TPlayer);
var
  i, intBool: integer;
begin
  lbxShipTypes.Items.beginupdate;
  OvcComponentState1.Storage.Open;
  try
    lbxShipTypes.Items.Clear;
    for i := 0 to player.ShipTypes.Count - 1 do begin
      lbxShipTypes.Items.AddObject(TShipType(player.ShipTypes.objects[i]).Name,
        player.ShipTypes.objects[i]);
      if qreportPlayer = player then begin
        intBool := OvcComponentState1.Storage.ReadInteger('TfrmShipDesign', 'Shiptype_' + TShipType(player.ShipTypes.objects[i]).Name, 0);
        TShipType(player.ShipTypes.objects[i]).CargoTypes := TCargoTypes(intBool);
      end;
    end;
    cbxCargoType.Enabled := qreportPlayer = player;
  finally
    OvcComponentState1.Storage.Close;
    lbxShipTypes.Items.EndUpdate;
  end;
end;

procedure TfrmShipDesign.FillEditBoxes(player: TPlayer; ShipType: TShipType);
begin
  edtDrive.Text := Format('%5.2f', [ShipType.Drive]);
  edtAttacks.Text := Format('%3d', [ShipType.Attacks]);
  edtWeapons.Text := Format('%5.2f', [ShipType.Weapons]);
  edtShields.Text := Format('%5.2f', [ShipType.Shields]);
  edtCargo.Text := Format('%5.2f', [ShipType.Cargo]);
  cbxCargoType.ItemIndex := ord(ShipType.CargoTypes);
  edtDriveTech.Text := Format('%5.2f', [player.DriveCur]);
  edtWeaponsTech.Text := Format('%5.2f', [player.WeaponsCur]);
  edtShieldsTech.Text := Format('%5.2f', [player.ShieldCur]);
  edtCargoTech.Text := Format('%5.2f', [player.CargoCur]);
  lblNGBlindMass.Caption := Format('%5.2f', [ShipType.Mass]);
end;

procedure TfrmShipDesign.FillcbxPlayer;
var
  i: integer;
begin
  cbxPlayer.Clear;
  for i := 0 to players.Count - 1 do
    if TPlayer(players.Objects[i]).ShipTypes.Count > 0 then
      cbxPlayer.Items.AddObject(TPlayer(players.Objects[i]).Name, players.Objects[i]);
end;

procedure TfrmShipDesign.FormShow(Sender: TObject);
var
  playerIndex: integer;
begin
  lblNGBlindMass.Visible := inivars.GameType = gtGalaxyNGBlind;
  inc(FUpdating);
  try
    FillcbxPlayer;
    if cbxPlayer.Items.Count > 0 then
    begin
      playerIndex := cbxPlayer.Items.IndexOf(qreportPlayer.Name);
      if playerIndex < 0 then playerIndex := 0;
      cbxPlayer.ItemIndex := playerIndex;
      if cbxPlayer.Items.Count > 0 then begin
        FilllbxShipTypes(TPlayer(cbxPlayer.items.Objects[playerIndex]));
        lbxShipTypes.ItemIndex := 0;
        FillEditBoxes(TPlayer(cbxPlayer.items.Objects[playerIndex]),
          TShipType(lbxShipTypes.items.Objects[0]));
      end;
    end;
  finally
    dec(FUpdating);
  end;
  CalculateShip;
end;

procedure TfrmShipDesign.edtDriveChange(Sender: TObject);
begin
  CalculateShip;
end;

procedure TfrmShipDesign.cbxPlayerChange(Sender: TObject);
var
  playerIndex: integer;
begin
  inc(FUpdating);
  try
    playerIndex := cbxPlayer.ItemIndex;
    if playerIndex < 0 then playerIndex := 0;
    cbxPlayer.ItemIndex := playerIndex;
    if cbxPlayer.items.Count > 0 then begin
      FilllbxShipTypes(TPlayer(cbxPlayer.items.Objects[playerIndex]));
      lbxShipTypes.ItemIndex := 0;
      if cbxPlayer.Items.Count > 0 then
        FillEditBoxes(TPlayer(cbxPlayer.items.Objects[playerIndex]),
          TShipType(lbxShipTypes.items.Objects[0]));
    end;
  finally
    dec(FUpdating);
  end;
  CalculateShip;
end;

procedure TfrmShipDesign.lbxShipTypesClick(Sender: TObject);
var
  playerIndex,
    shipTypeIndex: integer;
begin
  inc(FUpdating);
  try
    playerIndex := cbxPlayer.ItemIndex;
    if playerIndex < 0 then playerIndex := 0;
    shipTypeIndex := lbxShipTypes.ItemIndex;
    if shipTypeIndex < 0 then lbxShipTypes.ItemIndex := 0;
    FillEditBoxes(TPlayer(cbxPlayer.items.Objects[playerIndex]),
      TShipType(lbxShipTypes.items.Objects[shipTypeIndex]));
  finally
    dec(FUpdating);
  end;
  CalculateShip;
end;

procedure TfrmShipDesign.btnAddToDefendersClick(Sender: TObject);
var
  gr: TGroup;
  st: TShipType;
begin
  gr := TGroup.Create;
  st := TShipType.Create;
  gr._Type := st;
  if lbxShipTypes.itemindex <> -1 then
    st.Name := lbxShipTypes.Items[lbxShipTypes.itemindex]
  else
    st.Name := 'New Ship';
  st.Drive := StrToFloat(edtDrive.Text);
  st.Attacks := StrToInt(edtAttacks.Text);
  st.Weapons := StrToFloat(edtWeapons.Text);
  st.Shields := StrToFloat(edtShields.Text);
  st.Cargo := StrToFloat(edtCargo.Text);
  gr.DriveTech := StrToFloat(edtDriveTech.Text);
  gr.weaponsTech := StrToFloat(edtWeaponsTech.Text);
  gr.ShieldsTech := StrToFloat(edtShieldsTech.Text);
  gr.cargoTech := StrToFloat(edtCargoTech.Text);
  gr.Aantal := edtDefendersCount.AsInteger;
  gr.AantalBattle := edtDefendersCount.AsInteger;
  if cbxPlayer.ItemIndex = -1 then
    gr.player := nil
  else
    gr.Player := TPlayer(cbxPlayer.items.Objects[cbxPlayer.ItemIndex]);
  gr.Lading := 0;
  frmBattleSimulator.AddGroupToDefenders(gr);
  frmBattleSimulator.UpdateBattleSim;
end;

procedure TfrmShipDesign.btnAddToAttackersClick(Sender: TObject);
var
  gr: TGroup;
  st: TShipType;
begin
  gr := TGroup.Create;
  st := TShipType.Create;
  gr._Type := st;
  if lbxShipTypes.itemindex <> -1 then
    st.Name := lbxShipTypes.Items[lbxShipTypes.itemindex]
  else
    st.Name := 'New Ship';
  st.Drive := StrToFloat(edtDrive.Text);
  st.Attacks := StrToInt(edtAttacks.Text);
  st.Weapons := StrToFloat(edtWeapons.Text);
  st.Shields := StrToFloat(edtShields.Text);
  st.Cargo := StrToFloat(edtCargo.Text);
  gr.DriveTech := StrToFloat(edtDriveTech.Text);
  gr.weaponsTech := StrToFloat(edtWeaponsTech.Text);
  gr.shieldsTech := StrToFloat(edtShieldsTech.Text);
  gr.cargoTech := StrToFloat(edtCargoTech.Text);
  gr.Aantal := edtAttackersCount.AsInteger;
  gr.AantalBattle := edtAttackersCount.AsInteger;
  if cbxPlayer.ItemIndex = -1 then
    gr.player := nil
  else
    gr.Player := TPlayer(cbxPlayer.items.Objects[cbxPlayer.ItemIndex]);
  gr.Lading := 0;
  frmBattleSimulator.AddGroupToAttackers(gr);
  frmBattleSimulator.UpdateBattleSim
end;

procedure TfrmShipDesign.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  WindowState := wsMinimized;
  CanClose := false;
end;

procedure TfrmShipDesign.btnClipboardClick(Sender: TObject);
var
  strShiptypeName: string;
  strCommand: string;
begin
  if InputQuery('Shiptype', 'Enter Name:', strShiptypeName) then
  begin
    strCommand := 'D ' + trim(strShiptypeName) + ' ' +
      trim(edtDrive.Text) + ' ' + trim(edtAttacks.Text) + ' ' +
      trim(edtWeapons.Text) + ' ' + trim(edtShields.Text) + ' ' +
      trim(edtCargo.Text);
    frmOrders.InsertOtherCommand(strCommand);
  end;
end;

procedure TfrmShipDesign.FormCreate(Sender: TObject);
begin
  frmStdShip := TfrmStdShip.Create(nil);
end;

procedure TfrmShipDesign.FormDestroy(Sender: TObject);
begin
  frmStdShip.free;
end;

procedure TfrmShipDesign.btnStdShipClick(Sender: TObject);
begin
  frmStdShip.Show;
  ShowWindow(frmStdShip.Handle, SW_RESTORE);
  CalculateStdShip;
end;

procedure TfrmShipDesign.RxCalcEdit1Change(Sender: TObject);
begin
  if frmShipDesign.WindowState <> wsMinimized then begin
    if frmStdShip.Visible then
      frmStdShip.BringToFront
    else
      frmStdShip.Show;
    ShowWindow(frmStdShip.Handle, SW_RESTORE);
    CalculateStdShip;
    TWinControl(Sender).SetFocus;
  end;
end;

procedure TfrmShipDesign.RxCalcEdit1ButtonClick(Sender: TObject);
begin
  frmCalculate := TfrmCalculate.Create(nil);
  try
    try
      frmCalculate.Value := StrToFloat(RxCalcEdit1.Text);
    except
      frmCalculate.Value := 0;
    end;
    if frmCalculate.ShowModal = mrOK then
      RxCalcEdit1.Text := Format('%5.0f', [frmCalculate.Value]);
  finally
    frmCalculate.free;
  end;
end;

function TfrmShipDesign.GetUsedTurns: string;
begin
  Result := RxSpinEdit1.Text;
end;

procedure TfrmShipDesign.SetBaseMass(mass: single);
begin
  RxCalcEdit1.Text := Format('%5.2f', [mass]);
end;

procedure TfrmShipDesign.SetUsedTurns(value: string);
begin
  RxSpinEdit1.Text := Value;
end;

procedure TfrmShipDesign.cbxCargoTypeClick(Sender: TObject);
var
  shipTypeIndex: integer;
  shipType: TshipType;
begin
  shipTypeIndex := lbxShipTypes.ItemIndex;
  if shipTypeIndex < 0 then Exit;

  shipType := TShipType(lbxShipTypes.items.Objects[shipTypeIndex]);
  ShipType.CargoTypes := TCargoTypes(cbxCargoType.ItemIndex);
  OvcComponentState1.Storage.Open;
  OvcComponentState1.Storage.WriteInteger('TfrmShipDesign', 'Shiptype_' + shipType.Name, ord(ShipType.CargoTypes));
  OvcComponentState1.Storage.Close;
end;

procedure TfrmShipDesign.RefreshShipTypes;
begin
  FormShow(nil);
//  cbxPlayerChange(nil);
end;

end.
