unit UfrmStdShip;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, OvcState, OvcBase, TopWnd, Menus, SysMenu;

type
  TfrmStdShip = class(TForm)
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    btnClose: TButton;
    btnClipboard: TButton;
    btnExtra: TButton;
    Memo1: TMemo;
    OvcFormState1: TOvcFormState;
    OvcComponentState1: TOvcComponentState;
    RadioGroup3: TRadioGroup;
    procedure RadioGroup1Click(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnClipboardClick(Sender: TObject);
    procedure btnExtraClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure SetWindow;
    function GetShieldsIndex: integer;
    function GetShieldsItems: TStrings;
    function GetSpeedIndex: integer;
    function GetSpeedItems: TStrings;
    function GetWeaponsIndex: integer;
    function GetWeaponsItems: TStrings;
    procedure SetShieldsIndex(const Value: integer);
    procedure SetSpeedIndex(const Value: integer);
    procedure SetWeaponsIndex(const Value: integer);
    { Private declarations }
  public
    property SpeedIndex: integer read GetSpeedIndex write SetSpeedIndex;
    property WeaponsIndex: integer read GetWeaponsIndex write SetWeaponsIndex;
    property ShieldsIndex: integer read GetShieldsIndex write SetShieldsIndex;
    property SpeedItems: TStrings read GetSpeedItems;
    property WeaponsItems: TStrings read GetWeaponsItems;
    property ShieldsItems: TStrings read GetShieldsItems;
    { Public declarations }
  end;

var
  frmStdShip: TfrmStdShip;

implementation

uses clipbrd, UfrmShipDesign, UfrmOrders, UfrmMain;

{$R *.DFM}

procedure TfrmStdShip.SetWindow;
begin
  //172
  //306
  if Memo1.Visible then
  begin
    frmStdShip.Height := 420;
    btnExtra.Caption := '<<';
  end
  else
  begin
    frmStdShip.Height := 291;
    btnExtra.Caption := '>>';
  end;

end;

procedure TfrmStdShip.RadioGroup1Click(Sender: TObject);
begin
  frmShipDesign.CalculateStdShip;
end;

procedure TfrmStdShip.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmStdShip.btnClipboardClick(Sender: TObject);
begin
  frmShipDesign.CalculateStdShip;
  frmOrders.InsertOtherCommand(frmShipDesign.FStdShip);
end;

procedure TfrmStdShip.btnExtraClick(Sender: TObject);
begin
  Memo1.Visible := not Memo1.Visible;
  SetWindow;
end;

procedure TfrmStdShip.FormShow(Sender: TObject);
begin
  SetWindow;
  if Memo1.Lines.Count = 0 then begin
    Memo1.Lines.Add('D c4 18.57 0 0.00 0.00 6.18 ; small carrier (10)');
    Memo1.Lines.Add('D ac 71.98 0 0.00 0.00 27.02 ; big carrier (100)');
    Memo1.Lines.Add('D c1 1 0 0.00 0.00 1 ; very small carrier (1.1)');
    Memo1.Lines.Add('D drone 1 0 0 0 0');
    Memo1.Lines.Add('D dk 1 1 1 0 0');
  end;
end;

function TfrmStdShip.GetShieldsIndex: integer;
begin
  Result := RadioGroup3.ItemIndex;
end;

function TfrmStdShip.GetShieldsItems: TStrings;
begin
  Result := RadioGroup3.Items;
end;

function TfrmStdShip.GetSpeedIndex: integer;
begin
  Result := RadioGroup1.ItemIndex;
end;

function TfrmStdShip.GetSpeedItems: TStrings;
begin
  Result := RadioGroup1.Items;
end;

function TfrmStdShip.GetWeaponsIndex: integer;
begin
  Result := RadioGroup2.ItemIndex;
end;

function TfrmStdShip.GetWeaponsItems: TStrings;
begin
  Result := RadioGroup2.Items;
end;

procedure TfrmStdShip.SetShieldsIndex(const Value: integer);
begin
  RadioGroup3.ItemIndex := Value;
end;

procedure TfrmStdShip.SetSpeedIndex(const Value: integer);
begin
  RadioGroup1.ItemIndex := Value;
end;

procedure TfrmStdShip.SetWeaponsIndex(const Value: integer);
begin
  RadioGroup2.ItemIndex := Value;
end;

end.
